/*
 * AppletManager.java
 *
 * Created on 11 aot 2005, 10:41
 * Cette classe permet de grer les donnes d'une applet pour les restituer dans une autre.
 * Sauvegarde d'abord les calculs ou foncions nomms z1, z2, ..., z10 (s'ils existent)
 * en sauvegardant la chane de calcul qui les dfinit et la chaine reprsentant la
 * variable formelle (vide dans le cas d'un calcul).
 * Elle sauvegarde aussi les calculs nomms res1, res2, ..., res10.
 * Pour cela chaque applet MathGraph32 poss?dera un paramtre nomm Action du type String.
 * Si celui-ci contient "Sauvegarde", lors du positionnement de la figure, les valeurs
 * prcdemment cites seront enregistres dans le tableau valeurs et s'il contient
 * "Restitution", elles seront restitues aux variables var1, var2, var3, ..., var10.
 */

/**
 *
 * @author Yves
 */
package Applet;

import objets.*;
import types.*;

public class AppletManager extends Object
{
	static String[] chaineZ = new String[10];
  static String[] varForZ = new String[10];
	static double[] doubleRes = new double[10];
  static int nombreZ; // Le nombre de calculs ou fonctions stock?s
  static int nombreRes; // Le nombre de r?sultats num?riques stock?s

	// Ajouter une applet ? la liste
	public void sauveValeurs(AppletMathGraph32 applet)
	{
    nombreZ = 0;
    nombreRes = 0;
    for (int i = 1; i <= 10; i++) {
      CCalcul pt = applet.listePr.pointeurCalculOuFonction("z"+Integer.toString(i),-1);
      if (pt != null) {
        nombreZ++;
        chaineZ[i-1] = pt.chaineCalcul;
        if (pt.getClass() == CFonc.class) varForZ[i-1] = ((CFonc)pt).chaineVariable;
        else varForZ[i-1] ="";
      }
    }
    for (int i = 1; i <= 10; i++) {
      CCalcul pt = applet.listePr.pointeurCalculOuFonction("res"+Integer.toString(i),-1);
      if (pt != null) {
        if (pt.getClass() == CCalcul.class) {
          nombreRes++;
          doubleRes[i-1] = pt.resultat;
        }
      }
    }
	}
	// Supprimer une applet de la liste
	public void restitueValeurs(AppletMathGraph32 applet)
	{
    CCalcul ptc;
    Int inderr = new Int();
    CListeObjets liste = applet.listePr;
    for (int i = 1; (i <= 10) && (i<=nombreZ); i++) {
      ptc = liste.pointeurCalculOuFonction("z"+Integer.toString(i), -1);
      if (ptc != null) {
        if (CCalculBase.verifieSyntaxe(liste, chaineZ[i-1], inderr, liste.indexOf(ptc)-1,varForZ[i-1])){
              applet.donneValeurA("z"+Integer.toString(i), chaineZ[i-1], varForZ[i-1]);
        }
      }
    }
	  for (int i = 1; (i <= 10) && (i<= nombreRes); i++) {
      ptc = liste.pointeurCalculOuFonction("res"+Integer.toString(i), -1);
      if (ptc != null) {
        if (ptc.getClass() == CCalcul.class) {
          applet.donneValeurA("res"+Integer.toString(i), Double.toString(doubleRes[i-1]), "");          
        }
      }
    }
  }
}
