/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package Applet;

import javax.swing.*;
import outils.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

/**
 *
 * @author Yves
 * Type de bouton associ aux outils. Possde un pointeur sur l'outil associ
 * Descend de JToggleButton et non de JButton car c'est  moi de grer l'activation
 * ou non d'un bouton. Par exemple, si l'utilisateur clique sur un outilm qui ne peut pas tre
 * activ, il faut le dsactiver et activer l'outil de capture.
 * JToggleButton permet au bouton de changer son tat par SetSelected(boolean)
 *
 */
@SuppressWarnings("serial")
public class MtgButton extends JToggleButton implements MouseListener, ActionListener {
  public Outil outil;
  private AppletMathGraph32 applet;
  private static Insets insets = new Insets(0,0,0,0);
  
  /** Creates a new instance of JMtgButton */
  public MtgButton(AppletMathGraph32 appletInit, Icon icon, Outil outilInit) {
    super(icon);
    applet = appletInit;
    addMouseListener(this);
    addActionListener(this);
    setMargin(insets);
    outil = outilInit;
  }
  
  /**
   * Construction  partir d'un outil et d'une chane (pour le bouton
   * Solution)
   * @param texte
   * @param outilInit
   */
  public MtgButton(AppletMathGraph32 appletInit, String texte, Outil outilInit) {
  	super(texte);
  	applet = appletInit;
    addMouseListener(this);
    addActionListener(this);
    setMargin(insets);
    outil = outilInit;
  }

	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseEntered(MouseEvent e) {
    if (getCursor() != AppletMathGraph32.defaultCursor) setCursor(AppletMathGraph32.defaultCursor);		
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void actionPerformed(ActionEvent e) {
    if (outil.activationValide()) {
      applet.outilActif.deselect();
      applet.outilActif = outil;
      outil.select();
      requestFocus(); 
    }
    else {
      applet.dialogueAvertissement(AppletMathGraph32.getString("ch15"));
      outil.deselect();
       // On ractive l'outil de capture si l'outil ne peut pas tre activ
      applet.activeOutilCapture();
    }   
  }
 
  // Ajout version 4.7.0.1 pour que sous Mac on voie les icnes slectionnes
	@Override
	public void paint(Graphics arg0) {
		// TODO Auto-generated method stub
		super.paint(arg0);
		if (isSelected()) {
			Graphics2D pDC= (Graphics2D) arg0;
			pDC.setColor(Color.blue);
	    Composite originalComposite = pDC.getComposite();
	    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.2f));
	    pDC.fillRect(0, 0, getWidth(), getHeight());
	    pDC.setComposite(originalComposite);
		}
	}

}
