package Applet;

import java.util.StringTokenizer;

import objets.CLatex;
import objets.CValeurDynamique;

import org.scilab.forge.jlatexmath.dynamic.ExternalConverter;

/**
 * Classe servant au parser latex  remplacer les affichages dynamiques par leur valeur
 * Avant utilisation, setAssociation devra tre appel pour spcifier quelle est la liste active
 * et si mes tirages alatoires sont permis ou non
 * @author Yves
 *
 */
public class MtgConverter implements ExternalConverter {
	private CLatex latex;
	private boolean tirageAleatoiresPermis;
	
	public MtgConverter(CLatex latexAssocieInit) {
		latex = latexAssocieInit;
	}
	
	public void autoriseTiragesAleatoires(boolean infrand) {
		tirageAleatoiresPermis = infrand;
	}
	

	public String getLaTeXString(String ch) {
    int len = ch.length();
    StringBuffer bufferAffichage = new StringBuffer(len+128);
		
    // On retire les ventuels espaces de cete chaine
    int k;
    while((k = ch.indexOf(' ', 0)) != - 1)
    {
      ch = ch.substring(0, k) + ch.substring(k+1);
    }
    // On spare cette chaine avec les virgules
    StringTokenizer st = new StringTokenizer(ch, ",", false);
    if (st.hasMoreTokens()) {
      String nomvaleur = st.nextToken();
      // On recherche si c'est bien le nom d'une valeur valide
      // Il ne faut pas que la valeur ait t dfinie aprs l'affichage de valeur
      // Si c'est le nom d'une valeur utilise, elle est comprise dans la
      // liste listeValeursDynamiquesUtilisees
      int indfin = latex.listeValeursDynamiquesUtilisees.size() - 1;
      CValeurDynamique pValeur = latex.listeValeursDynamiquesUtilisees.pointeurValeurOuFonction(nomvaleur,indfin);
      if (pValeur != null) {
        // Si la valeur n'existe pas, on ne l'inclut pas dans la chane  afficher
        if (pValeur.existe) {
          String chnombre = new String("");
          if (st.hasMoreTokens())
          {
            String chnbdec = st.nextToken();
            if (chnbdec.compareTo("+") == 0) {
              chnombre = pValeur.rendChaineValeurPourCommentaire(2, tirageAleatoiresPermis);
              if (!chnombre.startsWith("-")) chnombre = "+ " + chnombre;
            }
            else {
              Integer nbdec = new Integer(chnbdec);
              int nbdecimales = nbdec.intValue();
              chnombre = pValeur.rendChaineValeurPourCommentaire(nbdecimales, tirageAleatoiresPermis);
              if (st.hasMoreTokens())
              {
                String chplus = st.nextToken();
                if (chplus.compareTo("+") == 0)
                {
                	if (!chnombre.startsWith("-")) chnombre = "+ " + chnombre;
                }
              }
            }
          }
          else
          {
            // Si le nombre de dcimales n'est pas prcis, on en met deux par dfaut
            chnombre = pValeur.rendChaineValeurPourCommentaire(2, tirageAleatoiresPermis);
          }
          bufferAffichage.append(chnombre);
        }
      }
    }
    if (bufferAffichage.length() != 0) return bufferAffichage.toString(); 
    else return "\\;"; // Un caractre blanc
	}

}
