/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dialogs;

import Applet.AppletMathGraph32;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;

import objets.CCalcul;
import objets.CCalculBase;

import types.ErreurCalculException;
import types.Int;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class CreerCalculDlg extends MtgDlg {
  
  private javax.swing.JButton btnCancel;
  private javax.swing.JButton btnOK;
  private JLabel label1;
  private JLabel label2;
  private javax.swing.JTextField editeurFormule;
  private javax.swing.JTextField editeurNom;
  private javax.swing.JButton btnListeValeurs;
  
  public CreerCalculDlg(AppletMathGraph32 appletInit) {
    super (null, textes.Chaines.ch22, true, appletInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);    
  }
  private void initComponents() {
    btnOK = new javax.swing.JButton(textes.Chaines.btnOK);
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new javax.swing.JButton(textes.Chaines.btnCancel);
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    btnListeValeurs = new javax.swing.JButton(textes.Chaines.listeValeurs);
    btnListeValeurs.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnListeValeursActionPerformed(evt);
      }
    });
    
    label1 = new JLabel(textes.Chaines.creerCalculDlg1, JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    label2 = new JLabel(textes.Chaines.creerCalculDlg2, JLabel.RIGHT);
    label2.setRequestFocusEnabled(false);
    editeurFormule = new javax.swing.JTextField(null, 40);
    editeurFormule.setAutoscrolls(true);
    editeurNom = new javax.swing.JTextField(null,8);
    JPanel panePrincipal = new JPanel();
    JPanel paneLeft = new JPanel();
    JPanel paneRight = new JPanel();
    panePrincipal.setLayout(new FlowLayout());
    paneLeft.setLayout(new GridBagLayout());
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(label1, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 60, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.bottom = 0;
    paneLeft.add(editeurNom, constraints);
    
    setConstraints(constraints, 0, 1, 1, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneLeft.add(label2, constraints);
   
    setConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(editeurFormule, constraints);
    
    constraints.insets.bottom = 5;
    setConstraints(constraints, 1, 2, 1, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneLeft.add(btnListeValeurs, constraints);
    
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    
    panePrincipal.add(paneLeft);
    panePrincipal.add(paneRight);
    setContentPane(panePrincipal);
    pack();
  }
  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {                                      
    String chNom = editeurNom.getText();
    // On regarde d'abord si le nom propos est correct et non vide
    if ((chNom.length() == 0) || !EditeurNomCalcul.validationNomVariableOuCalcul(chNom)) {
      applet.dialogueAvertissement(textes.Chaines.ch1);
      editeurNom.requestFocus();
      return;
    }
    if (chNom.compareTo("i") == 0) {
      applet.dialogueAvertissement(textes.Chaines.ch2);
      editeurNom.requestFocus();
      return;
    }
    if (applet.listePr.egalNomValeurOuFonctionOuMesure(chNom, applet.listeConstruction.size()-1)) {
      applet.dialogueAvertissement(textes.Chaines.ch3);
      editeurNom.requestFocus();
      return;
    }
    //Le nom est correct. On vrifie maintenant le calcul
    String chCalcul = editeurFormule.getText();
    Int indErr = new Int();
    // On n'autorise d'utiliser que les objets crs par l'utilisateur
    if (CCalculBase.verifieSyntaxe(applet.listeConstruction, chCalcul, indErr, 
        applet.listeConstruction.size()-1, "")) {
      CCalculBase calc = CCalculBase.creeCalculBase(chCalcul ,applet.listeConstruction, 0,
              chCalcul.length()-1, "");
      try {
        @SuppressWarnings("unused")
				double v = calc.resultat(false);
      }
      catch (ErreurCalculException e) {
        MtgDlg.dialogueAvertissement(textes.Chaines.ch4);
        editeurFormule.requestFocus();
        return;
      }
      CCalcul cal = new CCalcul(applet.listePr, null, false, chNom, chCalcul, calc);
      if (applet.ajouteElementAvecVerification(cal))
        applet.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil20);
      dispose();
    }
    else {
      MtgDlg.dialogueAvertissement(textes.Chaines.ch5);
      editeurFormule.requestFocus();
      return;     
    }
  }                                     

  private void btnListeValeursActionPerformed(java.awt.event.ActionEvent evt) {                                         
    int indmax = applet.listeConstruction.size() - 1;
    ListeValeursTextFieldDlg dlg = new ListeValeursTextFieldDlg(applet, editeurFormule, indmax);
    dlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
    dlg.setVisible(true);
    // TODO add your handling code here:
  }                                        

  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {                                          
    dispose();
  }         
}
