/*
 * EditeurAngle.java
 *
 * Created on 5 juillet 2006, 18:17
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package dialogs;
import javax.swing.*;
import javax.swing.text.JTextComponent;

import Applet.AppletMathGraph32;
import objets.*;
import types.ErreurCalculException;
import types.Int;
import types.UniteAngle;

/**
 *
 * @author Yves
 * ComboBox utilise pour proposer les valeurs d'angle standard.
 */
@SuppressWarnings("serial")
public final class EditeurAngle extends JComboBox {
  private CValeurAngle val; // L'objet CValeurAngle que ce combo doit modifier.
  private CElementBase objet; // L'objet qui contient val et qui doit tre modifi
  private int uniteAngle;
  
  /** Creates a new instance of EditeurAngle */
  public EditeurAngle(AppletMathGraph32 appletMereInit, 
      CValeurAngle valInit, CElementBase objetInit, int uniteAngleInit) {
    super();
  	JTextField editor = (JTextField) getEditor().getEditorComponent();
  	editor.setColumns(20);
    
  	val = valInit;
    objet = objetInit;
    uniteAngle = uniteAngleInit;
    setEditable(true);
    if (uniteAngle == UniteAngle.Radian) {
	    addItem("pi/2");
	    addItem("-pi/2");
	    addItem("pi/3");
	    addItem("-pi/3");
	    addItem("pi/6");
	    addItem("-pi/6");
	    addItem("+pi/4");
	    addItem("-pi/4");    	
    }
    else {
	    addItem("+90");
	    addItem("-90");
	    addItem("+60");
	    addItem("-60");
	    addItem("+30");
	    addItem("-30");
	    addItem("+45");
	    addItem("-45");
    }
  }
  /* Vrification de la validit de la rponse contenue dans le champ d'dition
   * du combo
  */
  public final boolean verifieValidite() {
    @SuppressWarnings("unused")
		double v;
    int indice;
    CListeObjets liste = objet.listeProprietaire;
    String rep = (String) getSelectedItem();
    if (rep == null) {
    	MtgDlg.dialogueAvertissement(textes.Chaines.ch97);
    	return false;
    }
    // Dans le cas ou on cre un nouvel objet, celui-ci n'a pas encore t ajout
    //  la liste des objets de l'applet.
    int indobj = liste.indexOf(objet);
    if (indobj == -1) indice = liste.size() - 1;
    else indice = indobj - 1;

    Int inderr = new Int();
    // On vrifie d'abord la syntaxe de la rponse
    // La seule valeur qu'on a le droit d'utiliser est pi qui est toujours
    // le premier objet de la liste
    if (CCalculBase.verifieSyntaxe(liste, rep, inderr, indice, "")){
    
      CCalculBase calc = CCalculBase.creeCalculBase(rep ,liste, 0, rep.length()-1, "");
      try {
        v = calc.resultat(false);
      }
      catch (ErreurCalculException e) {
        MtgDlg.dialogueAvertissement(textes.Chaines.ch44);
        requestFocus();
        return false;
      }
      val.donneCalcul(calc);
      return true;
    }
    else {
      // On place le curseur  l'endroit de l'erreur de syntaxe
    	JTextComponent editor = (JTextComponent) getEditor().getEditorComponent();
      editor.setSelectionStart(inderr.getValue());
      editor.setSelectionEnd(inderr.getValue());
      MtgDlg.dialogueAvertissement(textes.Chaines.ch5);
      requestFocus();
      return false;
    }
  }
}

