/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import Applet.AppletMathGraph32;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.net.URL;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import objets.CElementBase;
import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CTransformation;

import outils.OutilHistorique;

import types.NatureObjet;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class HistoriqueDlg extends MtgDlg {
  public int indiceObjetEnCours; // L'indice de l'objet qui est affich
  public int indiceReelObjetEnCours; // L'indice rel sasn tenir compte des
  // objets qui ne sont pas affichables ni des objets de type calcul.
  public static Insets insetsBoutons = new Insets(2,2,2,2);

  private javax.swing.JLabel label1;
  private javax.swing.JLabel label2;
  private javax.swing.JButton btnOK;
  private javax.swing.JButton buttonDebut;
  private javax.swing.JButton buttonFin;
  private javax.swing.JButton buttonPrec;
  private javax.swing.JButton buttonSuiv;
  private javax.swing.JButton buttonSupprimer;
  private javax.swing.JScrollPane scrollPane;
  private javax.swing.JPanel panePrincipal;
  private javax.swing.JPanel paneLeft;
  private javax.swing.JPanel paneFleches;
  
  private javax.swing.JTextArea textArea;
  private javax.swing.JTextField textField;
  public HistoriqueDlg(AppletMathGraph32 appletInit) {
    super (AppletMathGraph32.getString("ch16"), true, appletInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);    
    addWindowListener(new java.awt.event.WindowAdapter() {
        public void windowClosing(java.awt.event.WindowEvent evt) {
          fermeture();
        } 
    } );
  }
  private void initComponents() {
    btnOK = new javax.swing.JButton(AppletMathGraph32.getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });
    label1 = new JLabel(AppletMathGraph32.getString("historiqueDlg1"), JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    label2 = new JLabel(AppletMathGraph32.getString("historiqueDlg2"), JLabel.RIGHT);
    label2.setRequestFocusEnabled(false);
    scrollPane = new javax.swing.JScrollPane();
    textField = new javax.swing.JTextField();
    textArea = new javax.swing.JTextArea();
    URL adr = AppletMathGraph32.class.getResource("images/Precedent.gif");    
    buttonPrec = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("images/Suivant.gif");    
    buttonSuiv = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("images/Debut.gif");    
    buttonDebut = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("images/Fin.gif");    
    buttonFin = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("images/Delete24.png");    
    buttonSupprimer = new javax.swing.JButton(new ImageIcon(adr));
    
    textField.setEditable(false);
    textField.setColumns(4);
    textArea.setColumns(20);
    textArea.setEditable(false);
    textArea.setLineWrap(true);
    textArea.setRows(5);
    scrollPane.setViewportView(textArea);
    scrollPane.setPreferredSize(new Dimension(300, 90));
    
    setModal(true);
    setResizable(false);
    
    buttonPrec.setMargin(insetsBoutons);
    buttonPrec.setToolTipText(AppletMathGraph32.getString("tipPrecedent"));
    buttonPrec.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonPrecActionPerformed(evt);
      }
    });

    buttonSuiv.setMargin(insetsBoutons);
    buttonSuiv.setToolTipText(AppletMathGraph32.getString("tipSuivant"));
    buttonSuiv.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonSuivActionPerformed(evt);
      }
    });

    buttonDebut.setMargin(insetsBoutons);
    buttonDebut.setToolTipText(AppletMathGraph32.getString("tipDebut"));
    buttonDebut.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonDebutActionPerformed(evt);
      }
    });

    buttonFin.setMargin(insetsBoutons);
    buttonFin.setToolTipText(AppletMathGraph32.getString("tipFin"));
    buttonFin.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonFinActionPerformed(evt);
      }
    });

    buttonSupprimer.setMargin(insetsBoutons);
    buttonSupprimer.setToolTipText(AppletMathGraph32.getString("tipSuppressionObjet"));
    buttonSupprimer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonSupprimerActionPerformed(evt);
      }
    });
    
    panePrincipal = new JPanel();
    panePrincipal.setLayout(new BoxLayout(panePrincipal, BoxLayout.X_AXIS));
    paneLeft = new JPanel();
    panePrincipal.setLayout(new BoxLayout(panePrincipal, BoxLayout.X_AXIS));
    paneFleches = new JPanel();
    paneFleches.setLayout(new GridBagLayout());
    
    GridBagConstraints constraints = new GridBagConstraints();
    // constraints.insets.bottom = 5;
    // constraints.insets.top = 5;
    // constraints.insets.left = 5;
    // constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 50, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneFleches.add(buttonPrec, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    // constraints.insets.bottom = 0;
    paneFleches.add(buttonSuiv, constraints);
    
    constraints.insets.top = 5;
    constraints.insets.right = 5;
    setConstraints(constraints, 0, 1, 1, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneFleches.add(buttonDebut, constraints);
   
    constraints.insets.right = 0;
    constraints.insets.left = 5;
    setConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneFleches.add(buttonFin, constraints);
    
    constraints.insets.right = 0;
    constraints.insets.left = 0;
    setConstraints(constraints, 0, 2, 2, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.CENTER);
    paneFleches.add(buttonSupprimer, constraints);
    
    paneLeft.add(label1);
    paneLeft.add(textField);
    paneLeft.add(Box.createRigidArea(new Dimension(5,5)));
    paneLeft.add(label2);
    paneLeft.add(scrollPane);
    panePrincipal.add(paneLeft);
    panePrincipal.add(Box.createRigidArea(new Dimension(5,5)));
    panePrincipal.add(paneFleches);  
    panePrincipal.add(Box.createRigidArea(new Dimension(5,5)));
    panePrincipal.add(btnOK);
    setContentPane(panePrincipal);
    pack();
    
  }
  
  private void fermeture() {
    dispose();
    applet.outilHistorique.deselect();
    applet.historiqueEnCours = false;  
    applet.activeOutilCapture();
  }
  
  public void reset() {
    indiceObjetEnCours = 0;
    indiceReelObjetEnCours = 0;
    remplitChamps();
  }
 /**
 * Fonction remplissant le champ devant contenir le n de l'objet en cours
 * et le champ contenant le texte dcrivant l'objet en cours
 */  
private void remplitChamps() {
  CElementBase elb = elementEnCours();
  textField.setText(Integer.toString(indiceReelObjetEnCours + 1));
  String ch = elb.infoPourHistorique();
  if (!elb.existe) ch = ch + "\n" + AppletMathGraph32.getString("ch18");
  textArea.setText(ch);
  textArea.setCaretPosition(0);
  OutilHistorique oh = applet.outilHistorique;
  oh.annuleClignotement();
  if ((elb.getNature() & NatureObjet.NToutObjet) != 0) { 
    oh.ajouteClignotementDe((CElementGraphique)elb);
    elb.ajouteAntecedents(applet.listeClignotante);
    // Il faut positionner la liste clignotante car pour les translations
    // on lui a rajout des lments qui ne sont pas des objets suppmentaires
    // ne faisant pas partie de la figure
    applet.listeClignotante.positionne(applet.infRand, applet.dimf);
    oh.resetClignotement();
  }
}

private CElementBase elementEnCours() {
	CListeObjets liste = applet.listePourConstruction(); // Modifi version  4.6
  // return (CElementBase) (applet.listeConstruction.get(indiceObjetEnCours));
  return (CElementBase) (liste.get(indiceObjetEnCours));
}
   


  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {                                      
    fermeture();
  }                                     

  private void buttonSuivActionPerformed(java.awt.event.ActionEvent evt) {                                           
    // CListeObjets liste = applet.listeConstruction; Modifi version 4.6
  	CListeObjets liste = applet.listePourConstruction(); // Modifi version  4.6  	
    if (indiceObjetEnCours < liste.size() - 1) {
      indiceObjetEnCours ++;
      indiceReelObjetEnCours ++;
      CElementBase elb = elementEnCours();
      while (elb.estDeNature(NatureObjet.NTransformation | NatureObjet.NBipoint)) {
        indiceObjetEnCours ++;
        elb = elementEnCours();
      }
      applet.paneFigure.repaint();
      remplitChamps();
    }
}                                          

  private void buttonPrecActionPerformed(java.awt.event.ActionEvent evt) {                                           
    if (indiceObjetEnCours > 0) {
      indiceObjetEnCours --;
      indiceReelObjetEnCours --;
      CElementBase elb = elementEnCours();
      while (elb.estDeNature(NatureObjet.NTransformation | NatureObjet.NBipoint)) {
        indiceObjetEnCours --;
        elb = elementEnCours();
      }
      applet.paneFigure.repaint();
      remplitChamps();
    }
}                                          

  private void buttonDebutActionPerformed(java.awt.event.ActionEvent evt) {                                            
    reset();
    applet.paneFigure.repaint();    
}                                           

  private void buttonFinActionPerformed(java.awt.event.ActionEvent evt) {                                          
    // CListeObjets liste = applet.listeConstruction; Modifi version 4.6
  	CListeObjets liste = applet.listePourConstruction();
    indiceObjetEnCours = liste.size() - 1;
    indiceReelObjetEnCours = liste.nombreElementsPourHistorique(false) - 1;
    applet.paneFigure.repaint();
    remplitChamps();
}                                         
    
  private void buttonSupprimerActionPerformed(java.awt.event.ActionEvent evt) {                                                
    if (indiceObjetEnCours == 0) {
      applet.dialogueAvertissement(AppletMathGraph32.getString("ch24"));
      return;
    }
    CElementBase elb = elementEnCours();
    // Destruction de l'objet en cours
  	CListeObjets liste = applet.listePourConstruction(); // Modifi version 4.6
  	/* Modifi version 4.6
    if (liste.nombreDependants(elb) >= 2) {
      if (applet.dialogueConfirmation_YES_NO(AppletMathGraph32.getString("ch37"))) {
        applet.retireDependants(elb.antecedentDirect());
        applet.gestionnaire.enregistreFigureEnCours(AppletMathGraph32.getString("chaineOutil16"));
        fermeture();
      }      
    }
    else {
      applet.retireDependants(elb.antecedentDirect());
      applet.gestionnaire.enregistreFigureEnCours(AppletMathGraph32.getString("chaineOutil16"));
      fermeture();
    }
    */
    // Destruction de l'objet en cours
    CElementBase antecedentDirect = elb.antecedentDirect();
    if (antecedentDirect.getNature() == NatureObjet.NTransformation) {
    	// Si l'objet antcdent direct est une transformation, on regarde s'il y a d'autres images par
    	// cette transformation  dtruire. Si oui, on ne dtruit pas la transformation.
    	// Sinon on dtruit la transformation et ses dpendants.
    	// On peut avoir par exemple cr un point image d'un point par une transformation puis l'iamge de cette image
    	// Dans ce cas il ne faut pas dtruite la transformation
    	if (liste.nombreImagesParTransformationNonDepDe((CTransformation) antecedentDirect, elb) > 0) antecedentDirect = elb;
    }
    if (antecedentDirect.getNature() == NatureObjet.NBipoint)  {
      if (!applet.dialogueConfirmation_YES_NO(getString("ch38"))) {
      	return;
      }
    }
    
    // if (cadre.listePr.nombreDependants(elb) >= 2) {
    if (liste.nombreDependants(elb) >= 2) {
      if (applet.dialogueConfirmation_YES_NO(getString("ch37"))) {
      	if (antecedentDirect != elb) indiceObjetEnCours --;
        applet.retireDependants(antecedentDirect);
        applet.gestionnaire.enregistreFigureEnCours(getString("chaineOutil16"));
        if (indiceObjetEnCours >= liste.size()) {
          indiceObjetEnCours = liste.size() - 1;
          indiceReelObjetEnCours = liste.nombreElementsPourHistorique(false) - 1;
        }
        applet.paneFigure.effacegBuffer();
        applet.repaintFigureSansCalcul();
        remplitChamps();
      }      
    }
    else {
      applet.retireDependants(antecedentDirect);
      applet.gestionnaire.enregistreFigureEnCours(getString("chaineOutil16"));
      if (indiceObjetEnCours >= liste.size()) {
        indiceObjetEnCours = liste.size() - 1;
        indiceReelObjetEnCours = liste.nombreElementsPourHistorique(false) - 1;
      }
      applet.paneFigure.effacegBuffer();
      applet.repaintFigureSansCalcul();
      remplitChamps();
    }   
  }

}
