/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dialogs;

import Applet.AppletMathGraph32;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.net.URL;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import objets.CElementBase;
import objets.CElementGraphique;
import objets.CListeObjets;

import outils.OutilHistorique;

import types.NatureObjet;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class HistoriqueDlg extends MtgDlg {
  public int indiceObjetEnCours; // L'indice de l'objet qui est affich
  public int indiceReelObjetEnCours; // L'indice rel sasn tenir compte des
  // objets qui ne sont pas affichables ni des objets de type calcul.
  public static Insets insetsBoutons = new Insets(2,2,2,2);

  private javax.swing.JLabel label1;
  private javax.swing.JLabel label2;
  private javax.swing.JButton btnOK;
  private javax.swing.JButton buttonDebut;
  private javax.swing.JButton buttonFin;
  private javax.swing.JButton buttonPrec;
  private javax.swing.JButton buttonSuiv;
  private javax.swing.JButton buttonSupprimer;
  private javax.swing.JScrollPane scrollPane;
  private javax.swing.JPanel panePrincipal;
  private javax.swing.JPanel paneLeft;
  private javax.swing.JPanel paneFleches;
  
  private javax.swing.JTextArea textArea;
  private javax.swing.JTextField textField;
  public HistoriqueDlg(AppletMathGraph32 appletInit) {
    super (null, textes.Chaines.ch16, true, appletInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);    
    addWindowListener(new java.awt.event.WindowAdapter() {
        public void windowClosing(java.awt.event.WindowEvent evt) {
          fermeture();
        } 
    } );
  }
  private void initComponents() {
    btnOK = new javax.swing.JButton(textes.Chaines.btnOK);
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });
    label1 = new JLabel(textes.Chaines.historiqueDlg1, JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);
    label2 = new JLabel(textes.Chaines.historiqueDlg2, JLabel.RIGHT);
    label2.setRequestFocusEnabled(false);
    scrollPane = new javax.swing.JScrollPane();
    textField = new javax.swing.JTextField();
    textArea = new javax.swing.JTextArea();
    URL adr = AppletMathGraph32.class.getResource("Images/Precedent.gif");    
    buttonPrec = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("Images/Suivant.gif");    
    buttonSuiv = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("Images/Debut.gif");    
    buttonDebut = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("Images/Fin.gif");    
    buttonFin = new javax.swing.JButton(new ImageIcon(adr));
    adr = AppletMathGraph32.class.getResource("Images/Suppression.gif");    
    buttonSupprimer = new javax.swing.JButton(new ImageIcon(adr));
    
    textField.setEditable(false);
    textField.setColumns(4);
    textArea.setColumns(20);
    textArea.setEditable(false);
    textArea.setLineWrap(true);
    textArea.setRows(5);
    scrollPane.setViewportView(textArea);
    scrollPane.setPreferredSize(new Dimension(300, 90));
    
    setModal(true);
    setResizable(false);
    
    buttonPrec.setMargin(insetsBoutons);
    buttonPrec.setToolTipText(textes.Chaines.tipPrecedent);
    buttonPrec.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonPrecActionPerformed(evt);
      }
    });

    buttonSuiv.setMargin(insetsBoutons);
    buttonSuiv.setToolTipText(textes.Chaines.tipSuivant);
    buttonSuiv.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonSuivActionPerformed(evt);
      }
    });

    buttonDebut.setMargin(insetsBoutons);
    buttonDebut.setToolTipText(textes.Chaines.tipDebut);
    buttonDebut.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonDebutActionPerformed(evt);
      }
    });

    buttonFin.setMargin(insetsBoutons);
    buttonFin.setToolTipText(textes.Chaines.tipFin);
    buttonFin.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonFinActionPerformed(evt);
      }
    });

    buttonSupprimer.setMargin(insetsBoutons);
    buttonSupprimer.setToolTipText(textes.Chaines.tipSuppressionObjet);
    buttonSupprimer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        buttonSupprimerActionPerformed(evt);
      }
    });
    
    panePrincipal = new JPanel();
    panePrincipal.setLayout(new BoxLayout(panePrincipal, BoxLayout.X_AXIS));
    paneLeft = new JPanel();
    panePrincipal.setLayout(new BoxLayout(panePrincipal, BoxLayout.X_AXIS));
    paneFleches = new JPanel();
    paneFleches.setLayout(new GridBagLayout());
    
    GridBagConstraints constraints = new GridBagConstraints();
    // constraints.insets.bottom = 5;
    // constraints.insets.top = 5;
    // constraints.insets.left = 5;
    // constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 50, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneFleches.add(buttonPrec, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    // constraints.insets.bottom = 0;
    paneFleches.add(buttonSuiv, constraints);
    
    constraints.insets.top = 5;
    constraints.insets.right = 5;
    setConstraints(constraints, 0, 1, 1, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneFleches.add(buttonDebut, constraints);
   
    constraints.insets.right = 0;
    constraints.insets.left = 5;
    setConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneFleches.add(buttonFin, constraints);
    
    constraints.insets.right = 0;
    constraints.insets.left = 0;
    setConstraints(constraints, 0, 2, 2, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.CENTER);
    paneFleches.add(buttonSupprimer, constraints);
    
    paneLeft.add(label1);
    paneLeft.add(textField);
    paneLeft.add(Box.createRigidArea(new Dimension(5,5)));
    paneLeft.add(label2);
    paneLeft.add(scrollPane);
    panePrincipal.add(paneLeft);
    panePrincipal.add(Box.createRigidArea(new Dimension(5,5)));
    panePrincipal.add(paneFleches);  
    panePrincipal.add(Box.createRigidArea(new Dimension(5,5)));
    panePrincipal.add(btnOK);
    setContentPane(panePrincipal);
    pack();
    
  }
  
  private void fermeture() {
    dispose();
    applet.outilHistorique.deselect();
    applet.historiqueEnCours = false;  
    applet.activeOutilCapture();
  }
  
  public void reset() {
    indiceObjetEnCours = 0;
    indiceReelObjetEnCours = 0;
    remplitChamps();
  }
 /**
 * Fonction remplissant le champ devant contenir le n de l'objet en cours
 * et le champ contenant le texte dcrivant l'objet en cours
 */  
private void remplitChamps() {
  CElementBase elb = elementEnCours();
  textField.setText(Integer.toString(indiceReelObjetEnCours + 1));
  String ch = elb.infoPourHistorique();
  if (!elb.existe) ch = ch + "\n" + textes.Chaines.ch18;
  textArea.setText(ch);
  textArea.setCaretPosition(0);
  OutilHistorique oh = applet.outilHistorique;
  oh.annuleClignotement();
  if ((elb.getNature() & NatureObjet.NToutObjet) != 0) { 
    oh.ajouteClignotementDe((CElementGraphique)elb);
    elb.ajouteAntecedents(applet.listeClignotante);
    // Il faut positionner la liste clignotante car pour les translations
    // on lui a rajout des lments qui ne sont pas des objets suppmentaires
    // ne faisant pas partie de la figure
    applet.listeClignotante.positionne(applet.infRand, applet.dimf);
    oh.resetClignotement();
  }
}

private CElementBase elementEnCours() {
  return (CElementBase) (applet.listeConstruction.get(indiceObjetEnCours));
}
   


  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {                                      
    fermeture();
  }                                     

  private void buttonSuivActionPerformed(java.awt.event.ActionEvent evt) {                                           
    CListeObjets liste = applet.listeConstruction;
    if (indiceObjetEnCours < liste.size() - 1) {
      indiceObjetEnCours ++;
      indiceReelObjetEnCours ++;
      CElementBase elb = elementEnCours();
      long nat = elb.getNature();
      if ((nat & (NatureObjet.NTransformation | NatureObjet.NBipoint)) != 0) {
        indiceObjetEnCours ++;
      }
      applet.paneFigure.repaint();
      remplitChamps();
    }
}                                          

  private void buttonPrecActionPerformed(java.awt.event.ActionEvent evt) {                                           
    if (indiceObjetEnCours > 0) {
      indiceObjetEnCours --;
      indiceReelObjetEnCours --;
      CElementBase elb = elementEnCours();
      long nat = elb.getNature();
      if ((nat & (NatureObjet.NTransformation | NatureObjet.NBipoint)) != 0) {
        indiceObjetEnCours --;
      }
      applet.paneFigure.repaint();
      remplitChamps();
    }
}                                          

  private void buttonDebutActionPerformed(java.awt.event.ActionEvent evt) {                                            
    reset();
    applet.paneFigure.repaint();    
}                                           

  private void buttonFinActionPerformed(java.awt.event.ActionEvent evt) {                                          
    CListeObjets liste = applet.listeConstruction;
    indiceObjetEnCours = liste.size() - 1;
    indiceReelObjetEnCours = liste.nombreElementsPourHistorique(false) - 1;
    applet.paneFigure.repaint();
    remplitChamps();
}                                         
    
  private void buttonSupprimerActionPerformed(java.awt.event.ActionEvent evt) {                                                
    if (indiceObjetEnCours == 0) {
      applet.dialogueAvertissement(textes.Chaines.ch24);
      return;
    }
    CElementBase elb = elementEnCours();
    // Destruction de l'objet en cours
    if (applet.listePr.nombreDependants(elb) >= 2) {
      if (applet.dialogueYesNo(textes.Chaines.ch23)) {
        applet.retireDependants(elb.antecedentDirect());
        applet.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil16);
        fermeture();
      }      
    }
    else {
      applet.retireDependants(elb.antecedentDirect());
      applet.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil16);
      fermeture();
    }
          
  }

}
