package dialogs;

import java.awt.Dimension;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;
import Applet.AppletMathGraph32;

@SuppressWarnings("serial")
public class PaneBoutonsListeValeursEtFonctionsTextField extends JPanel {
	private AppletMathGraph32 applet;
	private JTextField editeur; // l'diteur associ
	private boolean calculsReels; // True si l'diteur attend une valeur relle
	public JButton btnListeValeurs, btnListeFonctionsPredefinies; // public version 4.5.2
	private int indiceMaxi; // Indice de la dernire valeur qui peut figurer dans la liste des valeurs
	private boolean intermPermis; // True si la liste des vzleurs doit prsenter les valeurs intermdiaires
	
	
	/**
	 * Constructeur ajoutant un bouton Valeurs si bValeurs est true et un bouton fonctions prdfinies
	 * si bFonctions est true
	 * @param appletInit
	 * @param editeurInit
	 * @param calculsReelsInit
	 * @param indiceMaxiInit
	 * @param intermPermisInit
	 */
	public PaneBoutonsListeValeursEtFonctionsTextField(AppletMathGraph32 appletInit, JTextField editeurInit,
			boolean calculsReelsInit, int indiceMaxiInit, boolean intermPermisInit, boolean bValeurs, boolean bFonctions) {
		super();
		applet = appletInit;
		editeur = editeurInit;
		calculsReels = calculsReelsInit;
		indiceMaxi = indiceMaxiInit;
		intermPermis = intermPermisInit;
    btnListeValeurs = new JButton(AppletMathGraph32.getString("listeValeurs"));
    btnListeValeurs.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnListeValeursActionPerformed();
      }
    });
    btnListeFonctionsPredefinies = new JButton(AppletMathGraph32.getString("listeFonctions"));
    btnListeFonctionsPredefinies.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnListeFonctionsPredefiniesActionPerformed();
      }
    });    
    if (bValeurs) {
    	add(btnListeValeurs);
    	add(Box.createRigidArea(new Dimension(6,0)));
    }
    if (bFonctions) add (btnListeFonctionsPredefinies);
	}
	
	
	private void btnListeValeursActionPerformed() {
		if (calculsReels) {
			ListeValeursOuFonctionsReellesTextFieldDlg dlg = 
				new ListeValeursOuFonctionsReellesTextFieldDlg(applet, editeur, indiceMaxi, intermPermis);
			dlg.setLocationRelativeTo(null);
			dlg.setVisible(true);
		}
		else {
			ListeValeursOuFonctionsReellesOuComplexesTextFieldDlg dlg = 
				new ListeValeursOuFonctionsReellesOuComplexesTextFieldDlg(applet, editeur, indiceMaxi, intermPermis);
			dlg.setLocationRelativeTo(null);
			dlg.setVisible(true);
		}
	}
	
	private void btnListeFonctionsPredefiniesActionPerformed() {
		ListeFonctionsPredefiniesDlg dlg = new ListeFonctionsPredefiniesDlg(applet, editeur, calculsReels);
		dlg.setLocationRelativeTo(null);
		dlg.setVisible(true);		
	}

	public void setEnabled(boolean bactivated) {
		btnListeValeurs.setEnabled(bactivated);
		btnListeFonctionsPredefinies.setEnabled(bactivated);
	}
}
