/*
 * CAppelFonction.java
 *
 * Created on 1 juillet 2004, 18:14
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CAppelFonction extends CCalculBase {
	CCalculAncetre fonctionAssociee;// Pointera uniquement sur une
																		// fonction ou une suite
	CCalculBase operande;

  /** Creates new CAppelFonction */
  public CAppelFonction() {
  }
  // Constructeur
  public CAppelFonction(CListeObjets liste, CCalculAncetre fonctionInit, CCalculBase operandeInit)
  {
    listeProprietaire = liste;
    fonctionAssociee = fonctionInit;
    operande = operandeInit;
  }  
  
  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CCalculBase cloneOperande = operande.getClone(listeSource, listeCible); 
    //  revoir car la fonction a dj t cre
    int ind1 = listeSource.indexOf(fonctionAssociee);    
    CCalculBase ptcalc = new CAppelFonction(listeCible, (CCalculAncetre)(listeCible.get(ind1, CCalculAncetre.class)),
      cloneOperande);
    return ptcalc;
  }
  
  public boolean existe() {
    return fonctionAssociee.existe && operande.existe();
  }
  public double resultat(boolean infoRandom) throws ErreurCalculException {
    return fonctionAssociee.rendValeurFonction(infoRandom, operande.resultat(infoRandom));
  }
  public double resultatFonction(boolean infoRandom, double valeurParametre) throws ErreurCalculException {
    return fonctionAssociee.rendValeurFonction
      (infoRandom, operande.resultatFonction(infoRandom, valeurParametre));
  }
  public boolean dependDe(CElementBase p) {
    return fonctionAssociee.dependDe(p) || operande.dependDe(p);
  }

  public boolean dependDePourBoucle(CElementBase p) {
    return fonctionAssociee.dependDePourBoucle(p) || operande.dependDePourBoucle(p);
  }
  
  public boolean  dependDeVariable() {
    return operande.dependDeVariable();
  }
  public CCalculBase getCopie() {
    return new CAppelFonction(listeProprietaire,fonctionAssociee, operande.getCopie());
  }
  
  @Override
	public String chaineCalcul(String varFor) {
  	String cha = operande.chaineCalculSansPar(varFor);
  	// ElimineParenthesesDebut(cha);
  	return fonctionAssociee.nom() + "(" + cha + ")";
	}
    
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    fonctionAssociee = (CCalculAncetre) (list.get(ind1,CCalculAncetre.class));
    operande = (CCalculBase) (inps.readCObject(list));
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    fonctionAssociee = (CCalculAncetre) (list.get(ind1,CCalculAncetre.class));
    operande = (CCalculBase) (inps.readObject(list));
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(fonctionAssociee);
    oups.writeInt(ind1);
    oups.writeObject(operande);
  }
  
  @Override
	public boolean estConstant() {
		return fonctionAssociee.estConstant() && operande.estConstant();
	}
  
}
