/*
 * CCalculBase.java
 *
 * Created on 1 juillet 2004, 17:14
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Attention :  la diffrence de la version C++, dans la version Java, chaque objet CCalculBase
// contient listePropritaire qui est un rfrence  la liste qui possde l'objet.
// Cela permet de connatre l'unit d'angle et la longueur unit dans Positionne() et
// rendValeur() et rendValeurFonction()
import java.io.*;
import java.awt.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;

public abstract class CCalculBase extends CObjetBase {

  /** Creates new CCalculBase */
  public CCalculBase() {
   }
  
  public CCalculBase(CListeObjets liste) {
    super(liste);
  }

  public static final int Nombre = 0;
  public static final int Addition = 1;
  public static final int Multiplication = 2;
  public static final int Puissance = 3;
  public static final int Fonction = 4;
  public static final int Valeur = 5;  
  public static final int ParOuvrante = 6;
  public static final int ParFermante = 7;
  public static final int Inferieur = 8;
  public static final int Inegalite = 9;
  public static final int Blanc = 10;
  // Rajou par rapprot  la version C++ 1.8
  public static final int Carre = 11;
  
  /**
   * Construction d'un calcul de type CCalculBase  partir d'une chane ch de
   * caractres en supposant la syntaxe correcte (procdure rcursive)
   * On cre en fait un arbre binaire de calcul
   * ptListe est la liste propritaire
   */
  public static CCalculBase creeCalculBase(String ch, CListeObjets ptListe,
    int pdebut, int pfin, String nomVariableFormelle)
  {
    int ptr;
    Point info = new Point(); // Contiendra dans x l'indice du caractre prcdent
    // et dans y l'oprateur trouv (correspond au ptPrecedent et operateurInegalite
    // de la version C++
    // int ptPrecedent;
    // int operateurInegalite;
    char car;
    byte op;
    Int nomF = new Int();
    int longNom;
    PointeurValDyn ptVa = new PointeurValDyn();
    Bool parametreTrouve = new Bool(true);

    // On limine les blancs de dbut
    car = ch.charAt(pdebut);
    while ((car == ' ') && (pdebut < pfin)) 
    {
      pdebut++;
      car = ch.charAt(pdebut);
    }

    // On recherche d'abord les oprateurs d'ingalits
    ptr = premiereInegalite(ch,pdebut,pfin,info);
    if (ptr != -1)
    {
        return new COperation(ptListe,creeCalculBase(ch,ptListe,pdebut,info.x,
            nomVariableFormelle),creeCalculBase(ch,ptListe,ptr+1,pfin,
            nomVariableFormelle),info.y);
    }
    else
    {
      // On recherche ensuite les operateurs d'addition ou soustraction
      ptr = premiereSomme(ch,pdebut,pfin);
      if (ptr != -1)
      {
        // On regarde d'abord si la chaine commence par un signe - ou
        // un signe +
        car = ch.charAt(ptr);
        if (car == '+') op = Operateur.Plus; else op = Operateur.Moin;
        if (ptr == pdebut)
        {
          car = ch.charAt(ptr);
          if (car == '+')
          {
            return creeCalculBase(ch,ptListe,pdebut+1,pfin,nomVariableFormelle);
          }
          else
          {
            return new COperation(ptListe, new CConstante(ptListe, 0),
                  creeCalculBase(ch,ptListe,pdebut+1,pfin,nomVariableFormelle),op);
          }
        }
        else
        {
          return new COperation(ptListe, creeCalculBase(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),creeCalculBase(ch,ptListe,ptr+1,pfin,
                nomVariableFormelle),op);
        }
      } // if (ptr != NULL)
      else
      {
        ptr = premierProduit(ch,pdebut,pfin);
        if (ptr != -1) 
        {
          car = ch.charAt(ptr);
          if (car == '*') op = Operateur.Mult; else op = Operateur.Divi;
          return new COperation(ptListe, creeCalculBase(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),creeCalculBase(ch,ptListe,ptr+1,pfin,
                nomVariableFormelle),op);
        }
        else
        // Le calcul ne contient ni addition, ni diffrence, ni produit
        // ni quotient}
        // Attention : par rapport  la version C++ 1.8, autorisation
        // du symbole  d'lvation au carr.
        {
          ptr = premierePuissance(ch,pdebut,pfin);
          if (ptr != -1)
          {
            if (ch.charAt(ptr) == '') {
              return new CPuissance(ptListe, creeCalculBase(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),new CConstante(ptListe, 2));
            }
            else return new CPuissance(ptListe, creeCalculBase(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),creeCalculBase(ch,ptListe,ptr+1,pfin,
                nomVariableFormelle));
          }
          else
          {
            // On regarde si la chaine commence par le nom d'une fonction
            // ou d'une valeur dj dfinie
            longNom = ptListe.commenceParNomFonctionOuValeurOuParametre
              (ch.substring(pdebut),nomVariableFormelle,ptVa,nomF,parametreTrouve,false);
            if (longNom > 0)
            {
              if (parametreTrouve.getValue())
              {
                return new CVariableFormelle();
              }
              else
              {
                if (ptVa.getPointeur() == null)
                {
                  return new CFonction(ptListe, nomF.getValue(),creeCalculBase(ch,ptListe,
                              pdebut+longNom,pfin,nomVariableFormelle));
                }
                else
                {
                  if (ptVa.getPointeur().estFonctionOuSuite())
                  {
                     return new CAppelFonction(ptListe, (CCalculAncetre) (ptVa.getPointeur()),
                          creeCalculBase(ch,ptListe,pdebut+longNom,pfin,
                          nomVariableFormelle));
                  }
                  else
                  {
                    return new CResultatValeur(ptListe, ptVa.getPointeur());
                 }
                }
              }
            }
            else
            {
              // Dans le cas o l'expression commence par une parenthse
              // ouvrante, elle finit par une fermante et il suffit 
              // d'valuer ce que la parenthse contient
              car = ch.charAt(pdebut);
              // Si le premier caractre est une parenthse ouvrante
              // il  faut faire attention car le dernier peut tre
              // un espace.
              // Cela a donn un bug dans la version 16 bits
              if (car == '(')
                return creeCalculBase(ch,ptListe,pdebut+1,
                  parentheseFermante(ch,pdebut)-1,nomVariableFormelle);
              else
              // Le rsultat ne peut tre que numrique}
              {
                String chaineNombre = new String();
                int ptch = pdebut;
                // car = ch.charAt(ptch); modifi par rapport au C++
                while ((FonteNom.chiffre(car) || (car == '.')) && (ptch <= pfin))
                {
                  car = ch.charAt(ptch);
                  chaineNombre = chaineNombre + car;
                  ptch++;
                }
                return new CConstante(ptListe, Double.parseDouble(chaineNombre));
              }
            }
          }
        }
      }
    }
  }
  
  /**
   * Construction d'un calcul de type CCalculBase  partir d'une chane ch de
   * caractres en supposant la syntaxe correcte (procdure rcursive)
   * On cre en fait un arbre binaire de calcul
   * ptListe est la liste propritaire
   */
  public static CCalculBase creeCalculBaseComplexe(String ch, CListeObjets ptListe,
    int pdebut, int pfin, String nomVariableFormelle)
  {
    int ptr;
    Point info = new Point(); // Contiendra dans x l'indice du caractre prcdent
    // et dans y l'oprateur trouv (correspond au ptPrecedent et operateurInegalite
    // de la version C++
    // int ptPrecedent;
    // int operateurInegalite;
    char car;
    byte op;
    Int nomF = new Int();
    int longNom;
    PointeurValDyn ptVa = new PointeurValDyn();
    Bool parametreTrouve = new Bool(true);
    Bool complexeiTrouve = new Bool(false);

    // On limine les blancs de dbut
    car = ch.charAt(pdebut);
    while ((car == ' ') && (pdebut < pfin)) 
    {
      pdebut++;
      car = ch.charAt(pdebut);
    }

    // On recherche d'abord les oprateurs d'ingalits
    ptr = premiereInegalite(ch,pdebut,pfin,info);
    if (ptr != -1)
    {
        return new COperation(ptListe,creeCalculBaseComplexe(ch,ptListe,pdebut,info.x,
            nomVariableFormelle),creeCalculBaseComplexe(ch,ptListe,ptr+1,pfin,
            nomVariableFormelle),info.y);
    }
    else
    {
      // On recherche ensuite les operateurs d'addition ou soustraction
      ptr = premiereSomme(ch,pdebut,pfin);
      if (ptr != -1)
      {
        // On regarde d'abord si la chaine commence par un signe - ou
        // un signe +
        car = ch.charAt(ptr);
        if (car == '+') op = Operateur.Plus; else op = Operateur.Moin;
        if (ptr == pdebut)
        {
          car = ch.charAt(ptr);
          if (car == '+')
          {
            return creeCalculBaseComplexe(ch,ptListe,pdebut+1,pfin,nomVariableFormelle);
          }
          else
          {
            return new COperation(ptListe, new CConstante(ptListe, 0),
            		creeCalculBaseComplexe(ch,ptListe,pdebut+1,pfin,nomVariableFormelle),op);
          }
        }
        else
        {
          return new COperation(ptListe, creeCalculBaseComplexe(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),creeCalculBaseComplexe(ch,ptListe,ptr+1,pfin,
                nomVariableFormelle),op);
        }
      } // if (ptr != NULL)
      else
      {
        ptr = premierProduit(ch,pdebut,pfin);
        if (ptr != -1) 
        {
          car = ch.charAt(ptr);
          if (car == '*') op = Operateur.Mult; else op = Operateur.Divi;
          return new COperation(ptListe, creeCalculBaseComplexe(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),creeCalculBaseComplexe(ch,ptListe,ptr+1,pfin,
                nomVariableFormelle),op);
        }
        else
        // Le calcul ne contient ni addition, ni diffrence, ni produit
        // ni quotient}
        // Attention : par rapport  la version C++ 1.8, autorisation
        // du symbole  d'lvation au carr.
        {
          ptr = premierePuissance(ch,pdebut,pfin);
          if (ptr != -1)
          {
            if (ch.charAt(ptr) == '') {
              return new CPuissance(ptListe, creeCalculBaseComplexe(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),new CConstante(ptListe, 2));
            }
            else return new CPuissance(ptListe, creeCalculBaseComplexe(ch,ptListe,pdebut,ptr-1,
                nomVariableFormelle),creeCalculBaseComplexe(ch,ptListe,ptr+1,pfin,
                nomVariableFormelle));
          }
          else
          {
            // On regarde si la chaine commence par le nom d'une fonction
            // ou d'une valeur dj dfinie
            longNom = ptListe.commenceParNomFonctionOuValeurOuParametreComplexe
              (ch.substring(pdebut),nomVariableFormelle,ptVa,nomF,parametreTrouve,complexeiTrouve,false);
            if (longNom > 0) {
            	if (complexeiTrouve.getValue()) {
            		return new CConstantei(ptListe);
            	}
            	else {
	              if (parametreTrouve.getValue())
	              {
	                return new CVariableFormelle();
	              }
	              else
	              {
	                if (ptVa.getPointeur() == null)
	                {
	                  return new CFonction(ptListe, nomF.getValue(),creeCalculBaseComplexe(ch,ptListe,
	                              pdebut+longNom,pfin,nomVariableFormelle));
	                }
	                else
	                {
	                  if (ptVa.getPointeur().estFonctionOuSuite())
	                  {
	                     return new CAppelFonctionComplexe(ptListe, (CCalculAncetre) (ptVa.getPointeur()),
	                    		 creeCalculBaseComplexe(ch,ptListe,pdebut+longNom,pfin,
	                          nomVariableFormelle));
	                  }
	                  else
	                  {
	                    return new CResultatValeurComplexe(ptListe, ptVa.getPointeur());
	                 }
	                }
	              }
            	}
            }
            else
            {
              // Dans le cas o l'expression commence par une parenthse
              // ouvrante, elle finit par une fermante et il suffit 
              // d'valuer ce que la parenthse contient
              car = ch.charAt(pdebut);
              // Si le premier caractre est une parenthse ouvrante
              // il  faut faire attention car le dernier peut tre
              // un espace.
              // Cela a donn un bug dans la version 16 bits
              if (car == '(')
                return creeCalculBaseComplexe(ch,ptListe,pdebut+1,
                  parentheseFermante(ch,pdebut)-1,nomVariableFormelle);
              else
              // Le rsultat ne peut tre que numrique}
              {
                String chaineNombre = new String();
                int ptch = pdebut;
                // car = ch.charAt(ptch); modifi par rapport au C++
                while ((FonteNom.chiffre(car) || (car == '.')) && (ptch <= pfin))
                {
                  car = ch.charAt(ptch);
                  chaineNombre = chaineNombre + car;
                  ptch++;
                }
                return new CConstante(ptListe, Double.parseDouble(chaineNombre));
              }
            }
          }
        }
      }
    }
  }  

  public static final boolean autorisationSyntaxe(int item,int itemSuivant)
  {
    switch (item)
    {
      case Nombre:
        switch (itemSuivant)
        {
          case Addition:
          case Multiplication:
          case Puissance:
          case Carre:
          case ParFermante:
          case Inegalite:
          case Blanc:
            return true;
          default: return false;
        }
      case Addition:
      case Multiplication:
        switch (itemSuivant)
        {
          case Nombre:
          case ParOuvrante:
          case Valeur:
          case Fonction:
          case Blanc:
            return true;
          default: return false;
        }
      case Puissance:
        switch (itemSuivant)
        {
          case Nombre:
          case Valeur:
          case ParOuvrante:
          case Fonction:
          case Blanc:
            return true;
          default: return false;
        }
      case Fonction:
        switch (itemSuivant)
        {
          case ParOuvrante:
          case Blanc:
            return true;
          default: return false;
        }
      case Valeur:
      case Carre:
        switch (itemSuivant)
        {
          case Addition:
          case Multiplication:
          case Puissance:
          case Carre:
          case ParFermante:
          case Inegalite:
          case Blanc:
            return true;
          default: return false;
        }
      case ParOuvrante:
        switch (itemSuivant)
        {
          case Addition:
          case ParOuvrante:
          case Nombre:
          case Valeur:
          case Fonction:
          case Blanc:
            return true;
          default: return false;
        }
      case ParFermante:
        switch (itemSuivant)
        {
          case ParFermante:
          case Addition:
          case Multiplication:
          case Puissance:
          case Carre:
          case Inegalite:
          case Blanc:
            return true;
          default: return false;
        }
      case Inegalite:
        switch (itemSuivant)
        {
          case Addition:
          case Nombre:
          case ParOuvrante:
          case Valeur:
          case Fonction:
          case Blanc:
            return true;
          default: return false;
        }
      default: return false; /// normalement inutile
    } // switch Item
  }
  
  abstract CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible);
    
  boolean existe() {
    return true;
  }
  
  /// resultat sera redfinie pour tous les descendants pouvant ne pas exister
  public double resultat(boolean infoRandom) throws ErreurCalculException {
    return 0;
  }
  // Ajout pour la version 2.0 calculs sur les complexes.
  // Le rsultat est renvoy dans z
  public void resultatComplexe(boolean infoRandom, Complexe zRes)  throws ErreurCalculException {
    /// Sera redfinie pour tous les descendants pouvant ne pas exister
    zRes.x = resultat(infoRandom);// Par dfaut on suppose le calcul rel
    zRes.y = 0;
  }
  /// Sera redfinie pour tous les descendants pouvant ne pas exister
  void  resultatFonctionComplexe(boolean infoRandom, Complexe valeurParametre, Complexe zRes)
    throws ErreurCalculException 
  {
    resultatComplexe(infoRandom, zRes);
  }
  
  public double resultatFonction(boolean infoRandom, double valeurparametre) throws ErreurCalculException {
    return resultat(infoRandom);
  }
  
  public boolean dependDe(CElementBase p) {
    return false;
  }

  // La fonction suivante renverra le mme rsultat que DependDe
  // sauf dans le cas o le calcul fait rferrence  la fonction
  // Rand de gnration d'un nombre alatoire
  public boolean dependDePourBoucle(CElementBase p) {
    return false;
  }
  
  /**
   * Renvoie 0 si pChaine ne commence pas par le nom d'une fonction prdfinie relle.
   * Si on renvoie la longueur de la chaine reprsentant cette fonction pour la syntaxe
   * (par exemple 3) pour Sin et renvoie dans Resultat.x l'indice de la fonction trouve
   * La comparaison se fait sans tenir compte de la casse
   */
  public static final int commenceParNomFonctionReellePredefinie(String pChaine, Int resultat)
  {
    int longueurNom = 0;
    //char * Ptch = TamponNomFonction;
    boolean trouve = false;
    int i = 0;
    while ((i < OperateurFonction.NomsFonctions.length) && !trouve)
    {
      if (pChaine.toLowerCase().startsWith(OperateurFonction.NomsFonctions[i].toLowerCase()))
      {
        trouve = true;
        // resultat.x = i;
        resultat.setValue(i);
        longueurNom = OperateurFonction.NomsFonctions[i].length();
      }
      i++;
    }; // while
    return longueurNom;
  }
  /**
   * Renvoie 0 si pChaine ne commence pas par le nom d'une fonction prdfinie complexe.
   * Si on renvoie la longueur de la chaine reprsentant cette fonction pour la syntaxe
   * (par exemple 3) pour Sin et renvoie dans Resultat.x l'indice de la fonction trouve
   * La comparaison se fait sans tenir compte de la casse
   */
  public static final int commenceParNomFonctionComplexePredefinie(String pChaine, Int resultat)
  {
    int longueurNom = 0;
    //char * Ptch = TamponNomFonction;
    boolean trouve = false;
    int i = 0;
    while ((i < OperateurFonction.NomsFonctionsComplexes.length) && !trouve)
    {
      if (pChaine.toLowerCase().startsWith(OperateurFonction.NomsFonctionsComplexes[i].toLowerCase()))
      {
        trouve = true;
        // resultat.x = i;
        resultat.setValue(i + OperateurFonction.indPremiereFoncComplexe);
        longueurNom = OperateurFonction.NomsFonctionsComplexes[i].length();
      }
      i++;
    }; // while
    return longueurNom;
  }
  /**
   * Fonction renvoyant true si pChaine commence par le nom d'une fonction prdfinie relle ou complexe
   */
  public static boolean commenceParNomFonctionPredefinie(String pChaine) {
  	Int res = new Int();
  	return ((commenceParNomFonctionReellePredefinie(pChaine, res) !=0) 
  			|| (commenceParNomFonctionComplexePredefinie(pChaine, res) !=0));
  }
  
  /**
   * Fonction renvoyant true si chaine est le nom d'une fonction relle prdfinie
   * @param chaine
   * @return
   */
  public static final boolean egalNomFonctionReellePredefinie(String chaine) {
    int i = 0;
    while (i < OperateurFonction.NomsFonctions.length)
    {
      if (chaine.toLowerCase().equals((OperateurFonction.NomsFonctions[i].toLowerCase())))
      	return true;
      i++;
    }; // while
    return false;
  }

  /**
   * Fonction renvoyant true si chaine est le nom d'une fonction complexe prdfinie
   * @param chaine
   * @return
   */
  public static final boolean egalNomFonctionComplexePredefinie(String chaine) {
    int i = 0;
    while (i < OperateurFonction.NomsFonctionsComplexes.length)
    {
      if (chaine.toLowerCase().equals((OperateurFonction.NomsFonctionsComplexes[i].toLowerCase())))
      	return true;
      i++;
    }; // while
    return false;
  }

  /**
   * Fonction renvoyant true si chaine est le nom d'une fonction relle ou complexe prdfinie
   * @param chaine
   * @return
   */
  public static final boolean egalNomFonctionReelleOuComplexePredefinie(String chaine) {
  	return egalNomFonctionReellePredefinie(chaine) || egalNomFonctionComplexePredefinie(chaine);
  } 
  

  // Fonction renvoyant, dans une chaine de caractres ch dont le dbut
  // a pour indice pdeb et la fin pfin l'indice du premier
  // signe + ou - rencont dans une expression algbrique  partir de la fin
  // Renvoie -1 si n'en trouve pas
  public static final int premiereSomme(String ch, int pdeb, int pfin)
  {
    int ptch;
    char car;
    int resultat;

    ptch = pfin;
    do
    {
      car = ch.charAt(ptch);
      resultat = ptch;
      if (car == ')') ptch = parentheseOuvrante(ch,pdeb,ptch);
      ptch--;
    }
    while ((ptch >= pdeb) && (car != '+') && (car != '-'));
    if ((car == '+') || (car == '-')) return resultat;
    else return -1;
  }  
  // Fonction renvoyant, dans une chaine de caractres ch dont le dbut
  // a pour indice pdeb et la fin pfin l'indice du premier
  // signe * ou / rencont dans une expression algbrique  partir de la fin
  // Renvoie -1 si n'en trouve pas
  public static final int premierProduit(String ch, int pdeb, int pfin)
  {
    int ptch;
    char car;
    int resultat;

    ptch = pfin;
    do
    {
      car = ch.charAt(ptch);
      resultat = ptch;
      if (car == ')') ptch = parentheseOuvrante(ch,pdeb,ptch);
      ptch--;
    }
    while ((ptch >= pdeb) && (car != '*') && (car != '/'));
    if ((car == '*') || (car == '/')) return resultat;
    else return -1;
  }
  
  // Fonction renvoyant l'indice dans la chaine ch de la premire ingalit
  // rencontree et -1 s'il n'y en a pas.
  // Renvoie dans retour.x l'indice du caractre prcdent l'ingalit
  // et dans retour.y l'oprateur associ  cette ingalit (dfini dans COperateur)
  public static final int premiereInegalite(String ch, int pdeb, int pfin, Point retour)
  {
    int ptch;
    char car, carPrecedent;
    int resultat;

    ptch = pfin;
    do
    {
      car = ch.charAt(ptch);
      resultat = ptch;
      if (car ==  ')') ptch = parentheseOuvrante(ch,pdeb,ptch);
      ptch = ptch - 1;
    }
    while ((ptch >= pdeb) && (car != '=') && (car != '>') && (car !='<'));
    switch (car)
    {
      case '<':
        retour.x = resultat-1;
        retour.y = Operateur.Inf;
        return resultat;
      case '>':
        retour.x = resultat-1;
        retour.y = Operateur.Sup;
        if (ptch > pdeb)
        {
          ptch = resultat-1;
          carPrecedent = ch.charAt(ptch);
          if (carPrecedent == '<')
          {
            retour.x = ptch-1;
            retour.y = Operateur.Diff;
          }
        }
        return resultat;
      case '=':
        if (ptch >= pdeb)
        {
          ptch = resultat-1;
          carPrecedent = ch.charAt(ptch);
          switch (carPrecedent)
          {
            case '<':
              retour.x = ptch-1;
              retour.y = Operateur.InfOuEgal;
              return resultat;
            case '>':
              retour.x = ptch-1;
              retour.y = Operateur.SupOuEgal;
              return resultat;
            default:
              retour.x = ptch;
              retour.y = Operateur.Egalite;
              return resultat;
          } // switch CarPrecedent
        }
      default: return -1;
    } // switch car
  }
  // Fonction renvoyant, dans une chaine de caractres ch dont le dbut
  // a pour indice pdeb et la fin pfin l'indice du premier
  // signe ^ rencont dans une expression algbrique  partir de la fin
  // Renvoie -1 si n'en trouve pas
  // Ajout d'une fonctionnali par rapport  la version C++ 1.8 : dtecte aussi
  // les carrs 
  public final static int premierePuissance(String ch, int pdeb, int pfin)
  {
    int ptch;
    char car;
    int resultat;

    ptch = pfin;
    do
    {
      car = ch.charAt(ptch);
      resultat = ptch;
      if (car == ')') ptch = parentheseOuvrante(ch,pdeb,ptch);
      ptch --;
    }
    while ((ptch >= pdeb) && (car != '^') && (car != ''));
    if ((car == '^') || (car == ''))	
      return resultat;
    else return -1;
  }
  
  // Fonction appele dans le cas ou pRecherche est l'indice dans chaine d'une
  // parenthse fermante et renvoyant l'indice de la parenthse
  // ouvrante correspondante. Elle ne doit tre appele que
  // si pdebut<=pRecherche et si pRecherche pointe sur une
  // parenthse fermante et si la syntaxe est correcte au point de vue parenthses
  public static final int parentheseOuvrante(String chaine,int pdebut,int pRecherche)
  {
    int p;
    char ch;
    int somme;

    somme = 0;
    p = pRecherche;
    do
    {
      ch = chaine.charAt(p);
      if (ch ==')') somme--;
      else
      {
        if (ch == '(') somme++;
      }
      p = p - 1;
    }
    while ((somme != 0) && (p >= pdebut));
    return p + 1;
  }
  // Ajout pour version 2 du CNED
  // Fonction appele dans le cas ou pDebut est l'indice dans chaine d'une
  // parenthse fermante et renvoyant l'indice de la parenthse
  // fermante correspondante. Elle ne doit tre appele que
  // si on est sur que la parenthse fermante existe bien
  public static final int parentheseFermante(String chaine, int pdebut)
  {
    int p;
    char ch;
    int somme;

    somme = 0;
    p = pdebut;
    do
    {
      ch = chaine.charAt(p);
      if (ch =='(') somme++;
      else
      {
        if (ch == ')') somme--;
      }
      p++;
    }
    while (somme != 0);
    return p-1;
  }
  
  /**
   * Procedure vrifiant la syntaxe de l'expression relle pointe par Ch en
   * tenant compte du fait qu'elle ne doit pas utiliser de valeur dont
   * l'indice dans PtListe est strictement suprieur  IndiceMaxiDansListe
   * la diffrence par rapport  la version C++ est que cette fonction
   *  ne renvoie pas de renseignement sur le message d'erreur  afficher
   */
  public final static boolean verifieSyntaxe(CListeObjets ptListe,String ch, Int indiceErreur,
        int indiceMaxiDansListe,String parametreFormel)
  {
    int i;
    int indiceDansListe;
    int pdebut;
    char car,carSuivant;
    boolean erreur;
    int longueurCh;
    int itemPrecedent = 0;
    int itemSuivant = 0;
    boolean pointDecimalRencontre;
    int sommeParentheses;
    int longNom;
    Int nomF = new Int();
    PointeurValDyn ptVa = new PointeurValDyn();
    boolean queDesBlancs;
    Bool parametreTrouve = new Bool(true);

    erreur = false;
    longueurCh = ch.length();
    // On vrifie d'abord qu'il n'y a pas d'erreur de parenthse
    if (longueurCh == 0)
    {
      // IndiceMessageErreur = IDE_NOUVEAUCALCUL4;
      indiceErreur.setValue(0);
      // MessageBeep(0);
      return false;
    }
    i = 0;
    sommeParentheses = 0;
    while ((i < longueurCh) && (sommeParentheses >= 0))
    {
      car = ch.charAt(i);
      switch (car)
      {
        case '(':
          sommeParentheses++;
          break;
        case ')':
          sommeParentheses--;
      } // switch
      i++;
    }
    if (sommeParentheses != 0)
    {
      indiceErreur.setValue(i);
      //IndiceMessageErreur = IDE_SYNTAXE2;
      return false;
    }
    i = 0;
    // Tout se passe au dbut comme si l'expression tait prcde 
    // d'une parenthse ouvrante
    itemPrecedent = ParOuvrante;
    while ((i < longueurCh) && !erreur)
    {
      car = ch.charAt(i);
      pointDecimalRencontre = false;
      if (FonteNom.chiffre(car) || (car == '.'))
      {
        while ((FonteNom.chiffre(car) || (car == '.'))
              && (i < longueurCh) && !erreur)
        {
          if (car == '.')
          {
            if (pointDecimalRencontre)
            {
              erreur = true;
              indiceErreur.setValue(i - 1);
              //IndiceMessageErreur = IDE_SYNTAXE1;
            }
            else pointDecimalRencontre = true;
          }
          i++;
          if (i < longueurCh) car = ch.charAt(i);
        } // while
        if (!erreur) itemSuivant = Nombre;
      }
      else	// cas o le caractre en cours n'est pas un nombre
            // le caractre en cours n'est pas un chiffre ou un point dcimal}
      {
        pdebut = i;
        // On regarde si cela commence par le nom d'une fonction ou
        // une valeur dj dfinie
        longNom = ptListe.commenceParNomFonctionOuValeurOuParametre(ch.substring(pdebut),
        		parametreFormel, ptVa, nomF, parametreTrouve, false);
        if (longNom > 0)
        {
          if (parametreTrouve.getValue())
          {
            itemSuivant = Valeur;
            i = i + longNom;
          }
          else
          {
            if (ptVa.getPointeur() == null)
            {
              itemSuivant = Fonction;
              i = i + longNom;
            }
            else
            {
              CValeurDynamique vd = ptVa.getPointeur();
              indiceDansListe = ptListe.indexOf(vd);
              if (indiceDansListe > indiceMaxiDansListe)
              {
                erreur = true;
                indiceErreur.setValue(i);
              }
              else
              {
                i += longNom;
                if (vd.estFonctionOuSuite()) itemSuivant = Fonction;
                else itemSuivant = Valeur;
              }
            }
          }
        }
        else
        {
          switch (car)
          {
            case '+':
            case '-':
              itemSuivant = Addition;
              i++;
              break;
            case '*':
            case '/':
              itemSuivant = Multiplication;
              i++;
              break;
            case '(':
              itemSuivant = ParOuvrante;
              i++;
              break;
            case ')':
              itemSuivant = ParFermante;
              i++;
              break;
            case '^':
              itemSuivant = Puissance;
              i++;
              break;
            // Ajout par rapport  la version C++ 1.8, autorisation du carr 
            case '':
              itemSuivant = Carre;
              i++;
              break;
            // ni nombre ni oprateur}
            case '<':
              itemSuivant = Inegalite;
              i++;
              if (i <= longueurCh-2)
              {
                carSuivant = ch.charAt(i);
                if ((carSuivant == '=') || (carSuivant == '>')) i++;
              }
              break;
            case '>':
              itemSuivant = Inegalite;
              i++;
              if (i <= longueurCh-2)
              {
                carSuivant = ch.charAt(i);
                if (carSuivant == '=') i++;
              }
              break;
            case '=':
              itemSuivant = Inegalite;
              i++;
              break;
            case ' ':
              itemSuivant = Blanc;
              i++;
              break;
            default: // switch Car
              erreur = true;
              //IndiceMessageErreur = IDE_SYNTAXE1;
              indiceErreur.setValue(i - 1);
          } // switch Car
        }// else du if LongNom > 0
      } // else du if Chiffre(Car) || (Car == '.'))
      if (!erreur)
      {
        if (autorisationSyntaxe(itemPrecedent,itemSuivant))
        {
          if (itemSuivant != Blanc) itemPrecedent = itemSuivant;
        }
        else
        {
          erreur = true;
          // IndiceMessageErreur = IDE_SYNTAXE1;
          indiceErreur.setValue(i);
        }
      }
    } // while
    // Il faut aussi regarder si la fin de l'expression est correcte
    itemSuivant = ParFermante;
    if (!erreur)
    {
      if (!autorisationSyntaxe(itemPrecedent,itemSuivant))
      {
        //MessageBeep(0);
        erreur = true;
        indiceErreur.setValue(longueurCh);
        // IndiceMessageErreur = IDE_SYNTAXE1;
      }
    }
    if (indiceErreur.getValue() < 0) indiceErreur.setValue(0);
    else
      if (indiceErreur.getValue() >= longueurCh) indiceErreur.setValue(longueurCh - 1);
    // On regarde si la chane ne contient que des blancs
    i = 0;
    queDesBlancs = true;
    while ((i <= longueurCh-1) && queDesBlancs)
    {
      car = ch.charAt(i);
      if (car != ' ') queDesBlancs = false;
      else i++;
    }
    if (queDesBlancs)
    {
      // MessageBeep(0);
      erreur = true;
      indiceErreur.setValue(longueurCh);
      // IndiceMessageErreur = IDE_SYNTAXE1;
    }
    // if (Erreur) MessageBeep(0);
    return !erreur;
  }
  
  /**
   * Procedure vrifiant la syntaxe de l'expression relle pointe par Ch en
   * tenant compte du fait qu'elle ne doit pas utiliser de valeur dont
   * l'indice dans PtListe est strictement suprieur  IndiceMaxiDansListe
   * la diffrence par rapport  la version C++ est que cette fonction
   *  ne renvoie pas de renseignement sur le message d'erreur  afficher
   */
  public final static boolean verifieSyntaxeComplexe(CListeObjets ptListe,String ch, Int indiceErreur,
        int indiceMaxiDansListe,String parametreFormel)
  {
    int i;
    int indiceDansListe;
    int pdebut;
    char car,carSuivant;
    boolean erreur;
    int longueurCh;
    int itemPrecedent = 0;
    int itemSuivant = 0;
    boolean pointDecimalRencontre;
    int sommeParentheses;
    int longNom;
    Int nomF = new Int();
    PointeurValDyn ptVa = new PointeurValDyn();
    boolean queDesBlancs;
    Bool parametreTrouve = new Bool(false);
    Bool complexei = new Bool(false);

    erreur = false;
    longueurCh = ch.length();
    // On vrifie d'abord qu'il n'y a pas d'erreur de parenthse
    if (longueurCh == 0)
    {
      // IndiceMessageErreur = IDE_NOUVEAUCALCUL4;
      indiceErreur.setValue(0);
      // MessageBeep(0);
      return false;
    }
    i = 0;
    sommeParentheses = 0;
    while ((i < longueurCh) && (sommeParentheses >= 0))
    {
      car = ch.charAt(i);
      switch (car)
      {
        case '(':
          sommeParentheses++;
          break;
        case ')':
          sommeParentheses--;
      } // switch
      i++;
    }
    if (sommeParentheses != 0)
    {
      indiceErreur.setValue(i);
      //IndiceMessageErreur = IDE_SYNTAXE2;
      return false;
    }
    i = 0;
    // Tout se passe au dbut comme si l'expression tait prcde 
    // d'une parenthse ouvrante
    itemPrecedent = ParOuvrante;
    while ((i < longueurCh) && !erreur)
    {
      car = ch.charAt(i);
      pointDecimalRencontre = false;
      if (FonteNom.chiffre(car) || (car == '.'))
      {
        while ((FonteNom.chiffre(car) || (car == '.'))
              && (i < longueurCh) && !erreur)
        {
          if (car == '.')
          {
            if (pointDecimalRencontre)
            {
              erreur = true;
              indiceErreur.setValue(i - 1);
              //IndiceMessageErreur = IDE_SYNTAXE1;
            }
            else pointDecimalRencontre = true;
          }
          i++;
          if (i < longueurCh) car = ch.charAt(i);
        } // while
        if (!erreur) itemSuivant = Nombre;
      }
      else	// cas o le caractre en cours n'est pas un nombre
            // le caractre en cours n'est pas un chiffre ou un point dcimal}
      {
        pdebut = i;
        // On regarde si cela commence par le nom d'une fonction ou
        // une valeur dj dfinie
        longNom = ptListe.commenceParNomFonctionOuValeurOuParametreComplexe(ch.substring(pdebut),
        		parametreFormel, ptVa, nomF, parametreTrouve, complexei, false);
        if (longNom > 0) {
        	if (complexei.getValue()) {
            itemSuivant = Valeur;
            i = i + longNom;
        	}
        	else {
	          if (parametreTrouve.getValue())
	          {
	            itemSuivant = Valeur;
	            i = i + longNom;
	          }
	          else
	          {
	            if (ptVa.getPointeur() == null)
	            {
	              itemSuivant = Fonction;
	              i = i + longNom;
	            }
	            else
	            {
	              CValeurDynamique vd = ptVa.getPointeur();
	              indiceDansListe = ptListe.indexOf(vd);
	              if (indiceDansListe > indiceMaxiDansListe)
	              {
	                erreur = true;
	                indiceErreur.setValue(i);
	              }
	              else
	              {
	                i += longNom;
	                if (vd.estFonctionOuSuite()) itemSuivant = Fonction;
	                else itemSuivant = Valeur;
	              }
	            }
	          }
        	}
        }
        else
        {
          switch (car)
          {
            case '+':
            case '-':
              itemSuivant = Addition;
              i++;
              break;
            case '*':
            case '/':
              itemSuivant = Multiplication;
              i++;
              break;
            case '(':
              itemSuivant = ParOuvrante;
              i++;
              break;
            case ')':
              itemSuivant = ParFermante;
              i++;
              break;
            case '^':
              itemSuivant = Puissance;
              i++;
              break;
            // Ajout par rapport  la version C++ 1.8, autorisation du carr 
            case '':
              itemSuivant = Carre;
              i++;
              break;
            // ni nombre ni oprateur}
            case '<':
              itemSuivant = Inegalite;
              i++;
              if (i <= longueurCh-2)
              {
                carSuivant = ch.charAt(i);
                if ((carSuivant == '=') || (carSuivant == '>')) i++;
              }
              break;
            case '>':
              itemSuivant = Inegalite;
              i++;
              if (i <= longueurCh-2)
              {
                carSuivant = ch.charAt(i);
                if (carSuivant == '=') i++;
              }
              break;
            case '=':
              itemSuivant = Inegalite;
              i++;
              break;
            case ' ':
              itemSuivant = Blanc;
              i++;
              break;
            default: // switch Car
              erreur = true;
              //IndiceMessageErreur = IDE_SYNTAXE1;
              indiceErreur.setValue(i - 1);
          } // switch Car
        }// else du if LongNom > 0
      } // else du if Chiffre(Car) || (Car == '.'))
      if (!erreur)
      {
        if (autorisationSyntaxe(itemPrecedent,itemSuivant))
        {
          if (itemSuivant != Blanc) itemPrecedent = itemSuivant;
        }
        else
        {
          erreur = true;
          // IndiceMessageErreur = IDE_SYNTAXE1;
          indiceErreur.setValue(i);
        }
      }
    } // while
    // Il faut aussi regarder si la fin de l'expression est correcte
    itemSuivant = ParFermante;
    if (!erreur)
    {
      if (!autorisationSyntaxe(itemPrecedent,itemSuivant))
      {
        //MessageBeep(0);
        erreur = true;
        indiceErreur.setValue(longueurCh);
        // IndiceMessageErreur = IDE_SYNTAXE1;
      }
    }
    if (indiceErreur.getValue() < 0) indiceErreur.setValue(0);
    else
      if (indiceErreur.getValue() >= longueurCh) indiceErreur.setValue(longueurCh - 1);
    // On regarde si la chane ne contient que des blancs
    i = 0;
    queDesBlancs = true;
    while ((i <= longueurCh-1) && queDesBlancs)
    {
      car = ch.charAt(i);
      if (car != ' ') queDesBlancs = false;
      else i++;
    }
    if (queDesBlancs)
    {
      // MessageBeep(0);
      erreur = true;
      indiceErreur.setValue(longueurCh);
      // IndiceMessageErreur = IDE_SYNTAXE1;
    }
    // if (Erreur) MessageBeep(0);
    return !erreur;
  }  
  // Ajout pour la version 1.9.5
  // Procdure rcursive servant  savoir si un calcul dpend de la variable formelle
  public abstract boolean  dependDeVariable();
  // Ajout pour la version 1.9.5
  // Sert  crer un clone d'un objet CCalcul
  // Utilis dans l'objet CDerivee
  public abstract CCalculBase getCopie();
  // Ajout pour la version 1.9.5.
  // Procdure rcursive crant l'objet CCalculBase reprsentant l'arbre de la
  // drive formelle d'un autre
  // Sera utilis au chargement d'un objet du type CDerivee
  // Nouveaut de la version 1.5. Cration d'un calcul qui reprsente la drive formelle
  // d'un calcul. Cette procdure est rcursive
  @SuppressWarnings("unchecked")
	public static CCalculBase creeDerivee(CCalculBase calc)
  {
    CListeObjets li =calc.listeProprietaire;
    Class pClass = calc.getClass();
    if (pClass == CConstante.class)
      return new CConstante(li,0);
    else
    if (pClass == CVariableFormelle.class)
      return new CConstante(li,1);
    else
    if (pClass == CResultatValeur.class)
      return new CConstante(li,0);
    else
    if (pClass == CAppelFonction.class)
    {
      CAppelFonction appfon = (CAppelFonction) calc;
      // Ici il y a un problme car l'appel de fonction peut tre un appel
      //  une suite rcurrente. Cet appel est licite s'il ne fait pas appel
      //  la variable formelle.
      // Il faudra le vrifier avant d'autoriser le calcul d'une drive.
      // Ici on suppose que c'est la cas
      if (appfon.fonctionAssociee.getClass() == CSuiteRec.class)
      {
        // L'appel de suite sans paramtre est considr comme une constante
        return new CConstante(li,0);
      }
      else // Cas d'une vraie fonction
      {
        CFonc f = (CFonc)(appfon.fonctionAssociee);
        // On regarde si l'appel de fonction est seulement de la forme f(paramtre)
        if (appfon.operande.getClass() == CVariableFormelle.class)
        {
          return creeDerivee(f.calcul);
        }
        else
        { // Dans ce cas il faut driver comme une compose du type fou
          CCalculBase uder = creeDerivee(appfon.operande);
          CCalculBase uCopie = appfon.operande.getCopie();
          CCalculBase fcalcder = creeDerivee(f.calcul);
          CAppelFonctionInterne appelfder = new CAppelFonctionInterne(fcalcder,uCopie);
          return new COperation(li, uder, appelfder, Operateur.Mult);
        }
      }
    }
    else
    if (pClass == COperation.class)
    {
      COperation op = (COperation)calc;
      switch (op.operateur)
      {
        case Operateur.Plus:
          return new COperation(li, creeDerivee(op.operande1), creeDerivee(op.operande2),Operateur.Plus);
        case Operateur.Moin:
          return new COperation(li, creeDerivee(op.operande1), creeDerivee(op.operande2),Operateur.Moin);
        case Operateur.Mult:
          {
          // On regarde d'abord si les facteurs du produit dpendent de la variable
          boolean op1dep = op.operande1.dependDeVariable();
          boolean op2dep = op.operande2.dependDeVariable();
          if (!op1dep && ! op2dep) return new CConstante(li, 0);
          if (!op1dep && op2dep) return new COperation(li, op.operande1.getCopie(),
            creeDerivee(op.operande2), Operateur.Mult);
          if (op1dep && !op2dep) return new COperation(li, creeDerivee(op.operande1),
            op.operande2.getCopie(), Operateur.Mult);
          // Formule u'v + uv'
          else return new COperation(li,
            new COperation(li, creeDerivee(op.operande1), op.operande2.getCopie(), Operateur.Mult),
            new COperation(li, creeDerivee(op.operande2), op.operande1.getCopie(), Operateur.Mult),
            Operateur.Plus);
          }
        case Operateur.Divi: // Formule (u'v-uv')/v
          // On regarde d'abord si le dnominateur dpend de la variable
          if (!op.operande2.dependDeVariable())
            return new COperation(li, creeDerivee(op.operande1), op.operande2.getCopie(), Operateur.Divi);
          else
            return new COperation(li, new COperation(li, new COperation(li, creeDerivee(op.operande1),
            op.operande2.getCopie(), Operateur.Mult),
            new COperation(li, creeDerivee(op.operande2), op.operande1.getCopie(), Operateur.Mult),
            Operateur.Moin),new CPuissance(li, op.operande2.getCopie(),
              new CConstante(li, 2)), Operateur.Divi);
        case Operateur.Inf:
        case Operateur.Sup:
        case Operateur.InfOuEgal:
        case Operateur.SupOuEgal:
        case Operateur.Egalite:
        case Operateur.Diff:
          return new CConstante(li, 0);
      }
    }
    else
    if (pClass == CFonction.class)
    {
      CFonction f = (CFonction)calc;
      switch (f.operateurFonction)
      {
        case OperateurFonction.Abso:
          // La fonction valeur absolue n'tant pas drivable en 0
          // On va renvoyer comme formule 1/((operande>0)-(Operande<0))*(Operande)'
          return new COperation(li, new COperation(li, new CConstante(li, 1), new COperation(li, 
            new COperation(li, f.operande.getCopie(),new CConstante(li, 0),Operateur.Sup),
            new COperation(li, f.operande.getCopie(),new CConstante(li, 0),Operateur.Inf), 
            Operateur.Moin), Operateur.Divi),	creeDerivee(f.operande),Operateur.Mult);
        case OperateurFonction.Enti: // la drive existe et est nulle sauf en tout entier
          // On renvoie donc comme formule 0/(operande<>int(operande))
          return new COperation(li, new CConstante(li, 0),
            new COperation(li, f.operande.getCopie(),
            new CFonction(li, OperateurFonction.Enti,f.operande.getCopie()), 
            Operateur.Diff), Operateur.Divi);
        case OperateurFonction.Raci:
        case OperateurFonction.Raci2: // Formule u'/(2Racine(u))
          return new COperation(li, creeDerivee(f.operande),
            new COperation(li, new CConstante(li, 2),
            new CFonction(li, OperateurFonction.Raci, f.operande.getCopie() ),
            Operateur.Mult), Operateur.Divi);
        case OperateurFonction.Sinu: // La drive ne sera correcte que si on est en mode radian
          // On applique la formule u'*cos(u)
          return new COperation(li, creeDerivee(f.operande),
            new CFonction(li, OperateurFonction.Cosi, f.operande.getCopie()), Operateur.Mult);
        case OperateurFonction.Cosi:// La drive ne sera correcte que si on est en mode radian
          // On applique la formule -u'*sin(u)
          return new COperation(li, new COperation(li, creeDerivee(f.operande),
            new CFonction(li, OperateurFonction.Sinu, f.operande.getCopie()), Operateur.Mult),
            new CConstante(li, -1), Operateur.Mult);
        case OperateurFonction.Tang: // On applique la formule u'/cos(u)
          return new COperation(li, creeDerivee(f.operande),
            new CPuissance(li, new CFonction(li, OperateurFonction.Cosi,
            f.operande.getCopie()), new CConstante(li, 2)), Operateur.Divi);
        // Le nombre de fonctions est limit pour la version collge
        case OperateurFonction.Logn: // Formule u'/(u*(u>0))
          return new COperation(li, creeDerivee(f.operande) ,
            new COperation(li, f.operande.getCopie() ,
            new COperation(li, f.operande.getCopie(),
            new CConstante(li, 0), Operateur.Sup), Operateur.Mult), Operateur.Divi);
          case OperateurFonction.Expo: //Formule u'*exp(u)
            return new COperation(li, creeDerivee(f.operande),
              new CFonction(li, OperateurFonction.Expo,f.operande.getCopie()), Operateur.Mult);
          case OperateurFonction.ATan: // Formule u'/(1+u)
            return	new COperation(li, creeDerivee(f.operande),
              new COperation(li,  new CConstante(li, 1), 
              new CPuissance(li, f.operande.getCopie(),new CConstante(li, 2) ),
              Operateur.Plus), Operateur.Divi);
          case OperateurFonction.ACos: // Formule u'/(rac(1-u))
           return new COperation(li, creeDerivee(f.operande) ,
             new CFonction(li, OperateurFonction.Raci, new COperation(li, new CConstante(li, 1),
             new CPuissance(li, f.operande.getCopie(),new CConstante(li, 2)), 
             Operateur.Moin)), Operateur.Divi);
          case OperateurFonction.ASin: // Meme formule qie ci-dessus
           return new COperation(li, creeDerivee(f.operande) ,
             new CFonction(li, OperateurFonction.Raci, new COperation(li, new CConstante(li, 1),
             new CPuissance(li, f.operande.getCopie(),new CConstante(li, 2)),
             Operateur.Moin)), Operateur.Divi);
          case OperateurFonction.Cosh: // Formule u'*Sinh(u)
            return new COperation(li, creeDerivee(f.operande),
              new CFonction(li, OperateurFonction.Sinh,f.operande.getCopie()), Operateur.Mult);
          case OperateurFonction.Sinh: // Formule u'*Cosh(u)
            return new COperation(li, creeDerivee(f.operande),
              new CFonction(li, OperateurFonction.Cosh,f.operande.getCopie()), Operateur.Mult);
          case OperateurFonction.Tanh: // Formule u'/Cosh(u)
            return new COperation(li, creeDerivee(f.operande),
              new CPuissance(li, new CFonction(li, OperateurFonction.Cosh ,
              f.operande.getCopie()),new CConstante(li, 2)), Operateur.Divi);
          case OperateurFonction.ArgCh: // Formule u'/Rac(u-1)
            return new COperation(li, creeDerivee(f.operande),
              new CFonction(li, OperateurFonction.Raci,new COperation(li,
              new CPuissance(li, f.operande.getCopie(),new CConstante(li, 2)),
              new CConstante(li, 1), Operateur.Moin) ), Operateur.Divi);
          case OperateurFonction.ArgSh: // Formule u'/(Rac(1+u)
            return new COperation(li, creeDerivee(f.operande),
              new CFonction(li, OperateurFonction.Raci,new COperation(li,
              new CPuissance(li, f.operande.getCopie(),new CConstante(li, 2)),
              new CConstante(li, 1), Operateur.Plus) ), Operateur.Divi);
          case OperateurFonction.ArgTh: // Formule (Abs(u)<1)*u'/(1-u)
            return new COperation(li,
              new COperation(li, new CFonction(li, OperateurFonction.Abso,
              f.operande.getCopie()),new CConstante(li, 1),Operateur.Inf) ,
              new COperation(li, creeDerivee(f.operande), 
              new COperation(li, new CConstante(li, 1),
              new CPuissance(li, f.operande.getCopie(),
              new CConstante(li, 2)) ,Operateur.Moin),Operateur.Divi), Operateur.Mult);
          case OperateurFonction.Rand:
            return new CConstante(li, 0);
      }
    }
    else
    if (pClass == CPuissance.class)
    {
      CPuissance pui = (CPuissance) calc;
      // Si l'exposant ne dpend pas de la variable formelle on emploie la formule
      // (u^n)' = nu'u^(n-1)
      if (!pui.exposant.dependDeVariable())
        return new COperation(li, new COperation(li, pui.exposant.getCopie(),
          creeDerivee(pui.operande) ,Operateur.Mult),
          new CPuissance(li, pui.operande.getCopie(),
          new COperation(li, pui.exposant.getCopie(), new CConstante(li, 1), 
          Operateur.Moin)), Operateur.Mult);
      // Sinon on considre u^v comme exp(v*lnu) de drive
      // (v'*lnu+v*u'/u)*u^v
      else
        return new COperation(li, new COperation(li, 
        new COperation(li, creeDerivee(pui.exposant),
        new CFonction(li, OperateurFonction.Logn,pui.operande.getCopie()) ,
        Operateur.Mult),new COperation(li, new COperation(li, creeDerivee(pui.operande),
        pui.operande.getCopie(), Operateur.Divi),pui.exposant.getCopie(),
        Operateur.Mult),Operateur.Plus),
        new CPuissance(li, pui.operande.getCopie(),pui.exposant.getCopie() ), Operateur.Mult);
    }
    return null;  // Pour satisfaire le compilateur
  }
  // Ajout pour la version 2.0
  //Procdure levant un double  la puissance n quand n est un entier compris entre 1 et 255
  public static double PuisExpEnt(double c1, int exposant)
  {
    double tampon = c1;
    double res = 1;
    // Version n'utilisant que des dcalages de bits pour optimisation
    int b = 128;
    int indfin = 7;
    while ((b & exposant) == 0)
    {
            indfin--;
            b = b >> 1;
    }
    // Attention aux erreurs d'arrondi. Il faut prendre l'entier le plus proche
    // int indfin = (int) floor(log(exposant)/log(2)+0.5); // plus lent. Abandonn
    for (int i = 0; i <=indfin; i++)
    {
      if ((exposant % 2) != 0)
      {
        res = res*tampon;
      }
      exposant >>= 1;
      tampon = tampon*tampon;
    }
    return res;
  }
  // Fonctions rajoutes pour la version 2.1.1 pour rendre le calcul sur les complexes plus
  // prcis en particulier le calcul de puissances.
  // Sans utiliser cette mthode pour calculer par exemple (1+i)^256 on trouve un rsultat aberrant
  public static double sinus(double x)
  {
    return Math.sin(x-Math.floor(x/(2*Math.PI))*2*Math.PI);
  }
  public static double cosinus(double x)
  {
    return Math.cos(x-Math.floor(x/(2*Math.PI))*2*Math.PI);
  }
  public static double tangente(double x)
  {
    return Math.tan(x-Math.floor(x/(2*Math.PI))*2*Math.PI);
  }
  
  /**
   * Sert  reconstituer une formule  partir de son arbre binaire conjointement  chaineCalculSansPar
   * A redfinir pour les descendants
   */
	public String chaineCalcul(String varFor) {
		return "";	
	}
	
  /**
   * Sert  reconstituer une formule  partir de son arbre binaire conjointement  chaineCalcul
   * A redfinir pour les descendants
   */
	public String chaineCalculSansPar(String varFor) {
		return chaineCalcul(varFor);
	}
	
	/**
	 * Rajout pour la version 3.0 : renvoie true si le calcul est constant sans faire appel
	 *  la fonction Rand()
	 * A redfinir pour tous les calculs renvoyant une constante
	 * @return
	 */
	public boolean estConstant() {
		return false;
	}
	
  public void chargeDepuisFlux ( MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    listeProprietaire = list;
  }

  /* Lecture depuis un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
  }
}
