/*
 * CCercle.java
 *
 * Created on 28 juin 2004, 18:45
 */

/**
 *
 * @author  Yves
 * @version 
 * Dans cette version comprenant des constructions cette classe n'est pas abstract
 * car dans les outils utilisant la cration visuelle d'objets (rapporteur) des
 * cercles de ce type sont instancis. Mais aucun objet de ce type n'est jamais
 * cr dans la liste des objets enregistrs dans une figure.
 * C'est la raison pour laquelle getClone est quand mme dfini mais renvoie null
 */
package objets;

import glob.*;

import java.awt.*;
import java.awt.geom.Point2D;

import types.*;


// Modification pour la version 1.9.5
// A la suite du rajout des lieux d'objets cette classe n'est plus abstract

public class CCercle extends CElementLigne {
		public double centre_x;
		public double centre_y;
		public double rayon;
		// Coordonnes du carr de trac
		public double xCarre1,yCarre1,xCarre2,yCarre2;

  /** Creates new CCercle */
  public CCercle() {
  }
  
  /** Constructeur pour objets crs lors de la cration visuelle d'objets
   *  Le centre et le rayon resteront fixes
   */

  public CCercle(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit,
    double centre_xInit, double centre_yInit, double rayonInit) {
     super (liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit);
     centre_x = centre_xInit;
     centre_y = centre_yInit;
     rayon = rayonInit;
  }

  // Constructeur pour clonage
  public CCercle(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit);      
  }
  
  @Override
  public String complementInfo() {
    return textes.Chaines.chinfo43;
  }
  
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    centre_x = ((CCercle)ptel).centre_x;
    centre_y = ((CCercle)ptel).centre_y;
    rayon = ((CCercle)ptel).rayon;
    xCarre1 = ((CCercle)ptel).xCarre1;
    yCarre1 = ((CCercle)ptel).yCarre1;
    xCarre2 = ((CCercle)ptel).xCarre2;
    yCarre2 = ((CCercle)ptel).yCarre2;
  }

  // Ici getClone est cre pour viter une erreur de compilation mais ne sert pas
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible){
    return null;
  }

  // Devra tre redfini pour les descendants qui ne sont pas des cercles.
  // Permet de savoir si un point est ou pas sur l'objet
  public boolean surArc(double xt,double yt) {
    return true; // true pour un vrai cercle
  }


  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    // devra tre appele par tous les descendants de cercle.positionne
    // pour vrifier que le rayon est positif
    existe = (rayon > 0);
    if (! existe) return;
    xCarre1 = centre_x - rayon;
    yCarre1 = centre_y - rayon;
    xCarre2 = centre_x + rayon;
    yCarre2 = centre_y + rayon;
  }
  
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    
    int styleTrait;
    if (masque) styleTrait = StyleTrait.traitPointille;
    else styleTrait = style;
    if ((Kernel.testToile(xCarre1,yCarre1)) && (Kernel.testToile(xCarre2,yCarre2)))
    {
      pDC.setStroke(Pinceau.CreePinceau(styleTrait));
      pDC.setColor(couleur);
      pDC.drawOval((int)Math.round(xCarre1),(int)Math.round(yCarre1),
          (int)Math.round(xCarre2 - xCarre1),(int)Math.round(yCarre2 - yCarre1));
    }
  }   

  public double abscisseMaximale() {
    // Modification de la version 1.9.5
    // return 2*Math.PI-1e-12;
    return 2*Math.PI;
  }

  public double abscisseMinimale() {
    return 0;
  }

  public double abscisseCurviligne(double ang)
  {
    return ang;
  }

  // Mthode dfinie pour la version 1.8
  public int natureArc() {
    return NatureArc.NatureArcCercle;
  }
    
  // Java : inutile de redfinir ChargeDepuisFlux    
  /** distancePoint renvoie -1 dans le cas o le l'objet n'est pas dsignable */
  public double distancePoint(double xp, double yp, boolean masquage) {
  	 if (!(existe) || (masquage && masque)) return -1;
  	 else return distancePointPourSurface(xp,yp,masquage);
  }
  
  public double distancePointPourSurface(double xp,double yp, boolean masquage) {
		if (!existe) return -1;
		else {
			double distance = Kernel.distancePointPoint(centre_x,centre_y,xp,yp);
			return Math.abs(distance - rayon);
    }      
  }
  
  /**
   * Fonction renvoyant true seulement si le cercle est visible dans la fentre dimfen
   * @param dimfen
   */
  @Override
  public boolean dansFenetre(DimensionFenetre dimfen) {
  	double dist[] = new double[4];
  	Point2D.Double int1 = new Point2D.Double();
  	Point2D.Double int2 = new Point2D.Double();
  	VecteurDirecteur u = new VecteurDirecteur();
  	double sommetsx[] = new double[5];
  	double sommetsy[] = new double[5];
		sommetsx[0] = 0;
    sommetsy[0] = 0;
    sommetsx[1] = dimfen.longueurAbscisses;
    sommetsy[1] = 0;
    sommetsx[2] = dimfen.longueurAbscisses;
    sommetsy[2] = dimfen.longueurOrdonnees;
    sommetsx[3] = 0;
    sommetsy[3] = dimfen.longueurOrdonnees;
    // Pour fermer la boucle des sommets, un cinquime
    sommetsx[4] = 0;
    sommetsy[4] = 0;
    if (dimfen.dansFenetre(centre_x,centre_y))
		{
    	for (int i = 0; i <= 3; i++) dist[i] = Kernel.distancePointPoint(centre_x,centre_y,sommetsx[i],sommetsy[i]);
			double maxDist = dist[0];
			for (int j = 1; j<=3; j++) {
				if (dist[j] > maxDist) maxDist = dist[j];
			}
  		if (rayon <= maxDist) return true; else return false;
    }
    else
    {
    	boolean resultat = false;
    	for (int i = 0; i <= 3; i++)
      {
      	u.x = sommetsx[i+1] - sommetsx[i];
        u.y = sommetsy[i+1] - sommetsy[i];
      	int position = Kernel.intersectionDroiteCercle(sommetsx[i],sommetsy[i],u,
        	centre_x,centre_y,rayon,int1,int2);
        switch (position)
				{
        	case PositionDroiteCercle.Secants:
					{
						resultat = (resultat || Kernel.appartientSegment(int1.x,int1.y,sommetsx[i],
          		sommetsy[i],sommetsx[i+1],sommetsy[i+1]));
						resultat = (resultat || Kernel.appartientSegment(int2.x,int2.y,sommetsx[i],
          		sommetsy[i],sommetsx[i+1],sommetsy[i+1]));
						break;
					}
          case PositionDroiteCercle.Tangents:
					{ 
						resultat = (resultat || Kernel.appartientSegment(int1.x,int1.y,
								sommetsx[i],sommetsy[i],sommetsx[i+1],sommetsy[i+1]));
					}
        }// switch
		} // for
      return resultat;
    }
  }
  

  //Ajout pour version 2 du CNED
  @Override
  public long getNature() {
    return NatureObjet.NCercle;
  }
  
  public void setRayon(double ray) {
  	rayon = ray;
  }
  
  /** Rajout pour la version 2.0 : permet de connatre si l'lment point par pt
   * est graphiquement (presque) confondu avec l'lment en question ou trs proche.
   * Pour cette version applet, ne sera redfini que pour les objets que l'utilisateur
   * pourra effectivement crer en ligne de faon  tester la validit de la construction.
  **/
  public boolean coincideAvec(CElementBase p) {
    if (p.getNature() != NatureObjet.NCercle) return false;
    CCercle cerc = (CCercle) p;
    return Kernel.zero(this.centre_x-cerc.centre_x) && Kernel.zero(this.centre_y-cerc.centre_y)
      && Kernel.zero(this.rayon-cerc.rayon);
  } 
  /**
   * Fonction rajoute pour la version 2.1 et servant  savoir si un point
   * est par dfinition sur une droite. Renverra true par exemple
   * si la droite est dfinie par deux points et le point est un de ces deux points
   * ou si le point est li  la droite
   * A t rajout pour amliorer l'outil d'intersection
   * A redfinir pour les descendants quand ncessaire
   * */
  public boolean contientParDefinition(CPointAncetre po)
  {
    return false;
  }

  @Override
  public String chaineDesignation() {
    return textes.Chaines.designationCercle;
  }
  
}
