/*
 * CDroite.java
 *
 * Created on 28 juin 2004, 15:42
 */

/**
 *
 * @author  Yves
 * @version
 */
// Java : Important : en C++ CDemiDroite hritait de CDroite mais appelait la mthode de srialization
// de CElement ligne car il est inutile de mmoriser l'origine et le vecteur
// c'est impossible en java. Une demi-droite ne pouvant pas tre nomme, inutile s'avoir
// un champ abscisseNom
// Mais cela pose un problme car dans la mthode de serialization de CDemiDroiteOA qui hrite de
// CdemiDroite, c'est la mthode de srialization de CDroite qui tait appele, ce qui est illogique.
// Dans chargeDepuisFlux de CDemiDroiteOA, il faut donc dpiler les donnes inutiles
// Mais pourtant uen demi-droite doit descendre de l'anctre des droites. J'ai rsolu le problme
// en rajoutant un type CDroiteAncetre qui soir l'anctre de toutes les droites
package objets;

import java.awt.*;
import java.io.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

// Classe pas abstract car est instancie dans CRepere
public class CDroite extends CDroiteAncetre {
  public static double abscisseNomParDefaut = 0.95;
  public double abscisseNom;
  
  /** Creates new CDroite */
  public CDroite() {
    super(); // Pour crer l'objet vecteur directeur
  }
  
  /**
   * Constructeur pour les droites utilises de faon interne
   * @param liste
   */
  public CDroite (CListeObjets liste) {
  	super();
  	listeProprietaire = liste;
  }

  // Constructeur pour clonage
  public CDroite(CListeObjets liste,CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit,
    boolean masqueInit, String nomInit, int indiceTailleNomInit,
    int styleInit, double abscisseNomInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit, dec_xInit, dec_yInit,
      masqueInit, nomInit, indiceTailleNomInit, styleInit);
    // Vecteur a dj t cr par le constructeur de CDroiteAncetre
    // vecteur = new VecteurDirecteur();
    abscisseNom = abscisseNomInit;
  }
  /** Constructeur pour les descendants de Cdroite n'ayant pas besoin d'tre nomms */
  public CDroite(CListeObjets liste,CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit);
    // Vecteur a dj t cr par le constructeur de CDroiteAncetre
    //vecteur = new VecteurDirecteur();
    abscisseNom = abscisseNomParDefaut;
  }
  /** Constructeur pour les descendants de Cdroite ayant besoin d'tre nomms avec un nom vide */
  /** Constructeur pour les descendants de Cdroite n'ayant pas besoin d'tre nomms */
  public CDroite(CListeObjets liste,CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit, int indiceTailleNomInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit);
    // Vecteur a dj t cr par le constructeur de CDroiteAncetre
    //vecteur = new VecteurDirecteur();
    abscisseNom = abscisseNomParDefaut;
    indiceTailleNom = indiceTailleNomInit;
  }
  
  
  // Pour satisfaire le compilateur, la classe n'tant pas abstract (voir plus haut)
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    return null;
  }
  
  @Override
  public String complementInfo() {
    return textes.Chaines.chinfo40;
  }
  
  // Revu en java : inutile de redfinir dependDe et dependDePourBoucle
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    double a,xa,ya,xb,yb;
    existe = vecteur.nonNul();
    if (!(existe)) return;
    if (vecteur.x == 0) {
      xext1 = point_x;
      yext1 = 0;
      xext2 = point_x;
      yext2 = dimfen.longueurOrdonnees;
      positionneNom();
      return;
    };
    if (vecteur.y == 0) {
      xext1 = 0;
      yext1 = point_y;
      xext2 = dimfen.longueurAbscisses;
      yext2 = point_y;
      positionneNom();
      return;
    }
    a = vecteur.y/vecteur.x;
    xa = 0;
    ya = point_y + a*(xa-point_x);
    if (ya > dimfen.longueurOrdonnees) {
      ya = dimfen.longueurOrdonnees;
      xa = (ya-point_y)/a+point_x;
    } else {
      if (ya < 0) {
        ya = 0;
        xa = (ya-point_y)/a+point_x;
      };
    }
    xb = dimfen.longueurAbscisses;
    yb = a*(xb-point_x)+point_y;
    if (yb > dimfen.longueurOrdonnees) {
      yb = dimfen.longueurOrdonnees;
      xb = (yb-point_y)/a+point_x;
    } else {
      if (yb < 0) {
        yb = 0;
        xb = (yb-point_y)/a+point_x;
      };
    }
    xext1 = xb;
    yext1 = yb;
    xext2 = xa;
    yext2 = ya;
    positionneNom();
  }
  
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    int styleTrait;
    if (masque) styleTrait = StyleTrait.traitPointille;
    else styleTrait = style;
    // Certaines droites servent de faon interne (repres par ex ) et ne sont pas associs  une liste
    pDC.setStroke(Pinceau.CreePinceau(styleTrait));
    pDC.setColor(couleur);
    pDC.drawLine((int) Math.round(xext1),(int) Math.round(yext1),
      (int) Math.round(xext2),(int) Math.round(yext2));
  }
    
  public void positionneNom() {
    placeNom(xext1+abscisseNom*(xext2-xext1),yext1+abscisseNom*(yext2-yext1));
  }
  // Rajout pour la version 2.0
  // Renvoie la chaine que doit tre fugitivement affiche lorsque le pointeur souris
  // se rapproche d'un objet
  // Renvoie null s'il n'y a rien  afficher
  public String chaineDesignation() {
    return textes.Chaines.designationDroite;
  }
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    abscisseNom = inps.readCDouble();
  }
  /* Enregistrement dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    abscisseNom = inps.readDouble();
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeDouble(abscisseNom);
  }     
}