/*
 * CDroiteAB.java
 *
 * Created on 30 juin 2004, 16:09
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CDroiteAB extends CDroite {

  CPointAncetre A;
	CPointAncetre B;

  /** Creates new CDroiteAB */
  public CDroiteAB() {
    super(); // Pour que lengthvecteur soit cr
  }

  // Constructeur pour clonage
  public CDroiteAB(CListeObjets liste, CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit, boolean masqueInit, String nomInit,
    int indiceTailleNomInit, int styleInit, double abscisseNomInit, CPointAncetre AInit,
      CPointAncetre BInit) {
      super(liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit,
        dec_xInit, dec_yInit, masqueInit, nomInit, indiceTailleNomInit, styleInit, abscisseNomInit);
      A = AInit;
      B = BInit;
  } 
  /** Constructeur plus court pour objets visuels */
  public CDroiteAB(CListeObjets liste, CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, int styleInit,  CPointAncetre AInit, CPointAncetre BInit, int indiceTailleNomInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, false, styleInit, indiceTailleNomInit);
    A = AInit;
    B = BInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(A);
    int ind2 = listeSource.indexOf(B);
    int ind3 = listeSource.indexOf(impProto);
    CElementBase ptelb = new CDroiteAB(listeCible,(CImplementationProto)(listeCible.get(ind3,CImplementationProto.class)),
    	estElementFinal, couleur, nomMasque, dec_x, dec_y, masque, nom, indiceTailleNom, style, abscisseNom,
      (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)),(CPointAncetre)(listeCible.get(ind2, CPointAncetre.class)));
    return ptelb;
  }
  // Inutile de redfinir setClone
  
  @Override
  public String infoPourHistorique() {
    return textes.Chaines.chinfo4;
  }

  @Override
  public void ajouteAntecedents(CListeObjets liste) {
    liste.add(A);
    liste.add(B);
  } 
  
  @Override
  public boolean dependDe(CElementBase p) {
  	return super.dependDe(p) || A.dependDe(p) || B.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
  	return ((p == this) || A.dependDePourBoucle(p) || B.dependDePourBoucle(p));
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
		existe = (A.existe) && (B.existe);
		if (!(existe)) return;
		point_x = A.x;
		point_y = A.y;
		vecteur.x = B.x - A.x;
		vecteur.y = B.y - A.y;
		super.positionne(infoRandom, dimfen);
  }  

  /** Rajout pour la version 2.0 : permet de connatre si l'lment point par pt
   * est confondu avec l'lment en question ou trs proche.
   * Pour cette version applet, ne sera redfini que pour les objets que l'utilisateur
   * pourra effectivement crer en ligne.
  **/
  public boolean confonduAvec(CElementBase p) {
    CDroiteAB pt;
    if (p.getClass() == this.getClass()) {
      pt = (CDroiteAB) p;
      return (((A==pt.A) && (B==pt.B)) || ((B==pt.A) && (A==pt.B)));
    }
    else return false;
  }
  
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (A == ancienPoint) A = nouveauPoint;
    if (B == ancienPoint) B = nouveauPoint;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
     super.chargeDepuisFlux(inps, list);
     int ind1 = inps.readCInt();
     int ind2 = inps.readCInt();
     A = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
     B = (CPointAncetre) (list.get(ind2,CPointAncetre.class));
  }
  /* Lecture depuis un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    int ind2 = inps.readInt();
    A = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    B = (CPointAncetre) (list.get(ind2,CPointAncetre.class));
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(A);
    oups.writeInt(ind1);
    int ind2 = list.indexOf(B);
    oups.writeInt(ind2);
  }
  /**
   * Fonction rajoute pour la version 2.1 et servant  savoir si un point
   * est par dfinition sur une droite. Renverra true par exemple
   * si la droite est dfinie par deux points et le point est un de ces deux points
   * ou si le point est li  la droite
   * A t rajout pour amliorer l'outil d'intersection
   * A redfinir pour les descendants quand ncessaire
   * */
  public boolean contientParDefinition(CPointAncetre po)
  {
    return (A == po) || (B == po);
  }
  
  @Override
  public boolean estParalleleParDefinition(CDroiteAncetre dte){
  	return (dte == this) || (A.appartientParDefinition(dte) && B.appartientParDefinition(dte))
  	|| dte.formentDroiteParallele(A, B);
  }
  
}

