/*
 * CDroiteOm.java
 *
 * Created on 12 juillet 2004, 19:08
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.Color;
import java.io.IOException;
import types.DimensionFenetre;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CDroiteOm extends CDroite {
	public CRepere rep;
	public CPointAncetre O;
	public CValeurAssocieeAVariable m;

  /** Creates new CDroiteOm */
  public CDroiteOm() {
  }
  
  // Constructeur pour clonage
  public CDroiteOm(CListeObjets liste, CImplementationProto impProtoInit,boolean estElementFinalInit,
      Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit,
      boolean masqueInit, String nomInit, int indiceTailleNomInit, int styleInit,
      double abscisseNomInit, CRepere repInit, CPointAncetre OInit, CValeurAssocieeAVariable mInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit, dec_xInit, dec_yInit,
      masqueInit, nomInit, indiceTailleNomInit, styleInit, abscisseNomInit);
    rep = repInit;
    O = OInit;
    m = mInit;     
  }
  
  // Constructeur plus court pour cration d'objet
  public CDroiteOm(CListeObjets liste, Color couleurInit, int styleInit, CRepere repInit,
  		CPointAncetre OInit, CValeurAssocieeAVariable mInit, int indiceTailleNomInit) {
  	super(liste, null, false, couleurInit, false, styleInit, indiceTailleNomInit);
    rep = repInit;
    O = OInit;
    m = mInit;       	
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(rep);
    int ind2 = listeSource.indexOf(O);
    int ind3 = listeSource.indexOf(impProto);     
    CValeurAssocieeAVariable mClone = (CValeurAssocieeAVariable) m.getClone(listeSource, listeCible);
    CElementBase ptelb = new CDroiteOm(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, nomMasque, dec_x, dec_y,
      masque, nom, indiceTailleNom, style, abscisseNom, (CRepere)(listeCible.get(ind1, CRepere.class)),
      (CPointAncetre)(listeCible.get(ind2, CPointAncetre.class)), mClone);
    return ptelb;
  }
  
  @Override
  public void ajouteAntecedents(CListeObjets liste) {
    liste.add(O);
  }

  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || O.dependDe(p) || rep.dependDe(p) || m.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return ((p == this) || O.dependDePourBoucle(p) || rep.dependDePourBoucle(p)
      || m.dependDePourBoucle(p));
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	m.positionne(infoRandom, dimfen);
		existe = rep.existe && O.existe && m.existe();
		if (existe)
		{
			point_x = O.x;
			point_y = O.y;
			double k = m.rendValeur(infoRandom);
			vecteur.x = rep.u.x + k*rep.v.x;
			vecteur.y = rep.u.y + k*rep.v.y;
			super.positionne(infoRandom, dimfen);
    }
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    int ind2 = inps.readCInt();
    rep = (CRepere) (list.get(ind1,CRepere.class));
    O = (CPointAncetre) (list.get(ind2,CPointAncetre.class));
    m = new CValeurAssocieeAVariable();
    m.chargeDepuisFlux(inps, list);
  }

  @Override
  public boolean confonduAvec(CElementBase p) {
    CDroiteOm pt;
    if (p.getClass() == this.getClass()) {
      pt = (CDroiteOm) p;
   		return (rep == pt.rep) && (O == pt.O) && m.confonduAvec(pt.m);
    }
    else return false;
  }        

  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (O == ancienPoint) O = nouveauPoint;
  }   

  /* Lecture depuis un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    int ind2 = inps.readInt();
    rep = (CRepere) (list.get(ind1,CRepere.class));
    O = (CPointAncetre) (list.get(ind2,CPointAncetre.class));
    m = new CValeurAssocieeAVariable();
    m.read(inps, list);
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(rep);
    oups.writeInt(ind1);
    int ind2 = list.indexOf(O);
    oups.writeInt(ind2);
    m.write(oups, list);
  }     
  /**
   * Fonction rajoute pour la version 2.1 et servant  savoir si un point
   * est par dfinition sur une droite. Renverra true par exemple
   * si la droite est dfinie par deux points et le point est un de ces deux points
   * ou si le point est li  la droite
   * A t rajout pour amliorer l'outil d'intersection
   * A redfinir pour les descendants quand ncessaire
   * */
  public boolean contientParDefinition(CPointAncetre po)
  {
    return (O == po);
  }
}