/*
 *
 * CFonction.java
 *
 * Created on 6 juillet 2004, 14:38
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;

public class CFonction extends CCalculBase {
	public static String parouv ="(";
	public static String parfer = ")";
	
  int operateurFonction;
  CCalculBase operande;
  boolean dejaPositionne; // ne servira que pour un appel fonction
  // Rand() de gnration d'un nombre alatoire.
  double valeurDejaPrise; // Comme son nom l'indique
  double valeurDejaPriseImaginaire; // Partie imaginaire pour les fonctions complexes
  // Attibut rajout pour optimisation
  Complexe z1 = new Complexe();
  /** Creates new CFonction */
  public CFonction() {
  }
  
  // Constructeur pour clonage
  public CFonction(CListeObjets liste, int operateurFonctionInit, CCalculBase operandeInit) {
    super(liste);
    operateurFonction = operateurFonctionInit;
    operande = operandeInit;
  }

  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CCalculBase cloneOperande = operande.getClone(listeSource, listeCible); 
    CCalculBase ptcalc = new CFonction(listeCible, operateurFonction, cloneOperande);
    return ptcalc;
  }

  public boolean dependDe(CElementBase p) {
    return operande.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    // Attention : modifi en java par rapport au C++
    if (operateurFonction == OperateurFonction.Rand) 
    {
      if (p instanceof CVariableBornee) return true;
        else return operande.dependDePourBoucle(p);
    }
    else return operande.dependDePourBoucle(p);
  }

  boolean existe() {
    return operande.existe();
  }

  public double resultatBase(boolean infoRandom, double x) throws ErreurCalculException {
    switch (operateurFonction)
    {
      case OperateurFonction.Abso:
        return Math.abs(x);
      case OperateurFonction.Enti:
        return Math.floor(x);
      case OperateurFonction.Raci:
      case OperateurFonction.Raci2:
        if (x >= 0)
          return Math.sqrt(x);
        else throw new ErreurCalculException();
      case OperateurFonction.Sinu:
        if (listeProprietaire.uniteAngle == UniteAngle.Radian) return CCalculBase.sinus(x);
        else return CCalculBase.sinus(x*Kernel.ConvDegRad);
      case OperateurFonction.Cosi:
        if (listeProprietaire.uniteAngle == UniteAngle.Radian) return CCalculBase.cosinus(x);
        else return CCalculBase.cosinus(x*Kernel.ConvDegRad);
      case OperateurFonction.Tang:
        if (listeProprietaire.uniteAngle == UniteAngle.Radian) return CCalculBase.tangente(x);
        else {
          return CCalculBase.tangente(x*Kernel.ConvDegRad);
        }
      case OperateurFonction.Logn:
        if (x>0) return Math.log(x);
        else throw new ErreurCalculException();
      case OperateurFonction.Expo:
        return Math.exp(x);
      case OperateurFonction.ATan:
        if (listeProprietaire.uniteAngle == UniteAngle.Radian) return Math.atan(x);
        else return Math.atan(x)*Kernel.ConvRadDeg;
      case OperateurFonction.ACos:
        if (listeProprietaire.uniteAngle == UniteAngle.Radian) return Math.acos(x);
        else return Math.acos(x)*Kernel.ConvRadDeg;
      case OperateurFonction.ASin:
        if (listeProprietaire.uniteAngle == UniteAngle.Radian) return Math.asin(x);
        else return Math.asin(x)*Kernel.ConvRadDeg;
      case OperateurFonction.Cosh:
        return (Math.exp(x) + Math.exp(-x))/2;
      case OperateurFonction.Sinh:
        return (Math.exp(x) - Math.exp(-x))/2;
      case OperateurFonction.Tanh:
        return (Math.exp(2*x) - 1)/(Math.exp(2*x) + 1);
      case OperateurFonction.ArgCh:
        if (x >= 1) return Math.log(x + Math.sqrt(x*x-1));
        else throw new ErreurCalculException();
      case OperateurFonction.ArgSh:
    		return Math.log(x + Math.sqrt(x*x+1));
      case OperateurFonction.ArgTh:
        if ((x > -1) && (x < 1 )) return 0.5*Math.log((1+x)/(1-x));
        else throw new ErreurCalculException();
      case OperateurFonction.Rand:
        if (infoRandom)
        {
          valeurDejaPrise = Math.random();
          dejaPositionne = true;
          return valeurDejaPrise;
        }
        else
        {
          if (!dejaPositionne)
          {
            valeurDejaPrise = Math.random();
            dejaPositionne = true;
            return valeurDejaPrise;
          }
          else return valeurDejaPrise;
        }
      default : throw new ErreurCalculException();
    }// switch OperateurFonction}
  }
  public double resultat(boolean infoRandom) throws ErreurCalculException {
    double x1 = operande.resultat(infoRandom);
    return resultatBase(infoRandom, x1);
  }

  public double resultatFonction(boolean infoRandom, double valeurParametre) throws ErreurCalculException {
    double x1 = operande.resultatFonction(infoRandom, valeurParametre);
    return resultatBase(infoRandom, x1);

  }
  void resultatComplexeBase(boolean infoRandom, Complexe z, Complexe zRes)  throws ErreurCalculException {
    switch (operateurFonction)
    {
      case OperateurFonction.Abs:
              zRes.y = 0;
              zRes.x = z.module();
              return;
      case OperateurFonction.Sin:
              z.sinComp(listeProprietaire.uniteAngle, zRes);
              return;
      case OperateurFonction.Cos:
              z.cosComp(listeProprietaire.uniteAngle, zRes);
              return;
      case OperateurFonction.Tan:
              z.tanComp(listeProprietaire.uniteAngle, zRes);
              return;
      case OperateurFonction.Log:
              z.lnComp(listeProprietaire.uniteAngle, zRes);
              return;
      case OperateurFonction.Exp:
              z.expComp(listeProprietaire.uniteAngle, zRes);
              return;
      case OperateurFonction.Ch:
              z.chComp(listeProprietaire.uniteAngle, zRes);
              return;
      case OperateurFonction.Sh:
              z.shComp(listeProprietaire.uniteAngle,zRes);
              return;
      case OperateurFonction.Th:
              z.thComp(listeProprietaire.uniteAngle,zRes);
              return;
      case OperateurFonction.Rnd:
        if (infoRandom)
        {
          valeurDejaPrise = Math.random();
          valeurDejaPriseImaginaire = Math.random();;
          zRes.x = valeurDejaPrise;
          zRes.y = valeurDejaPriseImaginaire;
          dejaPositionne = true;
          return;
        }
        else
        {
          if (infoRandom)
          {
            zRes.x = Math.random();
            zRes.y = Math.random();
          }
          else
          {
            if (!dejaPositionne)
            {
              zRes.x = Math.random();
              zRes.y = Math.random();
              valeurDejaPrise = zRes.x;
              valeurDejaPriseImaginaire = zRes.y;
              dejaPositionne = true;
              return;
            }
            else
            {
              zRes.x = valeurDejaPrise;
              zRes.y = valeurDejaPriseImaginaire;
              return;
            }
          }
        }
        break;
      case OperateurFonction.Conj:
        zRes.x = z.x;
        zRes.y = -z.y;
        return;
      case OperateurFonction.Arg:
        if ((z.x == 0) && (z.y == 0))
        {
          zRes.x = 0;
          zRes.y = 0;
          throw new ErreurCalculException();
        }
        else
        {
          zRes.x = z.argument(listeProprietaire.uniteAngle);
          zRes.y = 0;
          return;
        }
      case OperateurFonction.Re:
        zRes.x = z.x;
        zRes.y = 0;
        return;
      case OperateurFonction.Im:
        zRes.x = z.y;
        zRes.y = 0;
        return;
      case OperateurFonction.Rac:
      case OperateurFonction.Rac2:
        zRes.x = 0;
        zRes.y = 0;
        if ((z.y != 0) || (z.x <0))
        {
          throw new ErreurCalculException();
        }
        else
        {
          zRes.x = Math.sqrt(z.x);
          return;
        }
      case OperateurFonction.EntiC :
        zRes.x = 0;
        zRes.y = 0;
        if (z.y != 0)
        {
          throw new ErreurCalculException();
        }
        else
        {
          zRes.x = Math.floor(z.x);
          return;
        }
      case OperateurFonction.ACosC :
        // le rsultat n'existe que si l'argument est rel
        zRes.x = 0;
        zRes.y = 0;
        if (z.y != 0)
        {
          throw new ErreurCalculException();
        }
        else
        {
          zRes.x = Math.acos(z.x);
          return;
        }
      case OperateurFonction.ASinC :
        // le rsultat n'existe que si l'argument est rel
        // le rsultat n'existe que si l'argument est rel
        zRes.x = 0;
        zRes.y = 0;
        if (z.y != 0)
        {
          throw new ErreurCalculException();
        }
        else
        {
          zRes.x = Math.asin(z.x);
          return;
        }
      case OperateurFonction.ATanC :
        // le rsultat n'existe que si l'argument est rel
        zRes.x = 0;
        zRes.y = 0;
        if (z.y != 0)
        {
          throw new ErreurCalculException();
        }
        else
        {
          zRes.x = Math.atan(z.x);
          return;
        }
      case OperateurFonction.ArgChC :
        // le rsultat n'existe que si l'argument est rel
        zRes.x = 0;
        zRes.y = 0;
        if (z.y != 0)
        {
          throw new ErreurCalculException();
        }
        else
        {
          if (z.x >= 1) zRes.x = Math.log(z.x + Math.sqrt(z.x*z.x-1));
          else throw new ErreurCalculException();
        }
        break;
      case OperateurFonction.ArgShC :
        // le rsultat n'existe que si l'argument est rel
        zRes.x = 0;
        zRes.y = 0;
        if (z.y != 0)
        {
          throw new ErreurCalculException();
        }
        else
        {
          zRes.x = Math.log(z.x + Math.sqrt(z.x*z.x+1));
          return;
        }
      case OperateurFonction.ArgThC :
        // le rsultat n'existe que si l'argument est rel
        zRes.x = 0;
        zRes.y = 0;
        if (z.y != 0)
        {
          throw new ErreurCalculException();
        }
        else
        {
          if ((z.x > -1) && (z.x < 1 )) zRes.x = 0.5*Math.log((1+z.x)/(1-z.x));
          else throw new ErreurCalculException();
        }
    }; // switch OperateurFonction}    
  }
  public void resultatComplexe(boolean infoRandom, Complexe zRes)  throws ErreurCalculException {
    operande.resultatComplexe(infoRandom, z1);
    resultatComplexeBase(infoRandom, z1, zRes);
  }
  void  resultatFonctionComplexe(boolean infoRandom, Complexe valeurParametre, Complexe zRes)
    throws ErreurCalculException 
  {
    operande.resultatFonctionComplexe(infoRandom, valeurParametre, z1);
    resultatComplexeBase(infoRandom, z1, zRes);
  }
  
  public boolean  dependDeVariable() {
    return operande.dependDeVariable();
  }
  public CCalculBase getCopie() {
   	return new CFonction(listeProprietaire, operateurFonction, operande.getCopie());
  }
  
  @Override
	public String chaineCalcul(String varFor) {
  	String cha = operande.chaineCalculSansPar(varFor);

  	switch (operateurFonction)
  	{
  		case OperateurFonction.Abso:
  		case OperateurFonction.Abs:
  			return textes.Chaines.abs + parouv + cha + parfer;
  		case OperateurFonction.Enti:
  		case OperateurFonction.EntiC:
  			return textes.Chaines.intgr + parouv + cha + parfer;
  		case OperateurFonction.Raci:
  		case OperateurFonction.Raci2:
  		case OperateurFonction.Rac:
  		case OperateurFonction.Rac2:
  			return textes.Chaines.sqrt + parouv + cha + parfer;
  		case OperateurFonction.Sinu:
  		case OperateurFonction.Sin:
  			return textes.Chaines.sin + parouv + cha + parfer;
  		case OperateurFonction.Cosi:
  		case OperateurFonction.Cos:
  			return textes.Chaines.cos + parouv + cha + parfer;
  		case OperateurFonction.Tang:
  		case OperateurFonction.Tan:
  			return textes.Chaines.tan + parouv + cha + parfer;
  		case OperateurFonction.Logn:
  		case OperateurFonction.Log:
  			return textes.Chaines.ln + parouv + cha + parfer;
  		case OperateurFonction.Expo:
  		case OperateurFonction.Exp:
  			return textes.Chaines.exp + parouv + cha + parfer;
  		case OperateurFonction.ATan:
  		case OperateurFonction.ATanC:
  			return textes.Chaines.arctan + parouv + cha + parfer;
  		case OperateurFonction.ACos:
  		case OperateurFonction.ACosC:
  			return textes.Chaines.arccos + parouv + cha + parfer;
  		case OperateurFonction.ASin:
  		case OperateurFonction.ASinC:
  			return textes.Chaines.arcsin + parouv + cha + parfer;
  		case OperateurFonction.Cosh:
  		case OperateurFonction.Ch:
  			return textes.Chaines.ch + parouv + cha + parfer;
  		case OperateurFonction.Sinh:
  		case OperateurFonction.Sh:
  			return textes.Chaines.sh + parouv + cha + parfer;
  		case OperateurFonction.Tanh:
  		case OperateurFonction.Th:
  			return textes.Chaines.th + parouv + cha + parfer;
  		// A revoir ici. Pour la version 1.5 j'ai oublie le ArgCh
  		case OperateurFonction.ArgCh:
  		case OperateurFonction.ArgChC:
  			return textes.Chaines.argch + parouv + cha + parfer;
  		case OperateurFonction.ArgSh:
  		case OperateurFonction.ArgShC:
  			return textes.Chaines.argsh + parouv + cha + parfer;
  		case OperateurFonction.ArgTh:
  		case OperateurFonction.ArgThC:
  			return textes.Chaines.argth + parouv + cha + parfer;
  		case OperateurFonction.Rand:
  			return textes.Chaines.rand + parouv + cha + parfer;
  		case OperateurFonction.Conj:
  			return textes.Chaines.conj + parouv + cha + parfer;
  		case OperateurFonction.Arg:
  			return textes.Chaines.arg + parouv + cha + parfer;
  		case OperateurFonction.Re:
  			return textes.Chaines.re + parouv + cha + parfer;
  		case OperateurFonction.Im:
  			return textes.Chaines.im + parouv + cha + parfer;

  		default:
  			return "";
  	} // switch OperateurFonction}}
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    operateurFonction = inps.readByte();
    operande = (CCalculBase) inps.readCObject(list);
		if ((listeProprietaire.numeroVersion > 3) && (operateurFonction ==OperateurFonction.Rand))
		{
			valeurDejaPrise= inps.readCDouble();
			dejaPositionne = true;
    }
  }
  /* Lecture depuis un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    operateurFonction = inps.readByte();
    operande = (CCalculBase) inps.readObject(list);
		if (operateurFonction == OperateurFonction.Rand)
		{
			valeurDejaPrise= inps.readDouble();
			dejaPositionne = true;
    }
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeByte(operateurFonction);
    oups.writeObject(operande);
		if (operateurFonction == OperateurFonction.Rand)
		{
      oups.writeDouble(valeurDejaPrise);
    }
  }
  
  @Override
	public boolean estConstant() {
		return (operateurFonction != OperateurFonction.Rand) && operande.estConstant();
	}
  
}
