/*
 * CImplementationProto.java
 *
 * Created on 9 aot 2007, 12:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;

import java.io.*;
import types.NatureCalcul;
import types.NatureObjet;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

/**
 * 
 * @author Yves
 */
public class CImplementationProto extends CElementBase {
	public String nomProto; // Le nom du prototype qui l'a gnr
	public int nbIntermediaires;
	public int nbFinaux;
	public CSousListeObjets listeSources;

	/** Creates a new instance of CImplementationProto */
	public CImplementationProto() {
		listeSources = new CSousListeObjets();
	}

	/**
	 * Constructeur pour clonage
	 */
	public CImplementationProto(CListeObjets liste, String nomProtoInit, int nbIntermediairesInit,
			int nbFinauxInit, CSousListeObjets listeSourcesInit) {
		super(liste, null, false);
		nomProto = nomProtoInit;
		nbIntermediaires = nbIntermediairesInit;
		nbFinaux = nbFinauxInit;
		listeSources = listeSourcesInit;
	}

	/**
	 * Constructeur pour implmentation  partir d'un protoype Avanat appel les
	 * lments gnriques du prototype ont t mis  pointer sur les objets
	 * sources dans liste
	 * 
	 * @param liste
	 * @param nomProtoInit
	 * @param nbIntermediairesInit
	 * @param nbFinauxInit
	 */
	public CImplementationProto(CListeObjets liste, CPrototype proto) {
		super(liste, null, false);
		nomProto = proto.nom;
		listeSources = new CSousListeObjets();
		int nbSources = proto.nbObjSources;
		for (int i = 0; i < nbSources; i++) {
			listeSources.add(((CElementGenerique) proto.get(i)).elementAssocie);
		}
		nbFinaux = proto.nbObjFinaux;
		nbIntermediaires = proto.size() - nbSources - nbFinaux;
	}

  @Override
	public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
		CSousListeObjets listeSourcesClone = new CSousListeObjets();
		listeSourcesClone.setImage(listeSources, listeSource, listeCible);
		CElementBase ptelb = new CImplementationProto(listeCible, nomProto, nbIntermediaires, nbFinaux,
				listeSourcesClone);
		return ptelb;
	}

	public final CElementBase dernierObjetFinal() {
		int ind = listeProprietaire.indexOf(this);
		return listeProprietaire.get(ind + nbIntermediaires + nbFinaux);
	}

	@Override
	public boolean dependDe(CElementBase p) {
		return super.dependDe(p) || listeSources.dependDe(p);
	}


	@Override
	public long getNature() {
		return NatureObjet.NImplementationProto;
	}

	public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
		listeSources.remplacePoint(ancienPoint, nouveauPoint);
	}



	/**
	 * Fonction renvoyant le nombre d'objets finaux de type calcul ayant un nom
	 * Est utilis lors de la fin de l'implmentation d'une construction pour
	 * proposer de renommer ces calculs
	 * 
	 * @return
	 */
	public int nombreObjetsFinauxTypeCalculNommes() {
		int res = 0;
		int ind = listeProprietaire.indexOf(this);
		for (int i = ind + 1; i <= ind + nbFinaux + nbIntermediaires; i++) {
			CElementBase elb = listeProprietaire.get(i);
			if (elb.estElementFinal && ((elb.getNatureCalcul() & NatureCalcul.NToutCalculNommeSaufConst) != 0))
				res++;
		}
		return res;
	}

	// chargeDepuisFlux a t ajout  la version 2.5 pour cause d'implmentation
	// de prototype
	public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
		super.chargeDepuisFlux(inps, list);
		nomProto = inps.readCString();
		nbIntermediaires = inps.readCInt();
		nbFinaux = inps.readCInt();
		listeSources.chargeDepuisFlux(inps, list);
	}

	/* Enregistrement dans un flux java */
	public void read(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
		super.read(inps, list);
		nomProto = inps.readUTF();
		nbIntermediaires = inps.readInt();
		nbFinaux = inps.readInt();
		listeSources.read(inps, list);
	}

	/* Enregistrement dans un flux java */
	public void write(MathGraphDataOutputStream oups, CListeObjets list) throws IOException {
		super.write(oups, list);
		oups.writeUTF(nomProto);
		oups.writeInt(nbIntermediaires);
		oups.writeInt(nbFinaux);
		listeSources.write(oups, listeProprietaire);
	}
}
