package objets;

import java.awt.Color;
import java.awt.Graphics2D;
import java.io.IOException;
import java.util.StringTokenizer;

import javax.swing.JLabel;


import org.scilab.forge.jlatexmath.TeXConstants;
import org.scilab.forge.jlatexmath.TeXFormula;
import org.scilab.forge.jlatexmath.TeXIcon;
import org.scilab.forge.jlatexmath.dynamic.DynamicAtom;
import org.scilab.forge.jlatexmath.dynamic.ExternalConverter;
import org.scilab.forge.jlatexmath.dynamic.ExternalConverterFactory;

import Applet.MtgConverter;
import entreesSorties.MathGraphDataInputStream;
import types.DimensionFenetre;
import types.NatureObjet;
import types.Pinceau;
import types.StyleEncadrement;
import types.StyleTrait;

public class CLatex extends CCommentaire implements ExternalConverterFactory {
	private TeXIcon icon;
	public TeXFormula formula;
	private JLabel jl = new JLabel(); // Sert  afficher l'image de l'icne
	// Correspondance entre les indices de taille et la taille pour l'affichage latex
	private static final float tailleLatex[] = {12,14,16,18,20,25,30};
	private MtgConverter mtgConverter;
	private boolean codeLatexOK;
  
  /** Creates new CLatex */
  public CLatex() {
  	mtgConverter = new MtgConverter(this);
  }

	/**
	 * Constructeur
	 */
  public CLatex(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String chaineCommentaireInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit,
          indiceTaillePoliceInit, encadrementInit, effacementFondInit, couleurFondInit, chaineCommentaireInit);
    mtgConverter = new MtgConverter(this);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    // Corrig lors de la version 2.0
    int ind1 = listeSource.indexOf(pointLie);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CLatex(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y,
      masque, (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, chaineCommentaire);
    ((CCommentaire) ptelb).listeValeursDynamiquesUtilisees = 
      new CListeObjets(listeCible.uniteAngle, listeCible.pointeurLongueurUnite);
    if (listeCible.getClass() != CPrototype.class) {
    	((CLatex) ptelb).determineDependances();
    	((CLatex) ptelb).creeFormule();
    }
    return ptelb;
  }  
	
  /**
   * Cas particulier : dans le cas o le code latex est erron, renvoie une chaine standard  afficher  l'cran
   * Dans ce cas c'est super.affiche qui est appel
   */
  @Override
  public String rendChaineAffichage(boolean infoRandom) {
  	return textes.Chaines.ch170;
  }
   
  public synchronized void creeFormule() {
  	DynamicAtom.setExternalConverterFactory(this);
  	try {
  		if (chaineCommentaire.startsWith("$") && chaineCommentaire.endsWith("$"))
  			formula =  new TeXFormula(chaineCommentaire.substring(1, chaineCommentaire.length() - 1));
  			else formula =  new TeXFormula(chaineCommentaire);
  	}
  	catch (Exception e) {
			formula = null;
		}
  }
  /**
   * Doit tre appel lors de la srialization (chargement), lors de la cration d'un
   * commentaire ou de sa modification.
   * Est similaire  Positionne() et doit le rester
   */
  public void determineDependances()
  {
    listeValeursDynamiquesUtilisees.retireTout();
    // On examine la chaine  la recherche de #Val(
    int len = chaineCommentaire.length();
    int jdeb;
    int j = 0;
    if (chaineCommentaire.indexOf("\\Val{",j) == -1) return;
    while (((jdeb = chaineCommentaire.indexOf("\\Val{",j)) != -1) && j < len)
    {
      // On recherche la parenthse fermante correspondante
      int indparf = chaineCommentaire.indexOf('}',jdeb + 5);
      if (indparf == -1)
      {
        j = len + 1;
      }
      else
      {
        // On recherche aussi un ventuel retour  la ligne
        int indsaut = chaineCommentaire.indexOf('\n',jdeb + 5);
        if ((indsaut !=  -1) && (indsaut < indparf))
        {
          j = indsaut + 1;
        }
        else
        {
          // On cre une chaine form de ce qu'il y a entre \Val( et la parenthse fermante
          String ch = chaineCommentaire.substring(jdeb+5, indparf);
          // On retire les ventuels espaces de cete chaine
          int k;
          while((k = ch.indexOf(' ', 0)) != - 1)
          {
            ch = ch.substring(0,k) + ch.substring(k+1);
          }
          // On spare cette chaine avec les virgules
          StringTokenizer st = new StringTokenizer(ch, ",",false);
          if (! st.hasMoreTokens())
          {
            j = indparf + 1;
          }
          else
          {
            String nomvaleur = st.nextToken();
            // On recherche si c'est bien le nom d'une valeur valide
            // Il ne faut pas que la valeur ait t dfinie aprs l'affichage de valeur
            int indicecommentaire = listeProprietaire.indexOf(this);
            // Trs important : quand determineDependances est appel
            // par getClone() de CCommentaire, le commentaire n'a pas encor t rajout
            //  la liste clone et ainsi indiceCommentaire renvoie -1.
            // dans ce cas, indiceCommentaire doit valoir le nombre d'lments actuels
            // de la liste clone qui le possde
            if (indicecommentaire == -1) indicecommentaire = listeProprietaire.size() - 1;
            CValeurDynamique pValeur = listeProprietaire.pointeurValeurPourLatex(nomvaleur,indicecommentaire);
            if (pValeur == null)
            {
              j = indparf + 1;
            }
            else
            {
              listeValeursDynamiquesUtilisees.add(pValeur);
              // Si la valeur n'existe pas, on ne l'inclut pas dans la chane  afficher
              j = indparf + 1;
            }
          }
        }
      }		
    }
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	// super.positionne(infoRandom, dimfen);
  	if (formula == null) {
  		codeLatexOK = false;
  		super.positionnePourCLatex(infoRandom, dimfen);
  	}
  	else {
    	super.positionnePourCLatex(infoRandom, dimfen);  		
	  	mtgConverter.autoriseTiragesAleatoires(infoRandom);
	  	try {
	  		// formula =  new TeXFormula(chaineAffichage);
	      boolean basseDefinition = listeProprietaire.basseDefinition;
	  		
	  		if (basseDefinition) icon = formula.createTeXIcon(TeXConstants.STYLE_DISPLAY, tailleLatex[indiceTaillePolice]);
	  		else icon = formula.createTeXIcon(TeXConstants.STYLE_DISPLAY, 120);
		  	codeLatexOK = true;
	  	}
	  	catch (Exception e) {
	  		// formula = null;
	  		codeLatexOK = false;
	  		super.positionne(infoRandom, dimfen);
	  	}
  	}
  }
  
  @Override
  public void remplaceNomValeurDynamique(String ancienNom, String nouveauNom) {
  	String ch1 = "\\Val{" + ancienNom + "}";
  	String ch2 = "\\Val{" + nouveauNom + "}";
  	chaineCommentaire = chaineCommentaire.replace(ch1, ch2);
  	ch1 = "\\Val{" + ancienNom + ",";
  	ch2 = "\\Val{" + nouveauNom + ",";
  	chaineCommentaire = chaineCommentaire.replace(ch1, ch2);
  }
  
  public void affiche(Graphics2D pDC, boolean masquage, Color couleurFond, float transparence) {
  	// Il faut afficher un tel objet mme avec l'outil rideau quand il est masqu
  	if (!masque || (masque && !masquage)) {
	  	if (!codeLatexOK  || (formula == null)) {
	  		super.affiche(pDC, masquage, couleurFond, transparence);
	  		return;
	  	}
      rectangleAffichage.x = (int) (x_nom + dec_x);
      rectangleAffichage.y = (int) (y_nom + dec_y);
      rectangleAffichage.width = icon.getIconWidth();
      rectangleAffichage.height = icon.getIconHeight();
      trace(pDC, couleurFond, transparence);
    }
  }
  
  
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
  	if (!codeLatexOK) {
  		super.trace(pDC, couleurFond, transparence);
  		return;
  	}
    boolean basseDefinition = listeProprietaire.basseDefinition;
    // if ((chaineAffichage.length() == 0)) return;
    pDC.setStroke(Pinceau.CreePinceau(StyleTrait.traitFin)); // Pour le rectangle
    // d'encadrement ventuel et les flches de vecteur ventuelles
    if (basseDefinition) {
	    xEncadrement = rectangleAffichage.x - 3;
	    yEncadrement = rectangleAffichage.y - 2;
	    widthEncadrement = rectangleAffichage.width + 5;
	    heightEncadrement = rectangleAffichage.height + 2;
    } else {
      // Les dimensions suivantes sont diffrentes dans l'applet car l'espace de coordonnes est 100 fois plus grand
      // et il y a des problmes d'arrondi
      xEncadrement = rectangleAffichage.x - 40;
      yEncadrement = rectangleAffichage.y - 30;
      widthEncadrement = rectangleAffichage.width + 100;
      heightEncadrement = rectangleAffichage.height + 50;    	
    }
    
 
    if (effacementFond) {
      pDC.setColor(couleurFondAffichage);
      // Les bords bas et droits ne sont pas compris semble-t-il par fillRect
      // Diffrence par rapport  la version C++ V1.8
      if (encadrement != 0)
        pDC.fillRect(xEncadrement, yEncadrement, widthEncadrement, heightEncadrement);
      else
        pDC.fillRect(rectangleAffichage.x, rectangleAffichage.y,
          rectangleAffichage.width, rectangleAffichage.height);
      
    }
    pDC.setColor(couleur);
   	jl.setForeground(couleur);
   	icon.paintIcon(jl, pDC, rectangleAffichage.x, rectangleAffichage.y); 
    
    if (encadrement != 0) {
      pDC.setColor(couleur);
      pDC.drawRect(xEncadrement, yEncadrement, widthEncadrement, heightEncadrement);
    }
    
    if (encadrement == StyleEncadrement.Effet3D) {
    	if (basseDefinition) {
	      int x1 = xEncadrement + widthEncadrement + 1;
	      int y1 = yEncadrement + heightEncadrement + 1;
	      pDC.drawLine(xEncadrement + 1, y1, x1, y1);
	      pDC.drawLine(x1, yEncadrement + 1, x1, y1);
    	}
    	else {
    		int x = xEncadrement + widthEncadrement;
    		int y = yEncadrement + heightEncadrement;
        int x1 = x + 10;
        int y1 = y + 10;
        for (int j = 1; j <= 10; j++) {
	        pDC.drawLine(xEncadrement + j, y + j, x1, y + j);
	        pDC.drawLine(x + j, yEncadrement + j, x + j, y1);
        }
    	}
    }
  }  

  // A revoir
  @Override
  public long getNature() {
    return NatureObjet.NLatex;
  }
   
   @Override
	// Il faut redfinir read car il faut crer la formule une fois la chane carhe
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
   	mtgConverter = new MtgConverter(this);
    if (list.getClass() != CPrototype.class) creeFormule();
  }  


	public ExternalConverter getExternalConverter() {
		return mtgConverter;
	}	
   
}
