/*
 * CLieuDiscretParPointLie.java
 *
 * Created on 15 juillet 2004, 10:54
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;
import java.awt.Color;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;


public class CLieuDiscretParPointLie extends CLieuDiscretDeBase {
  CPointLie pointLieGenerateur;// le point li gnrateur du lieu
  
  /** Creates new CLieuDiscretParPointLie */
  public CLieuDiscretParPointLie() {
  }
  
  // Constructeur pour clonage
  public CLieuDiscretParPointLie(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, CPointAncetre pointATracerInit, int nombreDePointsInit, int motifInit, CPointLie pointLieGenerateurInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit,
      masqueInit, pointATracerInit, nombreDePointsInit, motifInit);
    pointLieGenerateur = pointLieGenerateurInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    
    int ind1 = listeSource.indexOf(pointATracer);
    int ind2 = listeSource.indexOf(pointLieGenerateur);
    int ind3 = listeSource.indexOf(impProto);
    CElementBase ptelb = new CLieuDiscretParPointLie(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, masque, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)),
      nombreDePoints, motif, (CPointLie)(listeCible.get(ind2, CPointLie.class)));
    if (listeCible.getClass() != CPrototype.class) {
	    ((CLieuDiscretParPointLie) ptelb).listeElementsAncetres = new CListeObjets(listeCible.uniteAngle, listeCible.pointeurLongueurUnite);
	    listeElementsAncetres.setImage(((CLieuDiscretParPointLie)ptelb).listeElementsAncetres, ptelb.listeProprietaire,
	      listeProprietaire);
    }
    return ptelb;
  }
  
  // Un membre ayant t rajout et servant lors du positionnement, il faut redfinir setClone()
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    indiceDernierPointTrace = ((CLieuDiscretParPointLie) ptel).indiceDernierPointTrace;
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListeElementsAncetres();
  }
  
  // Inutile de redfinir dependDe() var le point  tracer dpend du point li gnrateur  
  public boolean dependDePourCapture(CElementBase p) {
    // Un lieu de points n'a pas  tre redessin si on bouge le point
    // li qui l'a engendr}
    return ((p == this) || (pointATracer.dependDe(p) && (p != pointLieGenerateur)));
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    double abscisseMini, abscisseMaxi, abscisse, abscisseInitiale, pas;
    
    if (!pointLieGenerateur.existe) {
      existe = false;
      return;
    };
    abscisseMini = pointLieGenerateur.abscisseMinimale();
    abscisseMaxi = pointLieGenerateur.abscisseMaximale();
    if (abscisseMini == abscisseMaxi) {
      existe = false;
      return;
    } else {
      // On range dans l'ordre croissant
      if (abscisseMini > abscisseMaxi) {
        double d = abscisseMini;
        abscisseMini = abscisseMaxi;
        abscisseMaxi = d;
      }
    }
    abscisseInitiale = pointLieGenerateur.abscisse;
    // Modification pour la version 1.9.5
    int nbValeurs;
    if (pointLieGenerateur.lieALigneFermee()) nbValeurs = nombreDePoints;
    else nbValeurs = nombreDePoints - 1;
    pas = (abscisseMaxi-abscisseMini)/nbValeurs;
    abscisse = abscisseMini - pas;
    indiceDernierPointTrace = -1;
    for (int i = 0; i < nombreDePoints; i++) {
      abscisse = abscisse + pas;
      pointLieGenerateur.donneAbscisse(abscisse);
      listeElementsAncetres.positionne(infoRandom, dimfen);
      if (pointATracer.existe) {
        if (Kernel.testToile(pointATracer.x, pointATracer.y)) {
          indiceDernierPointTrace++;
          abscissesCoordonneesPoints[indiceDernierPointTrace] = (int)Math.round(pointATracer.x);
          ordonneesCoordonneesPoints[indiceDernierPointTrace] = (int)Math.round(pointATracer.y);
        }
      }
    } // for
    
    // On  remet le point anctre  sa position initiale
    pointLieGenerateur.donneAbscisse(abscisseInitiale);
    listeElementsAncetres.positionne(infoRandom, dimfen);
    if (indiceDernierPointTrace >= 0)
      existe = true;
    else existe = false;
  }
  
  public boolean confonduAvec(CElementBase p) {
    CLieuDePoints pt;
    if (p.getClass() == this.getClass()) {
      pt = (CLieuDePoints) p;
      return (pointATracer == pt.pointATracer) && (pointLieGenerateur == pt.pointLieGenerateur);
    } else return false;
  }
  
  public void etablitListeElementsAncetres() {
    int indicePointATracer = listeProprietaire.indexOf(pointATracer);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    listeElementsAncetres.retireTout();
    if (listeProprietaire.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(listeProprietaire.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }	
  }
  
	/**
	 * Fonction renvoyant true si l'objet dpend des positions gnres pas les dplacements d'un point li
	 * A redfinir pour les lieux de points et lieux d'objets et macros utilisant les dplacements d'un point li
	 * @param pointlie
	 * @return
	 */
  @Override
	public boolean estGenereParPointLie(CPointLie pointlie) {
		return pointLieGenerateur == pointlie;
	}
  
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointLieGenerateur = (CPointLie) (list.get(ind1,CPointLie.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indicePointATracer = list.indexOf(pointATracer);
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointLieGenerateur = (CPointLie) (list.get(ind1,CPointLie.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indicePointATracer = list.indexOf(pointATracer);
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((pointATracer.dependDe(ptelb)) && (ptelb.dependDe(pointLieGenerateur)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointLieGenerateur);
    oups.writeInt(ind1);
  }   
}
