/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;

import Applet.AppletMathGraph32;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import java.applet.AudioClip;
import java.awt.Color;

public class CMacroJouantSon extends CMacro {
  public AudioClip clip;
  public String wavePath;
  // Plus de membre executionArrierePlan dans la version java
	// boolean executionArrierePlan;

  /** Creates new CMacroJouantSon */
  public CMacroJouantSon() {
    clip = null;
  }
  
  // Constructeur pour clonage
  public CMacroJouantSon(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit,  boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      String wavePathInit, int alignementHorizontalInit, int alignementVerticalInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit,
					alignementHorizontalInit, alignementVerticalInit);
        wavePath = wavePathInit;
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie); 
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroJouantSon(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, wavePath, alignementHorizontal, alignementVertical);
    ((CMacroJouantSon) ptelb).clip = this.clip;
    return ptelb;  
  }
  
  // Le clip audio est maintenant charg par un Thread en tche de fond
  public void actionAvantExecution(AppletMathGraph32 applet) {
    clip.stop();
    clip.play();
  }
  
  public boolean executionPossible() {
    return (clip != null);
  }
  
  // mthode qui ne sera redfinie que pour les macros jouant un fichier sonore.
  // Pour celles-ci, lengthfichier sonore est charg via un Thread et il faut savoir
  // quand lengthclip est fini de charger par le Thread
  boolean chargementSonOK() {
    return (clip != null);
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    wavePath = inps.readCString();
    @SuppressWarnings("unused")
		boolean executionArrierePlan = inps.readBoolean();   // Plus utilis en java
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    wavePath = inps.readUTF();
  }
  
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeUTF(wavePath);
  }  
}
