/*
 * CMacroSuiteMacros.java
 *
 * Created on 19 aot 2004, 14:43
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.util.*;
import java.awt.Color;
import Applet.AppletMathGraph32;

public class CMacroSuiteMacros extends CMacroAvecListe {
  private int indiceMacroEnCours; // Indice de la macro en cours d'excution

  /** Creates new CMacroSuiteMacros */
  public CMacroSuiteMacros() {
  }
  
  // Constructeur pour clonage
  public CMacroSuiteMacros(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit, encadrementInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit, listeAssocieeInit);
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie);
    int ind2 = listeSource.indexOf(impProto);        
    CSousListeObjets listeAssocieeClone = new CSousListeObjets();
    listeAssocieeClone.setImage(listeAssociee, listeSource, listeCible);
    CElementBase ptelb = new CMacroSuiteMacros(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur,x_nom, y_nom, dec_x, dec_y, 
      masque, (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, listeAssocieeClone);
    return ptelb;
  }

  // MacroEnCours renvoie this except pour les macros de
  // type CMacroSuiteMacro
  @Override
  public CMacro macroEnCours() { 
    if (indiceMacroEnCours < listeAssociee.size()) 
       return (CMacro)(listeAssociee.get(indiceMacroEnCours));
    else return this;
  }

  @Override
  public void initialise(AppletMathGraph32 applet) {
    indiceMacroEnCours = 0;
    macroEnCours().executionEnCours = true;
    // C'est  chacune des macros de la suite d'appeler initialiseInterruptions()
    //macroEnCours().initialiseInterruptions(applet);
  }
 
  @Override
  public int typeAnimation() {
    if (indiceMacroEnCours < listeAssociee.size()) 
       return macroEnCours().typeAnimation();
    else return CMacro.sansAnimation;
  }
  
  public void passageMacroSuiv(AppletMathGraph32 applet) {
  	// Modification java : si la macro en cours est une macro d'apparition d'objets avec clic pour
  	// passer  l'objet suivant, on ne passe  la macro suivante qui si le dernier objet a t affich.
  	// Sinon on fait apparaitre l'objet suivant
  	if (macroEnCours().getClass() == CMacroApparition.class) {
  		CMacroApparition macroapp = (CMacroApparition) macroEnCours();
  		if (macroapp.clicPourObjetSuivant && (macroapp.indiceDernierObjetTraite < macroapp.listeAssociee.size() - 1)) {
  			applet.paneFigure.repaint();
  			return;
  		}
  	}
    indiceMacroEnCours++;
    if (indiceMacroEnCours < listeAssociee.size()) {
      macroEnCours().actionAvantExecution(applet);
      macroEnCours().initialiseInterruptions(applet);// Si la macro suivante ne marche pas par interruptions
      // il faut envoyer un repaint
      if (macroEnCours().typeAnimation() == CMacro.sansAnimation) applet.paneFigure.repaint();
      executionEnCours = true;
    }
    else executionEnCours = false;
  }
    
  @Override
  public boolean agitSurVariable(CVariableBornee var) {
    boolean resultat = false;
    ListIterator<CElementBase> li = listeAssociee.listIterator();
    while (li.hasNext()) {
      CMacro ptMacro = (CMacro) (li.next());
      resultat = resultat || ptMacro.agitSurVariable(var);
    }
    return resultat;
  }
  
  @Override
  public boolean affecteValeurAVariable(CValeurDynamique val) {
    boolean resultat = false;
    ListIterator<CElementBase> li = listeAssociee.listIterator();
    while (li.hasNext()) {
      CMacro ptMacro = (CMacro) (li.next());
      resultat = resultat || ptMacro.affecteValeurAVariable(val);
    }
    return resultat;
  }  

  // Nouveau version 3.0
  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
    while (indiceMacroEnCours < listeAssociee.size()) {
      CMacro ptMacro = (CMacro) (listeAssociee.get(indiceMacroEnCours));
    	if (ptMacro.typeAnimation() == CMacro.sansAnimation) {
    		ptMacro.actionDansPaint(applet);
    		indiceMacroEnCours++;
    	}
    	else break;
    }
    if (indiceMacroEnCours == listeAssociee.size()) executionEnCours = false;
  }
  
  @Override
  public void executeSimple(AppletMathGraph32 applet) {
    ListIterator<CElementBase> li = listeAssociee.listIterator();
    while (li.hasNext()) {
      CMacro ptMacro = (CMacro) (li.next());
      ptMacro.executeSimple(applet);
    }
  }
  
  @Override
  public boolean executionPossible() {
    boolean resultat = true;
    ListIterator<CElementBase> li = listeAssociee.listIterator();
    while (li.hasNext()) {
      CMacro ptMacro = (CMacro) (li.next());
      resultat = resultat && ptMacro.executionPossible();
    }
    return resultat;
  }
  
  
   @Override
   public void termineAction(AppletMathGraph32 applet) {
     super.termineAction(applet);
     CMacro mac = macroEnCours();
     if (mac != this) mac.termineAction(applet);
   }
  
}
