/*
 * CMacroTraceAutoParVariable.java
 *
 * Created on 13 aot 2004, 12:39
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;
import Applet.AppletMathGraph32;
import Applet.MtgPaneFigure;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CMacroTraceAutoParVariable extends CMacroAvecListe {
	// Frquence. Utile pour les macros excutes dans uns macro
	// excutant une suite d'autres macros
  public int frequenceAnimationMacro;
	public CVariableBornee variableAssociee;
  private double valeur; // l'abscisse en cours du point li qui bouge
  private double valeurMini;
  private double valeurMaxi;
  private double pas;
  private double valeurInitiale;
  CListeObjets listeDep;

  /** Creates new CMacroTraceAutoParVariable */
  public CMacroTraceAutoParVariable() {
  }

  // Constructeur pour clonage
  public CMacroTraceAutoParVariable(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit, CVariableBornee variableAssocieeInit, int frequenceAnimationMacroInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
      dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit, 
      encadrementInit, effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit, 
      listeAssocieeInit);
   variableAssociee = variableAssocieeInit;
   frequenceAnimationMacro = frequenceAnimationMacroInit;
   listeDep = new CListeObjets(liste);    
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CSousListeObjets listeAssocieeClone = new CSousListeObjets();
    listeAssocieeClone.setImage(listeAssociee, listeSource, listeCible);
    int ind1 = listeSource.indexOf(variableAssociee);    
    int ind2 = listeSource.indexOf(pointLie); 
    int ind3 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroTraceAutoParVariable(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind2, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, listeAssocieeClone,
      (CVariableBornee) (listeCible.get(ind1, CVariableBornee.class)), frequenceAnimationMacro);
   ((CMacroTraceAutoParVariable) ptelb).listeDep = new CListeObjets(listeCible.uniteAngle, listeCible.pointeurLongueurUnite);
     return ptelb;
  }

  @Override
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || variableAssociee.dependDe(p);
  }
    
  @Override
  public boolean dependDePourBoucle(CElementBase p) {
    return super.dependDePourBoucle(p) || variableAssociee.dependDePourBoucle(p);
  }

  @Override
  public boolean executionPossible() {
    return variableAssociee.existe && listeAssociee.existeAuMoinsUnElement();
  }

  /**
   * Fonction prparant les listes dont la macro a besoin pour s'excuter
   */
  @Override
  public void etablitListesInternes() {
  	listeDep.retireTout();
    listeDep.ajouteObjetsDependantsSauf(variableAssociee, listeProprietaire, this);
  }
  
  @Override
  public void actionAvantExecution(AppletMathGraph32 applet) { 
  	super.actionAvantExecution(applet);  // Met executioEnCours  true
    // Rajout pour version 1.8
    applet.initilizetbuffer();   
    pas = variableAssociee.valeurPas;
    valeurMini = variableAssociee.valeurMini;
    valeurMaxi = variableAssociee.valeurMaxi;
    valeurInitiale = variableAssociee.valeurActuelle;
    valeur = valeurMini - pas;
    listeDep.ajouteObjetsDependantsSauf(variableAssociee, listeProprietaire, this);
    timeDebut = System.currentTimeMillis();
    timeFin = timeDebut + 100000000; // Ce n'est pas timeFin qui compte mais le nombre de boucles
  }

  // Si lors de actionDansPaint(), appel dans paint(), la macro affiche d'abord
  // l'image de fond, cette procdure renvoie true (c'est le dfaut).
  // Renverra fausse pour les macros de trace et de trace automatique
  // ainsi que pour les macros de boucle avec trace d'objet
  @Override
  public boolean affichageSurImFond() {
    return false;
  }
  
  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
  	MtgPaneFigure paneFigure = applet.paneFigure;
    boolean infor = applet.infRand;
    DimensionFenetre dimfen = applet.dimf;
    if (frequenceAnimationMacro == 0) {
      valeur= valeur + pas;
      while (valeur <= valeurMaxi)
      {
        variableAssociee.donneValeur(valeur);
        listeDep.positionne(infor, dimfen);
        CMathGrafDoc doc = applet.document;
        listeAssociee.afficheToutMemeMasquesPourTrace(paneFigure.tbuffer, dimfen, doc.couleurFond, doc.transparencePourSurfaces);
        valeur = valeur + pas;
     }
      paneFigure.transferetbufferversgbuffer();
      paneFigure.afficheToutDansgbufferSansImFond();
      executionEnCours = false;
    }
    else {
      // Le timer a dj chang l'abscisse
    	paneFigure.transferetbufferversgbuffer();
    	paneFigure.afficheToutDansgbufferSansImFond();
    }     
  }
  
  @Override
  public long dureePourAnimation() {
    return 1;
  }

  @Override
  public void executePourTimer(AppletMathGraph32 applet, boolean repaint) {
    if (!executionEnCours) return;
    DimensionFenetre dimfen = applet.dimf;
    valeur = valeur + pas;
    if (valeur > valeurMaxi) {
      // On leurre paint() dans l'applet en changeant le temps de dbut d'affichage
      timeFin = timeDebut;
    }
    else {
      variableAssociee.donneValeur(valeur);
      listeDep.positionne(applet.infRand, dimfen);
      CMathGrafDoc doc = applet.document;
      listeAssociee.afficheToutMemeMasquesPourTrace(applet.paneFigure.tbuffer, applet.dimf, doc.couleurFond, doc.transparencePourSurfaces);
    }
    if (repaint) applet.paneFigure.repaint();
  }

  @Override
  public void termineAction(AppletMathGraph32 applet) {
    super.termineAction(applet);
  	MtgPaneFigure paneFigure = applet.paneFigure;
    variableAssociee.donneValeur(valeurInitiale);
    listeDep.positionne(applet.infRand, applet.dimf);
    listeDep.retireTout();
    paneFigure.transferetbufferversgbuffer();
    paneFigure.afficheToutDansgbuffer();
  }

  @Override
  public int typeAnimation() {
    if (frequenceAnimationMacro == 0) return CMacro.sansAnimation;
    else return CMacro.animationParTimer;
  }

  @Override
  public int frequenceAnimation() {
    return frequenceAnimationMacro;
  }
    
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    frequenceAnimationMacro = inps.readCInt();   
    int ind1 = inps.readCInt();
    variableAssociee = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }  
  /* Lecture depuis dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    frequenceAnimationMacro = inps.readInt();   
    int ind1 = inps.readInt();
    variableAssociee = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }
  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeInt(frequenceAnimationMacro);
    int ind1 = list.indexOf(variableAssociee);
    oups.writeInt(ind1);
  }
}
