/*
 * CMathGrafDoc.java
 *
 * Created on 3 juillet 2004, 15:39
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;
import java.awt.Color;
import java.awt.Image;
import java.util.Vector;
import types.Int;
import entreesSorties.MathGraphDataInputStream;

public class CMathGrafDoc {
	public boolean estDocumentVersionC = false; // True si on a ouvert un document cr avec la version C++
	// A partir de la version 1.5, on rajoute un membre numro de version
	// On commence  2
	int numeroVersion;
	// Pour la version java on mmorise la langue qui a servi  construire la figure
	public String langage;
	// Nouveau pour la version java 2.0 : Effet de transparence ou non pour les surfaces
	public float transparencePourSurfaces;	
	// Nouveau pour le java : Variable qui servira  savoir si la figure a t
	// charge depuis un flux C++
	public boolean ancienneVersion = false;
	// Chemin d'accs  la figure. Null s'il s'agit d'une nouvelle figure pas
	// encore enregistre
	public String path;
	public int sizeWindowx;
	public int sizeWindowy;
	int sizeDocx;
	int sizeDocy;
	// ///////////////////////////////////////
	// Membres rajouts pour la version 1.8//
	public Color couleurFond;
	public String pathImageFond;
	public Image imageFond = null;
	// ///////////////////////////////////////
	// Variable rajoute pour la versino ajva permettant de savoir si le document
	// a t modifi
	private boolean isDirty;

	public boolean isDirty() {
		return isDirty;
	}

	public void setDirty(boolean val) {
		isDirty = val;
	}

	public Vector<CPrototype> tablePrototypes = new Vector<CPrototype>();
	// Membres enregistrs dans le flux qui n'taient pas dans la version Pascal
	public boolean affichagesFiges; // Sera true si on ne veut pas
	// que l'utilisateur puisse dplacer les commentaires et
	// affichages de valeurs
	public boolean marquesAnglesFigees; // Idem pour les marques d'angles
	// n'a rien spcifi ou si la figure ne comporte pas de longueur
	// unit. Sinon contiendra la longueur en cm qu'aura la figure quand elle
	// sera copie dans un document  l'aide du menu Edition Copier
	// A partir de la version2, on rajoute un objet CListeIdMenu qui contient
	// un mot de passe et une liste contenant les identificateurs des items
	// de menus interdits pour la figure
	//  revoir en java. Inutile de charger les items de menus permis ou interdits
	// CListeIdMenus m_ListeIdMenus;
	// Toujours  partir de la version 2, on rajoute un mot de passe qui permet
	// de protger la figure ainis que 4 membres boolens spcifiant le type
	// de protection.
	// Il se dfinit et se change dans le menu Options>>Figure en cours.
	String motDePasseFigure;
	boolean protectionOptions;
	boolean protectionCopie;
	boolean protectionFigure;
	boolean protectionMenus;
	boolean protectionSecret;

	public String TexteFigure; // Le texte associ  la figure
	public CListeObjets listePrincipale;
	// Membre  true quand les items contenus dans la liste d'items de menus sont
	// interdits
	// (dans le cas o la liste n'est pas vide)
	public boolean itemsCochesInterdits;

	// Une liste d'objets qui contiendra la liste des menus autoriss ou interdits
	public Vector<Integer> listeIdMenus = new Vector<Integer>();

	/** Creates new CMathGrafDoc */
	public CMathGrafDoc() {
    listePrincipale = new CListeObjets(this);
  }

	public boolean itemPermis(int item) {
		if (item != 0) {
			boolean trouve = false;
			for (int i = 0; i < listeIdMenus.size(); i++) {
				Integer nb = (Integer) listeIdMenus.get(i);
				if (nb.intValue() == item)
					trouve = true;
			}
			if (itemsCochesInterdits)
				return !trouve;
			else
				return trouve;
		}
		else return true;
	}
	
	public void retireItem(int item) {
		for (int i = 0; i < listeIdMenus.size(); i++) {
			Integer nb = (Integer) listeIdMenus.get(i);
			if (nb.intValue() == item) {
				listeIdMenus.remove(i);
			}
		}
		
	}
	
	public boolean itemContenu(int item) {
		if (item != 0) {
			boolean trouve = false;
			for (int i = 0; i < listeIdMenus.size(); i++) {
				Integer nb = (Integer) listeIdMenus.get(i);
				if (nb.intValue() == item)
					trouve = true;
			}	
			return trouve;
		}
		return false;
	}

	public boolean menuModifie() {
		return listeIdMenus.size() != 0;
	}

	/**
	 * Chargement du document depuis un flux C++ d'objets polymorphe
	 * 
	 * @param inps
	 * @throws java.io.IOException
	 */
	public final void chargeDepuisFlux(MathGraphDataInputStream inps) throws IOException {
		String chaineIdentification = inps.readCString(16);
		if ((chaineIdentification.compareTo(textes.Chaines.chaineIdentification) != 0)
				&& (chaineIdentification.compareTo(textes.Chaines.chaineIdentificationDemo) != 0)
				&& (chaineIdentification.compareTo(textes.Chaines.ancienneChaineIdentification) != 0)
				&& (chaineIdentification.compareTo(textes.Chaines.ancienneChaineIdentificationDemo) != 0)
				&& (chaineIdentification.compareTo(textes.Chaines.chaineIdentificationJava) != 0))
			throw new IOException();
		if ((chaineIdentification.compareTo(textes.Chaines.chaineIdentification) == 0)
				|| (chaineIdentification.compareTo(textes.Chaines.chaineIdentificationDemo) == 0)
				|| (chaineIdentification.compareTo(textes.Chaines.ancienneChaineIdentification) == 0)
				|| (chaineIdentification.compareTo(textes.Chaines.ancienneChaineIdentification) == 0)) {
			estDocumentVersionC = true;
			chargeDepuisFluxC(inps, chaineIdentification);
		} else
			chargeDepuisFluxJava(inps);
		// Nouveaut pour la version java : si la langue dans laquelle a t cr le document
		// on reconstruit toutes les formules mathmatiques
		// if (langage.compareTo(frame.pref_langage) != 0) listePrincipale.reconstruitChainesCalcul();
	}

	// Chargement depuis un flux C++ une fois que les 16 caractres donnant la
	// chaine d'identification ont t lus
	public void chargeDepuisFluxC(MathGraphDataInputStream inps, String chaineId) throws IOException {
		langage = "fra"; // Franais pour les anciennes figures
		ancienneVersion = true;
		if ((chaineId.compareTo(textes.Chaines.ancienneChaineIdentification) == 0)
				|| (chaineId.compareTo(textes.Chaines.ancienneChaineIdentificationDemo) == 0)) {
			// Rajoute pour version 2.5
			// NumeroVersionDocumentActif = 1;
			numeroVersion = 1;
			// Couleur de fond blanc pour les anciennes figures
			couleurFond = new Color(255, 255, 255);
		} else {
			numeroVersion = inps.readCInt();
			// Changements pour la version 1.8 (version 3)
			if (numeroVersion > MathGraphDataInputStream.numeroVersionActif) {
				// MtgDlg.dialogueAvertissement(textes.Chaines.erreurVersion);
				throw new IOException();
			}
			// Changement pour version 2.0 :apparition du degr de transparence des surfaces pleines dans un float
			transparencePourSurfaces = 1f; // Pas de transparence pour anciennes figures ( modifier dans Options Figure en cours
			if (numeroVersion >= 3) {
				// Version 1.8 : on enregistre la couleur de fond de la figure
				int couleurRouge, couleurVert, couleurBleu;
				couleurRouge = inps.readUnsignedByte();
				couleurVert = inps.readUnsignedByte();
				couleurBleu = inps.readUnsignedByte();
				couleurFond = new Color(couleurRouge, couleurVert, couleurBleu);
				pathImageFond = inps.readCString();
				// Pas utilis par l'applet : absoluteImageFondPath
				@SuppressWarnings("unused")
				String absoluteImageFondPath = inps.readCString();
				// Pas utilis en java : la taille de l'image de fond en
				// coordonnes logiques
				@SuppressWarnings("unused")
				int i = inps.readCInt();
				i = inps.readCInt();
				// On enregistre aussi les dimensions de la vue qui contenait la fentre
				// (nouveau pour la version 1.8)
				// Pas utilis dans l'applet java
				i = inps.readCInt();
				i = inps.readCInt();
			} else {
				couleurFond = Color.WHITE;
				pathImageFond = "";
			}
			// On charge l'ventuelle liste d'items de menus
			int nombreItems = inps.readCCount();
			if (nombreItems != 0) {
				// Il faut tromper le flux dans lequel ont t enregistrs des objets
				// C++
				// du type CIdMenu et du type Point
				inps.listeNomsClasse.add(new String("CIdMenu"));
				inps.listeNumerosVersion.add(new Int());
				// Deux fois ! (dfaut du C++
				inps.listeNomsClasse.add(new String("CIdMenu"));
				inps.listeNumerosVersion.add(new Int());
				for (int i = 0; i < nombreItems; i++) {
					// On saute 13 octets pour le nom de la classe CIdMenu pour le premier
					// item CIdMenu
					if (i == 0) {
						for (int j = 0; j < 13; j++) {
							@SuppressWarnings("unused")
							byte a = inps.readByte();
						}
						int a = inps.readCInt();
						listeIdMenus.add(new Integer(a));
					} else {
						int a = inps.readCShort();
						a = inps.readCInt();
						listeIdMenus.add(new Integer(a));
						inps.listeNomsClasse.add(new String("CIdMenu"));
						inps.listeNumerosVersion.add(new Int());
					}
				}
			}
			// Un octet pour itemsCochesInterdits
			itemsCochesInterdits = inps.readBoolean();
			motDePasseFigure = inps.readCString();
			protectionOptions = inps.readBoolean();
			protectionCopie = inps.readBoolean();
			protectionFigure = inps.readBoolean();
			protectionMenus = inps.readBoolean();
			protectionSecret = inps.readBoolean();
		}
		TexteFigure = inps.readCString();
		sizeWindowx = inps.readCInt();
		sizeWindowy = inps.readCInt();
		affichagesFiges = inps.readBoolean();
		marquesAnglesFigees = inps.readBoolean();
		@SuppressWarnings("unused")
		boolean affichageSurfacesPendantCaptures = inps.readBoolean(); // Plus
																																		// utilis
																																		// en java
		@SuppressWarnings("unused")
		double longueurReellePourUnite = inps.readCDouble();  // Plus utilis en java
		if (numeroVersion > 3) chargePrototypes(inps);
		// Nouveaut pour la version 2.5 : La liste doit tre aucourant du n de
		// version
		// de document
		listePrincipale.numeroVersion = numeroVersion;
		listePrincipale.chargeDepuisFlux(inps);
		numeroVersion = MathGraphDataInputStream.numeroVersionActif;
		listePrincipale.numeroVersion = MathGraphDataInputStream.numeroVersionActif;
		// on reconstruit toutes les formules mathmatiques pour une figure c++ car on ne sait pas la langue de l'utilisateur
		listePrincipale.reconstruitChainesCalcul();
		// A revoir plus tard pour la version java
		// if (ListePrincipale.PointeurLongueurUnite != NULL)
		// ListePrincipale.MetAJourListeAncetresPourLieuxDependantDe
		// (ListePrincipale.PointeurLongueurUnite);
		// COleServerDoc::Serialize(ar);

	}

	/**
	 * Chargement depuis un flux java d'objets polymorphe
	 * 
	 * @throws IOException
	 */
	public final void chargeDepuisFluxJava(MathGraphDataInputStream inps) throws IOException {
		numeroVersion = inps.readInt();
		// Ligne suivante pour corriger un oubli dans la premire version o le numro de document
		// tait nul
		if (numeroVersion == 0) numeroVersion = 5;
		if (numeroVersion > MathGraphDataInputStream.numeroVersionActif) throw new IOException();
		if (numeroVersion >= 6) transparencePourSurfaces = inps.readFloat();
		else transparencePourSurfaces = 1f; //pas de transparence pour les anciennes figures. A modifier dans Options Figure en cours
		langage = inps.readUTF(); // la langue dans laquelle a t cr le document
		// Changements pour la version 1.8 (version 3)
		// Changement pour version 2.0 : on enregistre le degr de transparence des surfaces pleines dans un float
		int couleurRouge, couleurVert, couleurBleu;
		couleurRouge = inps.readUnsignedByte();
		couleurVert = inps.readUnsignedByte();
		couleurBleu = inps.readUnsignedByte();
		couleurFond = new Color(couleurRouge, couleurVert, couleurBleu);
		pathImageFond = inps.readUTF();
		
		// On lit un boolen indiquant si les codes d'items de menu correspondent 
		// des items interdits ou non
		itemsCochesInterdits = inps.readBoolean();
		// On charge l'ventuelle liste d'items de menus
		int nombreItems = inps.readInt();
		if (nombreItems != 0) {
			for (int i = 0; i < nombreItems; i++) {
				int a = inps.readInt();
				listeIdMenus.add(new Integer(a));
			}
		}
		motDePasseFigure = inps.readUTF();
		protectionOptions = inps.readBoolean();
		protectionCopie = inps.readBoolean();
		protectionFigure = inps.readBoolean();
		protectionMenus = inps.readBoolean();
		protectionSecret = inps.readBoolean();
		TexteFigure = inps.readUTF();
		sizeWindowx = inps.readInt();
		sizeWindowy = inps.readInt();
		affichagesFiges = inps.readBoolean();
		marquesAnglesFigees = inps.readBoolean();
		readPrototypes(inps);
		// Nouveaut pour la version 2.5 : La liste doit tre au courant du n de
		// version
		// de document
		listePrincipale.numeroVersion = numeroVersion;
		listePrincipale.read(inps);
		listePrincipale.numeroVersion = MathGraphDataInputStream.numeroVersionActif;
		numeroVersion = MathGraphDataInputStream.numeroVersionActif;
	}

	/**
	 * Chargement des ventuels prototypes de la figure depuis un flux C++.
	 */
	void chargePrototypes(MathGraphDataInputStream inps) throws IOException {
		// On lit d'abord le nombre de prototypes
		int nbProt = inps.readCInt();
		for (int i = 0; i < nbProt; i++) {
			CPrototype prot = new CPrototype();
			prot.chargeDepuisFlux(inps);
			tablePrototypes.add(prot);
		}
	}

	/**
	 * Chargement des ventuels prototypes de la figure depuis un flux java.
	 */
	private void readPrototypes(MathGraphDataInputStream inps) throws IOException {
		// On lit d'abord le nombre de prototypes
		int nbProt = inps.readInt();
		for (int i = 0; i < nbProt; i++) {
			CPrototype prot = new CPrototype();
			prot.read(inps);
			tablePrototypes.add(prot);
		}
	}

}
