/*
 * CMesureAire.java
 *
 * Created on 7 octobre 2006, 08:42
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package objets;

import java.io.*;
import java.util.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

/**
 *
 * @author Yves
 */
public class CMesureAire extends CCalculAncetre{
	private CPolygone polygoneAssocie;
  private double aire;
  
  /** Creates a new instance of CMesureAire */
  public CMesureAire() {
  }
  
  // Constructeur pour clonage
  public CMesureAire(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      CPolygone polygoneAssocieInit, String nomCalculInit) {
    // Inutile d'appeler lengthconstructeur anctre vide
    super(liste, impProtoInit, estElementFinalInit,  nomCalculInit);
    polygoneAssocie = polygoneAssocieInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(polygoneAssocie);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb =  new CMesureAire(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, (CPolygone)(listeCible.get(ind1, CPolygone.class)), nomCalcul);
    return ptelb;
  }
  
  @Override
  public void setClone(CElementBase ptel) {
    aire = ((CMesureAire) ptel).aire;
  }
  
  @Override
  public boolean nomIndispensable(CElementGraphique el) {
  	for (int i =0; i < polygoneAssocie.collectionPoints.size(); i++) {
  		CNoeudPointeurSurPoint nd = (CNoeudPointeurSurPoint) polygoneAssocie.collectionPoints.get(i);
  		if (nd.pointeurSurPoint == el) return true;
  	}
  	return false;
  }
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NMesureAirePolygone;
  }
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || polygoneAssocie.dependDe(p)
    || listeProprietaire.pointeurLongueurUnite.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return (p == this) || polygoneAssocie.dependDePourBoucle(p)
    || listeProprietaire.pointeurLongueurUnite.dependDePourBoucle(p);
  }

  double rendValeur(boolean infoRandom) {
    return aire;
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    CLongueur pLongUnite = listeProprietaire.pointeurLongueurUnite;
		existe = polygoneAssocie.existe && pLongUnite.existe;
    if (!existe) return;
    double longueurUnite = pLongUnite.rendLongueur();
    // Si la longueur unit est nulle, pLongUnite n'existe pas
    aire = 0;
    Vector<CNoeudPointeurSurPoint> array = polygoneAssocie.collectionPoints;
    for (int i = 0; i < array.size() - 1; i++ ) {
      CPointAncetre ptp1 = (CPointAncetre)((CNoeudPointeurSurPoint) array.get((i))).pointeurSurPoint;
      CPointAncetre ptp2 = (CPointAncetre)((CNoeudPointeurSurPoint) array.get((i+1))).pointeurSurPoint;
      double x1 = ptp1.x;
      double y1 = ptp1.y;
      double x2 = ptp2.x;
      double y2 = ptp2.y;
      aire += (x1*y2 - x2*y1)/2;
    }
    aire = Math.abs(aire)/(longueurUnite*longueurUnite);
  }
  /** Rajout pour la version 2.0 : permet de connatre si l'lment point par pt
   * est confondu avec l'lment en question ou trs proche.
   * Pour cette version applet, ne sera redfini que pour les objets que l'utilisateur
   * pourra effectivement crer en ligne.
  **/
  public boolean confonduAvec(CElementBase p) {
    CMesureAire pt;
    if (p.getClass() == this.getClass()) {
      pt = (CMesureAire) p;
      return polygoneAssocie == pt.polygoneAssocie;
    }
    else return false;
  }    
  
  @Override
  public boolean utiliseLongueurUnite() {
  	return true;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    polygoneAssocie = (CPolygone) (list.get(ind1,CPolygone.class));
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    polygoneAssocie = (CPolygone) (list.get(ind1,CPolygone.class));
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(polygoneAssocie);
    oups.writeInt(ind1);
  }  
}

