/*
 * CMesureY.java
 *
 * Created on 13 juillet 2004, 16:10
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Java : Diffrence par rapport au C++ : Cette classe hrite de CMesureX pour gagner de la place
// abscisse joue lengthrel de l'ordonne
import glob.Kernel;
import types.*;

public class CMesureY extends CMesureX {

  /** Creates new CMesureY */
  public CMesureY() {
  }

  // Constructeur pour clonage
  public CMesureY(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      CRepere repereAssocieInit, CPointAncetre pointMesureInit) {
    super(liste, impProtoInit, estElementFinalInit, repereAssocieInit, pointMesureInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(repereAssocie);
    int ind2 = listeSource.indexOf(pointMesure);  
    int ind3 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMesureY(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, (CRepere)(listeCible.get(ind1, CRepere.class)), (CPointAncetre)(listeCible.get(ind2, CPointAncetre.class)));
    return ptelb;    
  } 
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NMesureOrdonneeRepere;
  }
  
  @Override
  public String infoPourHistorique() {
    String ch =  textes.Chaines.chinfo81 + " " + pointMesure.rendNom() + "\n" + textes.Chaines.chinfo32 + " "
    + repereAssocie.nom() + "\n"
    + textes.Chaines.chinfo33 + " " + nom();
    if (existe) ch = ch + "\n" + textes.Chaines.chinfo97 + Kernel.chaineNombre(abscisse, 16);
    else ch = ch + "\n" + textes.Chaines.ch18;
    return ch;
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = repereAssocie.existe && pointMesure.existe;
    if (!existe) return;
    // L'orientation sur l'cran est l'inverse de celle du repre
		// choisi.Il faut donc permuter les rles de u et v}
    VecteurDirecteur u = new VecteurDirecteur(repereAssocie.O, repereAssocie.I);
    VecteurDirecteur v = new VecteurDirecteur(repereAssocie.O, repereAssocie.J);
		// Calcul des	abscisses et ordonnes de l'origine relle du repre dans le repre de base
		double xno = repereAssocie.O.x -u.x*repereAssocie.abscisseOrigine.rendValeur(infoRandom)-
			v.x*repereAssocie.ordonneeOrigine.rendValeur(infoRandom);
		double yno = repereAssocie.O.y - u.y*repereAssocie.abscisseOrigine.rendValeur(infoRandom)-
			v.y*repereAssocie.ordonneeOrigine.rendValeur(infoRandom);
		// Calcul de l'abscisse par rsolution d'un systme linaire
		double det = u.x*v.y-v.x*u.y;
		abscisse = (u.x*(pointMesure.y-yno)-u.y*(pointMesure.x-xno))/det;
  }

  @Override
  public String nom() {
    return "yCoord" + "(" + pointMesure.nom + "," + repereAssocie.O.nom + "," +
      repereAssocie.I.nom + "," +repereAssocie.J.nom + ")";
  }    
}
