/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;

/**
 *
 * @author  Yves
 * @version 
 */
// Classe noeud pondr dont les instances servent  construire des barycentres
import java.io.*;

import types.DimensionFenetre;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CNoeudPondere extends CObjetBase {
	public CPointAncetre pointAssocie;
	public CValeurAssocieeAVariable poids;
	// Ajout pour version 3.0
	public boolean existe;

  /** Creates new CNoeudPondere */
  public CNoeudPondere() {
  }
    
  // Constructeur pour clonage
  public CNoeudPondere(CListeObjets liste, CPointAncetre pointAssocieInit,
      CValeurAssocieeAVariable poidsInit) {
    super(liste);
    pointAssocie = pointAssocieInit;
    poids = poidsInit;
  }

  public CNoeudPondere getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CValeurAssocieeAVariable poidsClone = (CValeurAssocieeAVariable) poids.getClone(listeSource, listeCible);
    int ind1 = listeSource.indexOf(pointAssocie);
    return new CNoeudPondere(listeCible, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)), poidsClone);  
  }
  
  // Ajout pour version 3.0
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	poids.positionne(infoRandom, dimfen);
  	existe = poids.existe();
  }

  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (pointAssocie == ancienPoint) pointAssocie = nouveauPoint;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    poids = new CValeurAssocieeAVariable();
    poids.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointAssocie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    poids = new CValeurAssocieeAVariable();
    poids.read(inps, list);
    int ind1 = inps.readInt();
    pointAssocie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    poids.write(oups, list);
    int ind1 = list.indexOf(pointAssocie);
    oups.writeInt(ind1);
  }   
}
