package objets;

import java.awt.Color;
import java.io.IOException;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import types.NatureObjet;

/**
 * Classe anctre des points lis  un lieu de points.
 * Il y aura deux types de descendants : ceux lis  un lieu de points gnr par un point li
 * et ceux lis  un lieu de points gnr par une variable
 * @author Yves
 *
 */
public abstract class CPointLieLieuAncetre extends CPointLie {
	protected CLieuDeBase lieuAssocie;
	/*
	 * Signification de abscisse pour cet objet
	 * Dans le cas o le point est li  un lieu de points gnr par une variable, la valeur de la variable donnant la position du point
	 * Dans le cas o le point est li  un lieu de points gnr par un point li, l'abscisse de ce point li relative
	 *  l'objet auquel il est li et qui donne la position du point.
	 */
	
	// Constructeur par dfaut
	protected CPointLieLieuAncetre() {
	}
	
	// Constructeur pour clonage
  protected CPointLieLieuAncetre(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit,
      boolean masqueInit, String nomInit, int indiceTailleNomInit,
      int motifInit, boolean pointLibreInit, double abscisseInit, CLieuDeBase lieuAssocieInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit, dec_xInit, dec_yInit, 
          masqueInit, nomInit, indiceTailleNomInit, motifInit, pointLibreInit, abscisseInit);
        lieuAssocie = lieuAssocieInit;
    }
	
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    abscisse = ((CPointLie)ptel).abscisse;
  }
  
  public void donneAbscisse(double ab) {
    abscisse = ab;
  }
  
  @Override
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || lieuAssocie.dependDe(p);
  }
  
  @Override
  public boolean dependDePourBoucle(CElementBase p) {
    return (p == this) || lieuAssocie.dependDePourBoucle(p);
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CPointLieLieuAncetre pt;
    if (p.getClass() == this.getClass()) {
      pt = (CPointLieLieuAncetre) p;
      return glob.Kernel.zero(abscisse - pt.abscisse);
    }
    else return false;
  }  
  
  @Override
  public long getNature() {
    return NatureObjet.NPointLie;
  }
  
  @Override
	public
  CElementBase lieA() {
    return lieuAssocie;
  }
  
  /* Chargement depuis un flux java */
  public void read( MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    lieuAssocie = (CLieuDeBase) (list.get(ind1,CLieuDeBase.class));
    abscisse = inps.readDouble();
  }
  
  /* Enregistrement dans un flux java */
  public void write( MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(lieuAssocie);
    oups.writeInt(ind1);
    oups.writeDouble(abscisse);
  }    
   
}
