package objets;

import glob.Kernel;

import java.awt.Color;
import java.awt.geom.Point2D.Double;

import types.DimensionFenetre;
import types.Doub;
import types.InfoLieu;

public class CPointLieLieuParVar extends CPointLieLieuAncetre {

  /** Constructeur par dfaut */
  public CPointLieLieuParVar() {
  }
	
  /** Constructeur pour clonage */
  public CPointLieLieuParVar(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit,
      boolean masqueInit, String nomInit, int indiceTailleNomInit,
      int motifInit, boolean pointLibreInit, CLieuParVariable lieuAssocieInit, double abscisseInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit, dec_xInit, dec_yInit, 
        masqueInit, nomInit, indiceTailleNomInit, motifInit, pointLibreInit, abscisseInit, lieuAssocieInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(lieuAssocie);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CPointLieLieuParVar(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, nomMasque, dec_x, dec_y, masque, nom, 
      indiceTailleNom, motif, pointLibre, (CLieuParVariable)(listeCible.get(ind1, CLieuDePoints.class)), abscisse);
    return ptelb;
  }  
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
		existe = lieuAssocie.existe;
		if (!existe) return;
		CVariableBornee var = (CVariableBornee) ((CLieuParVariable) lieuAssocie).variableGeneratrice;
		CPointAncetre ptGenerateurTrace = (CPointAncetre) ((CLieuParVariable) lieuAssocie).pointATracer;
		// On mmorise la valeur actuelle de la variable qui gnre le lieu auquel le point est li
		double ancienneAbscisse = var.valeurActuelle;
		var.donneValeur(abscisse);
		((CLieuParVariable) lieuAssocie).listeElementsAncetres.positionne(infoRandom, dimfen);
		super.placeEn(ptGenerateurTrace.x, ptGenerateurTrace.y);
		var.donneValeur(ancienneAbscisse);
		((CLieuParVariable) lieuAssocie).listeElementsAncetres.positionne(infoRandom, dimfen);
  }
  
  @Override
  public double abscisseMaximale() {
  	return ((CLieuParVariable) lieuAssocie).variableGeneratrice.valeurMini;
  }

  @Override
  public double abscisseMinimale() {
  	return ((CLieuParVariable) lieuAssocie).variableGeneratrice.valeurMaxi;
  }
  
	@Override
	public boolean testDeplacement(DimensionFenetre dimfen, double xtest,
			double ytest, Double pointr, Doub abscr) {
		CLieuParVariable lieu = (CLieuParVariable) lieuAssocie;
		CVariableBornee var = lieu.variableGeneratrice;
		InfoLieu info = lieu.infoLieu;
    double abscisseMini = var.valeurMini;
    double abscisseMaxi = var.valeurMaxi;
    // On ordonne l'abscisse minimale et maximale
    if (abscisseMini > abscisseMaxi) {
      double w = abscisseMini;
      abscisseMini = abscisseMaxi;
      abscisseMaxi = w;
    }
    // Modification pour la version 1.9.5
    double pas = (abscisseMaxi - abscisseMini)/(info.nombreDePoints-1);
    long dis = Long.MAX_VALUE;
    int indDistMini = 0;
    for (int i = 0; i < info.nombreDePoints; i++) {
    	long d = (long) Kernel.distancePointPoint(xtest, ytest, lieu.abscissesCoordonneesPoints[i], lieu.ordonneesCoordonneesPoints[i]);
    	if (d < dis) {
    		dis = d;
    		indDistMini = i;
    	}  
    }
    abscr.setValue(abscisseMini + indDistMini*pas);
    // Il est inutile ici de donner des valeurs  pointr qui n'est pas utilis par l'outil correspondant
    return true;
	}  
  
}
