/*
 * CPrototype.java
 *
 * Created on 8 aot 2007, 17:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/*
 * Cette classe n'est pas pleinement implmente dans l'applet. Elle a seulement besoin d'^tre
 * charge.
 **/
package objets;

import java.io.*;
import types.NatureCalcul;
import types.NatureObjet;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
/**
 *
 * @author Yves
 */
 @SuppressWarnings("serial")
public class CPrototype extends CListeObjets {
  public static final int numeroVersionPrototypes = 2;
	private int numeroVersionPrototype;	// Par prcaution pour de futures versions. Vaudra 1 pour la version 2.5
  public String nom;
  public String commentaire; // Commentaire explicatif
  public int nbObjSources;
  public int nbObjFinaux;
  public int natureSources;
	public CListeObjets listePourImplementation;
  public int indicePremierObjetPourImplementation;
  
	public static int ConstructionEltsGraphiquesSeuls = 0;
	public static int ConstructionEltsMixtes = 1;
	public static int ConstructionEltsCalculsSeuls = 2;
  
  /** Creates a new instance of CPrototype */
  public CPrototype() {
  	numeroVersionPrototype = numeroVersionPrototypes;
  	setListePourImplementation(null);
  }
  
  /**
   * Constructeur  partir d'objets contenus dans la liste listeSources
   * @param nomInit : Le nom du prototype
   * @param nbObjSourcesInit : Le nombre d'objets sources
   * @param listePrincipale : la liste contenant tous les objets dont certains servent  construire le prototype
   * @param listeElements : la sous liste complte de listeElements forme des lments sources, intermdiaires et finaux
   * @param listeElementsFinaux : la sous liste de listeElements forme des lments finaux
   * @param natureSourcesInit : Donne la nature du prototype : sources exclusivement de type calcul ou exclusivement
   * de type graphique ou mixte
   */
  public CPrototype(String nomInit, int natureSourcesInit, int nbObjSourcesInit, CListeObjets listePrincipale, CListeObjets listeElements, 
  		CListeObjets listeElementsFinaux) {
  	nom = nomInit;
  	natureSources = natureSourcesInit;
  	nbObjSources = nbObjSourcesInit;
  	numeroVersionPrototype = numeroVersionPrototypes;
  	setListePourImplementation(null);
  	nbObjFinaux = listeElementsFinaux.size();
  	int nombreTotal = listeElements.size();
  	int i;
  	for (i = 0; i < nbObjSources; i++)
  	{
  		CElementGenerique ptgen = new CElementGenerique();
  		CElementBase elb = listeElements.get(i);
  		long natureGraphique = elb.getNature();
  		long natureCalcul = elb.getNatureCalcul();
  		// Modification version 1.0.1
  		/*
  		 if ((natureCalcul & NatureCalcul.NTouteValeurReelleOuComplexe) != 0)
  			ptgen.nom = ((CValeurDynamique) elb).nom();
  		else
  		*/
			// Les points ou droites ayant un nom indispensable doivent voir aussi un nom lors de l'implmentation
			// Ce nom est sauve dans l'lment gnrique
			if ((natureGraphique & (NatureObjet.NToutPoint | NatureObjet.NDroite)) != 0){
				if (listeElements.nomIndispensable((CElementGraphique)elb)) ptgen.nom = ((CElementGraphique) elb).nom;
			}
  		ptgen.estElementFinal = false;
  		if (natureGraphique != 0) ptgen.natureGraphique = natureGraphique;
  		// else ptgen.natureCalcul = natureCalcul;
  		// Attention pas de else car les repres sont  la fois graphiques et non graphiques
  		ptgen.natureCalcul = natureCalcul;
  		add(ptgen);
  	}
  	for (i = nbObjSources; i < nombreTotal; i++)
  	{
  		CElementBase elb = listeElements.get(i);
  		CElementBase elbClone = elb.getClone(listeElements, this);
  		elbClone.estElementFinal = listeElementsFinaux.contains(elb);
  		add(elbClone);
  	}  	
  }
  		
  
  public void setListePourImplementation(CListeObjets listePourImplementationInit) {
  	listePourImplementation = listePourImplementationInit;
  }
 
  /**
   * Fonction renvoyant une chane forme de l'aide pour l'implmentation de l'objet ni
   * si elle existe. Cette chane est contenue dans le commentaire du prototype (si elle
   * a t entre) et elle est dlimite en dbut par un caractre # suivi d'une chane
   * reprsentant i suivi d'un caractre : et en fin par un caractre #
   */
  public final String chaineImplementationProto(int i) {
  	StringBuffer stringbuf = new StringBuffer(128);
  	String ch = "#" + Integer.toString(i) + ":";
  	int j = commentaire.indexOf(ch);
  	if (j != -1) {
  		int k = commentaire.indexOf("#", j + ch.length());
  		if (k != -1) stringbuf.append(commentaire.substring(j + ch.length(), k));
  		else stringbuf.append(commentaire.substring(j + ch.length()));
  		int p = stringbuf.indexOf("\n");
  		if (p != -1) stringbuf.delete(p, stringbuf.length());
  		if (stringbuf.length() > 50) stringbuf.delete(51, stringbuf.length());
  	}
  	return stringbuf.toString();
  }

 // Chargement de la liste depuis un flux
  public void chargeDepuisFlux (MathGraphDataInputStream inps)  throws IOException {
    numeroVersionPrototype = inps.readCInt();
    nom = inps.readCString();
    commentaire = inps.readCString();
    nbObjSources = inps.readCInt();
    nbObjFinaux = inps.readCInt();
    natureSources = inps.readUnsignedByte();
    super.chargePourProtoDepuisFlux(inps);
    // On recherche le objets sources repres et on les met  la fin des objets sources de type calcul
    // On recherche d'abord l'indice du premier objet source graphique qui ne soit pas un repre
    int ind;
    
    int nbObjCal = 0;
    boolean trouve = false;
    for (ind = 0; ind < nbObjSources; ind++) {
    	CElementGenerique el = (CElementGenerique) get(ind);
    	if (el.natureGraphique != 0) {
    		trouve = true;
    		break;
    	}
    	else nbObjCal++;
    }
    // On regarde si cet objet est suivi de repre. Si c'est le cas on reclasse les repres avant
    // ce premier lment graphique
    if (trouve) {
    	for (int j = ind + 1; j < nbObjSources; j++) {
    		CElementGenerique el = (CElementGenerique) get(j);
    		if (el.natureCalcul == NatureCalcul.NRepere) {
    			remove(j);
    			add(ind, el);
    		}
    	}
    }
    // Il revoir la nature des ojets sources requis
    if (natureSources != ConstructionEltsCalculsSeuls) {
	    // On compte les objets sources de type calcul
	  	int nb = 0;
	  	for (int i = 0; i < nbObjSources; i++) {
	  		CElementGenerique gen = (CElementGenerique) get(i);
	  		if (gen.natureCalcul != 0) nb++;
  	}
  	if (nb == nbObjSources) natureSources = ConstructionEltsCalculsSeuls;
  	else
  		if (nb == 0) natureSources = ConstructionEltsGraphiquesSeuls;
  		else
  			natureSources = ConstructionEltsMixtes;
  	}
  }
  /* Chargement depuis un flux java */
  public void read(MathGraphDataInputStream inps)  throws IOException {
    numeroVersionPrototype = inps.readInt();
    nom = inps.readUTF();
    commentaire = inps.readUTF();
    nbObjSources = inps.readInt();
    nbObjFinaux = inps.readInt();
    natureSources = inps.readUnsignedByte();
    super.readPourProtoDepuisFlux(inps);
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups)  throws IOException {
  	// Important : quand on enregistre le prototype dans un flux il faut que son membre
  	// listePourImplementation soit null car sinon ce ne sont pas les bons indices des objets
  	// contenus dans le prototype qui vont tre enregistrs.
  	setListePourImplementation(null);
    oups.writeInt(numeroVersionPrototype);
    oups.writeUTF(nom);
    oups.writeUTF(commentaire);
    oups.writeInt(nbObjSources);
    oups.writeInt(nbObjFinaux);
    oups.writeByte(natureSources);
    super.writePourProtoDepuisFlux(oups);
  }
}
