/*
 * CSurfaceAncetre.java
 *
 * Created on 18 juillet 2004, 10:00
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;


import java.awt.Color;
import java.io.IOException;

import types.NatureObjet;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;


public abstract class CSurfaceAncetre extends CElementGraphique {
  
	public int styleRemplissage; // Nom chang parrapport au C++ (Quadrillage) Etait un int en C++
	
	/** Creates new CSurfaceAncetre */

  public CSurfaceAncetre() {
  }

  // Constructeur pour clonage
  public CSurfaceAncetre(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleRemplissageInit) {
   super(liste, impProtoInit, estElementFinalInit, couleurInit, false, 0, 0, masqueInit, "", 0);
   styleRemplissage = styleRemplissageInit;
  }
  
  @Override
  public long getNature() {
    return NatureObjet.NSurface;
  }
  
  /**
   * Fonction appele quand on change le nombre de points du lieu qui est le bord de la surface
   * A redfinir pour les descendants atant un lieu pour bord
   */
  public void metAJourTableaux() {
  }
 
  /**
   * Fonction renvoyant true lorsque la surface a pour bord lieu
   * Utilis quand on change le nombre de points d'un lieu. Il faut alors recrer les tableaux
   * utilis par les surfaces ayant lieu pour bord
   * @param lieu
   * @return
   */
  public boolean aPourBord(CLieuDeBase lieu) {
  	return false;
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CSurfaceAncetre pt;
    if (p.getClass() == this.getClass()) {
      pt = (CSurfaceAncetre) p;
      return (styleRemplissage == pt.styleRemplissage);
    }
    else return false;
  }  
  
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    styleRemplissage = inps.readCInt();
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    styleRemplissage = inps.readInt();
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeInt(styleRemplissage);
  }    
}