/*
 * CSurfaceDisque.java
 *
 * Created on 18 juillet 2004, 11:18
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.*;

import types.*;

public class CSurfaceDisque extends CSurface {

  /** Creates new CSurfaceDisque */
  public CSurfaceDisque() {
  }
  
  // Constructeur pour clonage
  public CSurfaceDisque(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleRemplissageInit, CCercle bordInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleRemplissageInit, bordInit);
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(bord);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CSurfaceDisque(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, masque, styleRemplissage, (CCercle)(listeCible.get(ind1, CCercle.class)));
    return ptelb;
  }
  
  /*
   * Modifi version 2.0
  public void trace(Graphics2D pDC, boolean effacement, Color couleurFond, float transparence) {
    Color coul;

    if (effacement)
      coul = Couleur.TraduitCouleur(0);
    else coul = couleur;
    int styleRemplissageEffectif;
    if (masque) styleRemplissageEffectif = StyleRemplissage.QuadrillageCroise;
    else styleRemplissageEffectif = styleRemplissage;
    if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePlein) pDC.setColor(coul);
    else {
    	TexturePaint tp = StyleRemplissage.getTexturePaint(coul, styleRemplissageEffectif, listeProprietaire.basseDefinition);
    	pDC.setPaint(tp);
   }
    CCercle ptc = (CCercle) bord;
    pDC.fillOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
      (int)Math.round(ptc.xCarre2 - ptc.xCarre1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1));
  }
  */
  
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {

    int styleRemplissageEffectif;
    if (masque) styleRemplissageEffectif = StyleRemplissage.QuadrillageCroise;
    else styleRemplissageEffectif = styleRemplissage;
    CCercle ptc = (CCercle) bord;
    if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePleinTransp) {
    	if (transparence != 1) {
    		pDC.setColor(couleur);
  	    Composite originalComposite = pDC.getComposite();
  	    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transparence));
  	    // Ligne suivante modifie version 2.0
  	    pDC.fillOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
  	      (int)Math.round(ptc.xCarre2 - ptc.xCarre1 + 1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1 + 1));
  	    pDC.setComposite(originalComposite);    		
    	}
    	else {
    		pDC.setColor(couleur);
  	    // Ligne suivante modifie version 2.0
  	    pDC.fillOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
    	      (int)Math.round(ptc.xCarre2 - ptc.xCarre1 + 1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1) + 1);
    	}
    }
    else {
      if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePlein) {
    		pDC.setColor(couleur);
  	    pDC.fillOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
    	      (int)Math.round(ptc.xCarre2 - ptc.xCarre1 + 1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1) + 1);
      }
      else {
	    	TexturePaint tp = StyleRemplissage.getTexturePaint(couleur, styleRemplissageEffectif, listeProprietaire.basseDefinition, couleurFond);
	    	pDC.setPaint(tp);
		    // Ligne suivante modifie version 2.0
	    	pDC.fillOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
		      (int)Math.round(ptc.xCarre2 - ptc.xCarre1 + 1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1 + 1));
      }
    }
  }  
  
  
  /*
   * Pour projet d'utilisation de transparence
  public void trace(Graphics2D pDC, boolean effacement) {
    Color coul;

    if (effacement)
      coul = Couleur.TraduitCouleur(0);
    else coul = couleur;
    int styleRemplissageEffectif;
    if (masque) styleRemplissageEffectif = StyleRemplissage.QuadrillageCroise;
    else styleRemplissageEffectif = styleRemplissage;
    CCercle ptc = (CCercle) bord;
    if (effacement) {
    	pDC.setColor(coul);
    	pDC.fillOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
        (int)Math.round(ptc.xCarre2 - ptc.xCarre1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1));
	    pDC.drawOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
		      (int)Math.round(ptc.xCarre2 - ptc.xCarre1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1));
    }
    else {
	    TexturePaint tp = StyleRemplissage.getTexturePaint(coul, styleRemplissageEffectif, listeProprietaire.basseDefinition);
	    pDC.setPaint(tp);
	    Composite originalComposite = pDC.getComposite();
	    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.5f));
	    pDC.fillOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
	      (int)Math.round(ptc.xCarre2 - ptc.xCarre1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1));
	    pDC.drawOval((int)Math.round(ptc.xCarre1), (int)Math.round(ptc.yCarre1),
		      (int)Math.round(ptc.xCarre2 - ptc.xCarre1), (int)Math.round(ptc.yCarre2 - ptc.yCarre1));
	    pDC.setComposite(originalComposite);
    }
  }
  */ 
}
