/*
 * CSymetrieAxiale.java
 *
 * Created on 10 juillet 2004, 13:00
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.geom.*;
import java.io.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CSymetrieAxiale extends CTransformation {
	private CDroiteAncetre axe;

  /** Creates new CSymetrieAxiale */
  public CSymetrieAxiale() {
  }
  
  @Override
	public int natureTransformation() {
		return symetrieAxiale;
	}
  
  // Constructeur pour clonage
  public CSymetrieAxiale(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    CDroiteAncetre axeInit) {
    super(liste, impProtoInit, estElementFinalInit);
    axe = axeInit;
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(axe);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CSymetrieAxiale(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
    estElementFinal, (CDroiteAncetre)(listeCible.get(ind1, CDroiteAncetre.class)));
    return ptelb;    
  }
 

  @Override
  void AjouteElementsVisuelsPourHist(CListeObjets liste) {
    liste.add(axe);
  }
  
  String designationTransf() {
    return textes.Chaines.chinfo20;
  }  
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || axe.dependDe(p);
  }

  public boolean dependDePourBoucle(CElementBase p) {
    return ((p == this) || axe.dependDePourBoucle(p));
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	existe = axe.existe;
  }

  public boolean confonduAvec(CElementBase p) {
    CSymetrieAxiale pt;
    if (p.getClass() == this.getClass()) {
      pt = (CSymetrieAxiale) p;
      return axe.confonduAvec(pt.axe);
    } else return false;
  }
  
  public double transformeLongueur(double L) {
    return L;
  }

  public void transformePoint(double x, double y, Point2D.Double pointr) {

    VecteurDirecteur u = new VecteurDirecteur(axe.point_x, axe.point_y, x, y);
    VecteurDirecteur uimage = new VecteurDirecteur();
    transformeVecteur(u, uimage);
    pointr.x = axe.point_x + uimage.x;
    pointr.y = axe.point_y + uimage.y;
  }

  // Mthode rajoute pour la version 1.8
  void transformeAngle(double ang, Point2D.Double pointr) {
    pointr.x = - ang;
  }
  
  // Java : transformeVecteur a t modifi par rapport au C++. Il est inutile de tester
  // que lengthvecteur directeur de l'axe est non  nul
  public void transformeVecteur(VecteurDirecteur u, VecteurDirecteur ur) {
  double norm2;
  double ax,ay,x,y,k1,k2;

    x = u.x;
    y = u.y;
    ax = axe.vecteur.x;
    ay = axe.vecteur.y;
    norm2 = ax*ax + ay*ay;
    k1 = ax*ax - ay*ay;
    k2 = 2*ax*ay;
    ur.x = (k1*x + k2*y)/norm2;
    ur.y = (k2*x - k1*y)/norm2;
  }
    
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    axe = (CDroiteAncetre) (list.get(ind1,CDroiteAncetre.class));
  }

  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    axe = (CDroiteAncetre) (list.get(ind1,CDroiteAncetre.class));
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(axe);
    oups.writeInt(ind1);
  }    
}
