/*
 * CValeurAssocieeAVariable.java
 *
 * Created on 7 juillet 2004, 12:02
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.IOException;

import entreesSorties.MathGraphDataInputStream;


public class CValeurAssocieeAVariable extends CValeurAssocieeAVariableAncetre {
  // public String chaineCalculValeur;
  
  /** Creates new CValeurAssocieeAVariable */
  public CValeurAssocieeAVariable() {
  }
  
  public CValeurAssocieeAVariable(CListeObjets list) {
  	super(list);
  }

  /** Constructeur pour clonage */
  public CValeurAssocieeAVariable(CListeObjets liste, CCalculBase calculInit, double valeurInit) {
    super(liste, calculInit);
    valeur = valeurInit;
  }
  
  // Constructeur pour une valeur qui vient d'tre cre mais n'a pas t encore calcule
  public CValeurAssocieeAVariable(CListeObjets liste, CCalculBase calculInit) {
    super(liste);
    donneCalcul(calculInit);
  }
  
  /** Constructeur  partir d'un autre objet du mme type */
  public CValeurAssocieeAVariable(CValeurAssocieeAVariable valInit) {
  	super(valInit.listeProprietaire);
    calcul = valInit.calcul.getClone(listeProprietaire, listeProprietaire);
    estConstant = valInit.estConstant;
    existe = valInit.existe;
  }
  
  /** Constructeur  partir d'une valeur numrique */
  public CValeurAssocieeAVariable(CListeObjets liste, double valInit) {
  	super(liste);
  	calcul = new CConstante(liste,valInit);
  	valeur = valInit;
    estConstant = true;
    existe = true;
  }
  
  public CValeurAssocieeAVariable getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CCalculBase calculClone = calcul.getClone(listeSource, listeCible);
    return new CValeurAssocieeAVariable(listeCible, calculClone, valeur);
  }
    
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    // On lit la chane reprsentant le calcul en C++ qui n'est plus utilise
    @SuppressWarnings("unused")
		String s = inps.readCString();
  }
}
