/*
 * CValeurAssocieeAVariableAncetre.java
 *
 * Created on 7 juillet 2004, 11:26
 */

/**
 * Modification pour la version 3.0
 * CValeurAssocieeAVariableAncetre pourra contenir un calcul faiasnt rfrence  tous les objets
 * non graphiques prcdents
 * Il maintiendra donc un objet du type CCalculBase nomm calcul
 * Il maitiendra aussi un boolen nomm estConstant qui sera mis  true si le calcul
 * n'utilise que des constantes et un double nomm valeur qui contiendra la valeur renvoye
 * Un nouveau membre existe dira si le calcul associ existe
 * Tout objet qui contient des membres du type CValeurAssocieeAVariableAncetre devra dans sa
 * fonction positionne appeler la mthode positionne de CValeurAssocieeAVariableAncetre
 * @author  Yves
 * @version 
 */
package objets;

// Important : dans la version C++, CValeurAssocieeAVariableAncetre drivait de CObject
// Il est plus intelligent de la faire driver de CElementBase;
// Mais lui n'a pas  renvoyer de nature par GetNature qui renvera donc -1.
// A noter que le nom est mal choisi : ce devrait tre CValeurAssocieeAValeurDynamiqueAncetre
import java.io.*;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public abstract class CValeurAssocieeAVariableAncetre extends CObjetBase {
	public double valeur;  // La valeur si aucune valeur dynaique n'est associe
	// public CValeurDynamique valeurDynamiqueAssociee; // NULL ou la valeur dynamique associe
	public CCalculBase calcul;
	protected boolean estConstant;
	protected boolean existe;

  /** Creates new CValeurAssocieeAVariableAncetre */
  public CValeurAssocieeAVariableAncetre() {
  }
  
  public CValeurAssocieeAVariableAncetre(CListeObjets list) {
  	super(list);
  }
  
  
  // Constructeur pour clonage
  public CValeurAssocieeAVariableAncetre(CListeObjets liste, CCalculBase calculInit) {
    super(liste);
    calcul = calculInit;
  }

  abstract CValeurAssocieeAVariableAncetre getClone(CListeObjets listeSource, CListeObjets listeCible);
  
  /** Fonction associant  l'objet la valeur dynamique vald */
  /*
  public void associeA(CValeurDynamique vald) {
    valeurDynamiqueAssociee = vald;
  }
  */
  /**
   * Ajout pour la version 3.0
   * Donne un calcul  l'objet et vrifie s'il est constant ou non.
   */
  public void donneCalcul(CCalculBase calc) {
  	calcul = calc;
  	estConstant = calcul.estConstant();
  	if (estConstant) {
  		existe = true;
      try {
        valeur = calcul.resultat(false);
      } 
      catch (ErreurCalculException e) {
        existe = false;
        valeur = 0;
      }
      if (Double.isNaN(valeur) || Double.isInfinite(valeur)) {
        existe = false;
      }
  	}
  }
  
  /**
   * Ajout pour la version 3.0
   * Donne une valeur constante.
   * @param val
   */
  public void donneValeur(double val) {
  	valeur = val;
  	calcul = new CConstante(listeProprietaire, valeur);
  	estConstant = true;
  	existe = true;
  }
  
  /**
   * Ajout pour la version 3.0
   * Renvoie true si contient un calcul qui est le rsultat de val
   * @param val
   * @return
   */
  public boolean pointeSur(CValeurDynamique val) {
  	if (calcul.getClass() == CResultatValeur.class) {
  		return (((CResultatValeur) calcul).valeurAssociee == val);
  	}
  	else return false;
  }
  
  // La classe tant abstract, inutile de redfinir getClone()
  
  public boolean dependDe(CElementBase p) {
    return calcul.dependDe(p);
  }

  public boolean dependDePourBoucle(CElementBase p) {
    return calcul.dependDePourBoucle(p);
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    if (!estConstant) {
      existe = calcul.existe();
      if (!existe) return;
      try {
        valeur = calcul.resultat(infoRandom);
      } 
      catch (ErreurCalculException e) {
        existe = false;
        valeur = 0;
      }
      if (Double.isNaN(valeur) || Double.isInfinite(valeur)) {
        existe = false;
      }
    }
  }
  
  public boolean confonduAvec(CObjetBase p) {
    CValeurAssocieeAVariableAncetre pt;
    if (p.getClass() == this.getClass()) {
      pt = (CValeurAssocieeAVariableAncetre) p;
      if (estConstant && pt.estConstant) return (valeur == pt.valeur);
      else {
      	if ((calcul.getClass() == CResultatValeur.class) && (pt.calcul.getClass() == CResultatValeur.class)) {
      		CResultatValeur res1 = (CResultatValeur) calcul;
      		CResultatValeur res2 = (CResultatValeur) pt.calcul;
      		return res1 == res2;
      	}
      	else return false;
      }
    } else return false;
  }
  

  public boolean existe()
  {
    return existe;
  }
  
  public double rendValeur(boolean infoRandom) {
    return valeur; ///Cas d'une constante
  }
  
  /**
   * Renvoie une chaine tant gale au nom de la valeur associe s'il y en a un
   * et sinon la chaine reprsentant le calcul associ
   * @return
   */
  public String chaineInfo()
  {
    return calcul.chaineCalculSansPar(null);
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
     super.chargeDepuisFlux(inps, list);
     valeur = inps.readCDouble();
     int ind1 = inps.readCInt();
     if (ind1 == -1) {
    	 // Si dans la version C++ la valeur tait constante, on doit crer un CCalculBase renvoyant cette constante
    	 calcul = new CConstante(list, valeur);
    	 estConstant = true;
    	 existe = true;
     }
     else {
    	 // On cre un calcul renvoyant la valeur dynamique associe en C++
    	 CValeurDynamique valeurDynamiqueAssociee = (CValeurDynamique) (list.get(ind1,CValeurDynamique.class));
    	 calcul = new CResultatValeur(list, valeurDynamiqueAssociee);
    	 // positionne(false,null);
    	 estConstant = false;
     }
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    calcul = (CCalculBase) (inps.readObject(list));
    if (calcul.estConstant()) {
    	estConstant = true;
      existe = calcul.existe();
      if (!existe) return;
      try {
        valeur = calcul.resultat(false);
      } 
      catch (ErreurCalculException e) {
        existe = false;
        valeur = 0;
      }
      if (Double.isNaN(valeur) || Double.isInfinite(valeur)) {
        existe = false;
      }
    }
    else {
    	estConstant = false;
    	// existe = calcul.existe();
    }
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeObject(calcul);
  }
  
  /**
   * Ajout pour la version 3.0 : renvoie true seulement si la valeur est constante
   * ou si la valeur dynamique associe est constante
   * @return
   */
	public boolean estConstant() {
		return estConstant;
	}
	
	/**
	 * Ajout pour la version 3.0. Renvoie le calcul associ sous forme d'une chane
	 * @return
	 */
	public String chaineCalculValeur() {
		return calcul.chaineCalcul(null);
	}
  
  
}