/*
 * CValeurAssocieeComp.java
 *
 * Created on 28 janvier 2007, 09:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objets;

import java.io.*;

import types.Complexe;
import types.DimensionFenetre;
import types.ErreurCalculException;
import types.Operateur;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

/**
 *
 * @author Yves
 */
// Modifi version 3.0
public class CValeurAssocieeComp extends CObjetBase{
  private Complexe valeurComplexe;  // La valeur
  // private CValeurDynamique valeurDynamiqueAssociee; // NULL ou la valeur dynamique associe
  // private String chaineCalculValeur;
	protected CCalculBase calcul;
	protected boolean estConstant;
	private boolean existe;
  
  /** Creates a new instance of CValeurAssocieeComp */
  public CValeurAssocieeComp() {
  	valeurComplexe = new Complexe();
  }
  
  /**
   * Constructeur pour cration d'objet
   * @param liste
   */
  public CValeurAssocieeComp(CListeObjets liste) {
  	super(liste);
  	valeurComplexe = new Complexe();
    calcul = null;
    // chaineCalculValeur = "";  	
  }
  
  /** Constructeur  partir d'un autre objet du mme type */
  public CValeurAssocieeComp(CValeurAssocieeComp valInit) {
  	super(valInit.listeProprietaire);
    // valeurComplexe = valInit.valeurComplexe;
  	valeurComplexe = new Complexe(valInit.valeurComplexe);
    calcul = valInit.calcul.getClone(listeProprietaire, listeProprietaire);
    estConstant = valInit.estConstant;
    existe = valInit.existe;
  }
  
  
  /* Constructeur pour clonage */
  public CValeurAssocieeComp(CListeObjets liste, CCalculBase calculInit, Complexe valeurComplexeInit) {
    super(liste);
    valeurComplexe = new Complexe(valeurComplexeInit);
    calcul = calculInit;
  }
  
  public CValeurAssocieeComp getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CCalculBase calculClone = calcul.getClone(listeSource, listeCible);
    return new CValeurAssocieeComp(listeCible, calculClone, valeurComplexe);

  }
  
  /**
   * Ajout pour la version 3.0
   * Donne un calcul  l'objet et vrifie s'il est constant ou non.
   */
  public void donneCalcul(CCalculBase calc) {
  	calcul = calc;
  	estConstant = calcul.estConstant();
  	if (estConstant) {
  		existe = true;
      try {
        calcul.resultatComplexe(false, valeurComplexe);
      }
      catch (ErreurCalculException e) {
        existe = false;
        valeurComplexe.x = 0;
        valeurComplexe.y = 0;
      }
      if (Double.isNaN(valeurComplexe.x) || Double.isInfinite(valeurComplexe.x)
        || Double.isNaN(valeurComplexe.y) || Double.isInfinite(valeurComplexe.y)) {
         existe = false;
      }
  	}
  }
  
  /** Fonction associant  l'objet la valeur dynamique vald */
  //public void associeA(CValeurDynamique vald) {
  //  valeurDynamiqueAssociee = vald;
  //}
  public void donneValeur(Complexe c) {
  	valeurComplexe.x = c.x;
  	valeurComplexe.y = c.y;
  	calcul = null;
  	estConstant = true;
  }
  
  //public void donneChaineCalcul(String s) {
  //  chaineCalculValeur = s;
  //}
  
  /**
   * Renvoie une chaine tant gale au nom de la valeur associe s'il y en a un
   * et sinon la chaine reprsentant le calcul associ
   * @return
   */
  public String chaineInfo()
  {
    return calcul.chaineCalculSansPar(null);
  }  
  
  public boolean existe() {
  	return existe;
  }
  
  // Ajout pour version 3.0
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    if (!estConstant) {
      existe = calcul.existe();
      if (!existe) return;
      // A revoir en java pour la gestion des erreurs de calcul
      // AnnuleErreurDeCalcul();	// Pour dtecter une ventuelle erreur de
      //                         // calcul lors de l'appel
      try {
        calcul.resultatComplexe(infoRandom, valeurComplexe);
      }
      catch (ErreurCalculException e) {
        existe = false;
        valeurComplexe.x = 0;
        valeurComplexe.y = 0;
      }
      if (Double.isNaN(valeurComplexe.x) || Double.isInfinite(valeurComplexe.x)
        || Double.isNaN(valeurComplexe.y) || Double.isInfinite(valeurComplexe.y)) {
         existe = false;
      }
    }
  }
  
  public boolean dependDe(CElementBase p) {
    return calcul.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
   return calcul.dependDePourBoucle(p);
  }
  
  public void rendValeurComplexe(boolean infoRandom, Complexe zRes) {
    zRes.set(valeurComplexe.x, valeurComplexe.y);///Cas d'une constante
  }
  
  public boolean confonduAvec(CObjetBase p) {
    CValeurAssocieeComp pt;
    if (p.getClass() == this.getClass()) {
      pt = (CValeurAssocieeComp) p;
      if (estConstant) return (valeurComplexe.x == pt.valeurComplexe.x) && (valeurComplexe.y == pt.valeurComplexe.y) ;
      else return false;    } else return false;
  }

  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
     super.chargeDepuisFlux(inps, list);
     int ind1 = inps.readCInt();
     // Plus utulis
     @SuppressWarnings("unused")
		 String chaineCalculValeur = inps.readCString();
     valeurComplexe.x = inps.readCDouble();
     valeurComplexe.y = inps.readCDouble();
     if ( ind1 == -1) {
    	 CConstantei constantei = new CConstantei();
    	 CConstante a = new CConstante(list,valeurComplexe.x);
    	 CConstante b = new CConstante(list,valeurComplexe.y);
    	 COperation op1 = new COperation(list,  b, constantei, Operateur.Mult);
    	 calcul = new COperation(list,  a, op1, Operateur.Plus);
    	 estConstant = true;
    	 existe = true;
     }
     else {
    	 CValeurDynamique valeurDynamiqueAssociee = (CValeurDynamique) (list.get(ind1,CValeurDynamique.class));
    	 calcul = new CResultatValeurComplexe(list, valeurDynamiqueAssociee);
    	 estConstant = false;    	 
     }
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    calcul = (CCalculBase) (inps.readObject(list));
    if (calcul.estConstant()) {
    	estConstant = true;
      existe = calcul.existe();
      if (!existe) return;
      try {
        calcul.resultatComplexe(false, valeurComplexe);
      }
      catch (ErreurCalculException e) {
        existe = false;
        valeurComplexe.x = 0;
        valeurComplexe.y = 0;
      }
      if (Double.isNaN(valeurComplexe.x) || Double.isInfinite(valeurComplexe.x)
        || Double.isNaN(valeurComplexe.y) || Double.isInfinite(valeurComplexe.y)) {
         existe = false;
      }   
    }
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeObject(calcul);
  }
  
  /**
   * Ajout pour la version 3.0 : renvoie true seulement si la valeur est constante
   * ou si la valeur dynamique associe est constante
   * @return
   */
	public boolean estConstant() {
		return estConstant;
	}
  
}
