/*
 * CValeurDynamique.java
 *
 * Created on 1 juillet 2004, 17:50
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import glob.*;

import java.awt.*;

import types.*;


// Modification pour la version 2.5 : la classe n'est plus abstract car il
// faut pouvoir l'instancier dans CListeObjets.get(int indice, Class cla)
public class CValeurDynamique extends CElementBase {
  // Attribut rajout pour optimisation lors de la version 2.0
  Complexe z1 = new Complexe();
  
  /** Creates new CValeurDynamique */
  public CValeurDynamique() {
  }

  public CValeurDynamique(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit) {
    super(liste, impProtoInit, estElementFinalInit);
  }
  
  public void donneNom(String  NouveauNom)
  {
  }
  
  // Mthode  redfinir pour les descendants renvoyant la valeur. Ne sert pas ici
  double rendValeur(boolean infoRandom) {
    return 0;
  }
  public void rendValeurComplexe(boolean infoRandom, Complexe zRes) {
    zRes.x = rendValeur(infoRandom);
    zRes.y = 0;
  }
  String rendChaineValeur(int nbDecimales, boolean infoRandom)
  {
    return Kernel.chaineNombre(rendValeur(infoRandom), nbDecimales);
  }
  // Rajout pour la version 2.0
  String rendChaineValeurComplexe(int nbDecimales, boolean infoRandom) {
    rendValeurComplexe(infoRandom, z1);
    String ch1 = Kernel.chaineNombre(z1.x, nbDecimales);
    String ch2 = Kernel.chaineNombre(z1.y, nbDecimales);
    if (ch2.compareTo("0") == 0) return ch1;
    else
    {
      if (ch1.compareTo("0") == 0)
      {
        if (ch2.compareTo("-1") == 0) ch2 = "-";
        else if (ch2.compareTo("1") == 0) ch2 = "";
        return ch2 + " i";
      }
      else
      {
        if (ch2.compareTo("1") == 0) return ch1 + " + i";
        else
        {
          if (ch2.compareTo("-1") == 0) ch2 = "-";
          if (ch2.charAt(0) == '-') return ch1 + " - " + ch2.substring(1) + " i";
          else return ch1 + " + " + ch2 + " i";
        }
      }
    }
  }
  // La fonction suivante ne sera redfinie que pour CCalculComplexe
  // Sert dans les commentaires dynamiques
  public String rendChaineValeurPourCommentaire(int nbDecimales, boolean infoRandom)
  {
    return rendChaineValeur(nbDecimales, infoRandom);
  }
  
  @Override
  public String nom() {
    return "";
  }
  
  // Ajout pour la version 2 du CNED
  // Fonction renvoyant true si la chaine pointe par PChaine
  // commence par l'intitul de la valeur dynamique. Si oui, elle
  // renvoie dans LongueurNom.x la longueur de cet intitul
  // Sera redfini pour certains descendants
  public boolean chaineCommenceParNom(String pChaine,Point longueurNom){
    String ChaineNom = nom();
    longueurNom.x = ChaineNom.length();
    int longueurChaine2 = pChaine.length();
    if (longueurChaine2 < longueurNom.x) return false;
    else
    {
      return ChaineNom.compareToIgnoreCase(pChaine.substring(0, longueurNom.x)) == 0;
    }
  }
  
  // Ajout spcifique version avec construction permettant de crer des calculs
  /**
   * Renverra true si la chaine ch est gale (sans tenir compte de la casse)
   * soit au nom de la valeur dans le cas d'un calcul ou une fonction soit 
   * la chane reprsentant la mesure dans le cas d'une mesure
   * @param ch
   * @return
   */
  public boolean chaineEgaleANom(String ch) {
    return (nom().compareToIgnoreCase(ch) == 0);
  }

  /**
   * Pour savoir si le calcul est une fonction relle, une suite relle ou non
   * Redfini seulement pour CFonc, CFoncComplexe, CSuiteRec et CSuiteRecComplexe;
   * Sert lors de la vrification syntaxique et lors de la cration des arbres binaires de calcul
   */ 
  public boolean estFonctionOuSuite() {
    return false;
  }
  
  /**
   * Ajout pour la version 3.0 : renvoie true seulement si la valeur dynamique est constant
   * @return
   */
	public boolean estConstant() {
		return false;
	}
  
}
