/*
 * OutilBis.java
 *
 * Created on 26 fvrier 2006, 09:41
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Yves
 * Outil de cration d'une bissectrice
 */
package outils;

import objets.*;
import types.*;
import Applet.*;

public class OutilBis extends OutilPar3pts {
  
  /** Creates a new instance of OutilBis */
  public OutilBis(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }

  public int idMenu() {
    return 32791;
  }

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "DteBis.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo2;
  }

  public String toolTip() {
    return textes.Chaines.toolTip2;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CBissectrice pt = new CBissectrice(appletMere.listePr, null, false, 
       appletMere.couleurActive(), StyleTrait.traitFin, point1, point2, point3, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil3);
    annuleClignotement();
    // Provisoire
    select();
  }
  
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CBissectrice bis = new CBissectrice(liste, null, false, Couleur.TraduitCouleur(1),
      StyleTrait.traitPointille, point1, point2, appletMere.pointSouris, 2);
    liste.add(bis);
    CPointProjete ptproj = new CPointProjete(liste, null, false, Couleur.TraduitCouleur(1),
            true, MotifPoint.croix, point1,bis);
    liste.add(ptproj);
  	// On cre deux segments en pointills
  	CSegment pts1 = new CSegment(liste, null, false, point1, point2);
    liste.add(pts1);
  	CSegment pts2 = new CSegment(liste, null, false, point2, appletMere.pointSouris);
    liste.add(pts2);
    // On cre deux marques d'angle
    CMarqueAngleGeometrique ptma1 = new CMarqueAngleGeometrique(liste, null, false, 
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais, StyleMarqueAngle.marqueSimple, 11, point1, point2, ptproj);
    liste.add(ptma1);
    CMarqueAngleGeometrique ptma2 = new CMarqueAngleGeometrique(liste, null, false, 
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais, StyleMarqueAngle.marqueSimple, 14, ptproj,
      point2, appletMere.pointSouris);
    liste.add(ptma2);
  }
    /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants
   * @param i : l'indice
   * @return
   */

  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return textes.Chaines.bissectrice1;
      case 2 : return textes.Chaines.bissectrice2;
      case 3 : return textes.Chaines.bissectrice3;
      default: return "";
    }
  }
  
}
