/*
 * OutilCerOR.java
 *
 * Created on 11 juillet 2006, 09:23
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;

import java.awt.*;
import dialogs.*;
import objets.*;
import types.*;
import Applet.*;


/**
 *
 * @author Yves
 */
public class OutilCerOR extends Outil {
  CPointAncetre point;
  CValeurAssocieeAVariable ray;
  CCercleOR ptCercle;
  /** Creates a new instance of OutilCerOR */
  public OutilCerOR(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true);
  }

  public int idMenu() {
    return 32797;
  }

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "CerOR.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo6;
  }  

  public String toolTip() {
    return textes.Chaines.toolTip6;
  }

  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    point = null;
    designationDe(NatureObjet.NToutPoint);
    appletMere.indication(textes.Chaines.cercleOR1);
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    if (appletMere.ajouteElementAvecVerification(ptCercle))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil5);
    annuleClignotement();
    appletMere.activeOutilCapture();
  }

  /** Mthode renvoyant true seulement si l'outil peut tre slectionn.
   * A redfinir seulement pour les outils qui peuvent ventuellement tre
   * impossibles  slectionner, par exemple l'outil de cration d'un cercle
   * par son centre et son rayon si une longueur unit n'a pas t dfinie pour
   * la figure
  **/
  public boolean activationValide() {
    return (appletMere.listePr.pointeurLongueurUnite != null);
  }  
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    CListeObjets liste = appletMere.listePr;
    if (point == null) {
      appletMere.indication(textes.Chaines.cercleOR2);
      point = (CPointAncetre) elg;
      ajouteClignotementDe(elg);
      resetClignotement();
      ray = new CValeurAssocieeAVariable(liste, 0);
      ptCercle = new CCercleOR(liste, null, false, appletMere.couleurActive(),
          false, StyleTrait.traitFin,  point, ray);
      // On cre un dialogue modal permettant d'entrer l'angle de la rotation
      RayonDlg rayonDlg = new RayonDlg(appletMere, ptCercle);
      rayonDlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
      // On redessine la figure pour liminer la dsignation ce point affiche pur le centre
      appletMere.videDesignation();
      appletMere.repaintFigure();
      rayonDlg.setVisible(true);
      // On regarde si la bote de dialogue a bien t valide par OK
      if (rayonDlg.retourOK()) {
        creeObjet();
      }
      else {
        annuleClignotement();
        appletMere.activeOutilCapture(); 
      }
    }
  }      
}
