/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 * Outil de cration d'une droite passant par deux points
 */
package outils;

import objets.*;
import Applet.*;


public class OutilDtAB extends OutilPar2pts {
  
  /** Creates a new instance of OutilDtAB */
  public OutilDtAB(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, AppletMathGraph32.iconCreerDroiteAB);
  }

  public int idMenu() {
    return 32783;
  }
  
  public String toolTip() {
    return getString("toolTip8");
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CDroiteAB pt = new CDroiteAB(appletMere.listePr, null, false,
      appletMere.couleurActive(), appletMere.styleTraitActif(), point1, point2, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil7"));
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CDroiteAB dt = new CDroiteAB(appletMere.listeObjetsVisuels, null, false,
    		appletMere.couleurActive(), appletMere.styleTraitActif(),
      point1, appletMere.pointSouris, 2);
    appletMere.listeObjetsVisuels.add(dt);
  }
  @Override
  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return getString("droiteAB1");
      case 2 : return getString("droiteAB2");
      default: return "";
    }
  }
}
