/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package outils;

import Applet.AppletMathGraph32;
import java.awt.Point;

import dialogs.RapportHomothetieDlg;

import objets.*;

import types.Couleur;
import types.MotifPoint;
import types.NatureObjet;

/**
 * Outil de crtion d'images par une homothtie
 * @author Yves
 */
public class OutilHom extends Outil {
  CPointAncetre point;
  CElementGraphique objet;
  CHomothetie ptHom;
  
  /** Creates a new instance of OutilRot */
  public OutilHom(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true);
  }

  public int idMenu() {
    return 32801;
  }  

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "Homothetie.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo26;
  }  
  
  public String toolTip() {
    return textes.Chaines.toolTip26;
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    point = null;
    objet = null;
    designationDe(NatureObjet.NToutPoint);
    appletMere.indication(textes.Chaines.homothetie1);
  }

  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CListeObjets liste = appletMere.listePr;
    appletMere.ajouteElement(ptHom);
    CElementGraphique elg = imageParTransformation(liste, objet, ptHom);
    if (appletMere.ajouteElementAvecVerification(elg)) {
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil22);
    }
    else{
      appletMere.detruitDernierElement();
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    CListeObjets liste = appletMere.listePr;
    if (point == null) {
      appletMere.indication(textes.Chaines.homothetie2);
      point = (CPointAncetre) elg;
      excluDeDesignation(elg);
      ajouteClignotementDe(elg);
      resetClignotement();
      CValeurAssocieeAVariable rap = new CValeurAssocieeAVariable(liste, 0);
      ptHom = new CHomothetie(liste, null, false, point, rap);
      // On cre un dialogue modal permettant d'entrer l'angle de la rotation
      RapportHomothetieDlg rapportDlg = new RapportHomothetieDlg(appletMere, ptHom);
      rapportDlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
      // On redessine la figure pour liminer la dsignation ce point affiche pour le centre
      appletMere.videDesignation();
      appletMere.repaintFigure();
      rapportDlg.setVisible(true);
      // On regarde si la bote de dialogue a bien t valide par OK
      if (rapportDlg.retourOK()) {
        ajouteObjetsVisuels();
        designationDe(appletMere.natureObjetsPourImages());
        resetClignotement();
        appletMere.indication(textes.Chaines.homothetie3);

      }
      else {
        annuleClignotement();
        select(); 
      }      
    }
    else {
      if (objet == null) {
        objet = elg;
        creeObjet();
        annuleClignotement();
      }
    }
  }      
  /* Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    appletMere.ajouteObjetVisuel(ptHom);
    CPointImage ptim = new CPointImage(liste, null, false, Couleur.TraduitCouleur(1),
      MotifPoint.croix, 2, appletMere.pointSouris, ptHom);
    appletMere.ajouteObjetVisuel(ptim);
  	// On cre un segment en pointills joignant le centre au point souris
  	CSegment pts1 = new CSegment(liste, null, false, point, ptim);
    appletMere.ajouteObjetVisuel(pts1);
  }
}
