/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package outils;
import Applet.AppletMathGraph32;
import java.util.ListIterator;

import objets.*;

import types.NatureObjet;

/**
 * Outil de mesure de l'abscisse d'un point sur une droite
 * @author Yves
 */
public class OutilMesAbs extends OutilPar3pts {

  /** Creates a new instance of OutilSeg */
  public OutilMesAbs(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }

  /**
   * Les outils descendant de OutilPar2Pts et necessitant que les points dsigns
   * soient nomms s'ils n'ont pas de noms devront redfinir cette fonction en renvoyant true
   * Cela servira pour l'outil de mesure de longueur
   * @return true si les points dsigns doivent tre nomms
   */
  boolean nomsPointsIndisp() {
    return true;
  }
  
  public int idMenu() {
    return 32817;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "MesAbs.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo31;
  }

  public String toolTip() {
    return textes.Chaines.toolTip31;
  }
  
  /**
   * Action aprs dsignation du deuxime point
   * Ne fera rien et ne sera redfini qu pour l'outil de mesure d'ascisse
   */
  public void actionApresPoint2() {
    // On ajoute  la liste clignotante les points qui sont aligns
    // avec point1 et point2
    CListeObjets list = appletMere.listePr;
    ListIterator<CElementBase> li = list.listIterator();
    while(li.hasNext()) {
      CElementBase elb = (CElementBase) li.next();
      if ((elb.getNature() & NatureObjet.NToutPoint) != 0) {
        CPointAncetre pt = (CPointAncetre) elb;
        if (glob.Kernel.aligne(point1.x, point1.y,point2.x, point2.y, pt.x, pt.y))
                ajouteClignotementDe(pt);
      }
    }
    appletMere.outilPointageActif = appletMere.outilPointageObjetClignotant; 
    designationDe(NatureObjet.NToutPoint); // Ncessaire car on change d'outil de pointage
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    appletMere.videDesignation();
    CMesureAbscisse mes = new CMesureAbscisse
            (appletMere.listePr, null, false , point1, point2, point3);
    if (appletMere.ajouteElementAvecVerification(mes)) {
      objetCree = true; // Necessaire  cause du fait que point1 et point2 ont t ventuellement
      // nomms et que si on ne cre pas l'objet on remet alors leur nom  une chaine vide    
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil24);
      appletMere.dialogueAvertissement(textes.Chaines.ch30 + " " + mes.nom() + " " + textes.Chaines.ch31
            + point3.rendNom() + textes.Chaines.ch32 
            + "(" + point1.rendNom() + "," + point2.rendNom() + ")" + textes.Chaines.ch26);
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  
/**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants devant crire plusieurs indications
   * @param i : l'indice
   * @return
   */          
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.mesAbs1;
      case 2 : return textes.Chaines.mesAbs2;
      case 3 : return textes.Chaines.mesAbs3;   
      default: return "";
    }
  }
}
