/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package outils;

import dialogs.AbscisseDlg;
import objets.*;
import types.*;
import Applet.AppletMathGraph32;

/**
 * Outil de cration d'un point dfini par son abscisse relativement  deux autres points
 * @author Yves
 */
public class OutilPtParAbs extends OutilPar2pts {
  CPointParAbscisse pt;
  /** Creates a new instance of OutilPar2pts */
  public OutilPtParAbs(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }
  
  public int idMenu() {
    return 32889;
  }  

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "PointParAbs.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo25;
  }  
 
  public String toolTip() {
    return textes.Chaines.toolTip25;
  }
  
  /**
   * Les outils descendant de OutilPar2Pts et necessitant que les points dsigns
   * soient nomms s'ils n'ont pas de noms devront redfinir cette fonction en renvoyant true
   * Cela servira pour l'outil de mesure de longueur
   * @return true si les points dsigns doivent tre nomms
   */
  boolean nomsPointsIndisp() {
    return true;
  }

  /**
   * Action aprs dsignation du deuxime point
   */
  public void actionApresPoint2() {
    ajouteClignotementDe(point2);
    resetClignotement();    
    appletMere.indication(textes.Chaines.pointParAbs3);   
  }

  @Override
  public String chaineIndication(int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.pointParAbs1;
      case 2 : return textes.Chaines.pointParAbs2;
      case 3 : return textes.Chaines.pointParAbs3;
      default: return "";
    }
  }
  
 
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CListeObjets liste = appletMere.listePr;
    CValeurAssocieeAVariable abs = new CValeurAssocieeAVariable(liste, 0);
    pt = new CPointParAbscisse(liste, null, false, appletMere.couleurActive(), false, 
            0d, 0d, false, "", 2, MotifPoint.croix, point1, point2, abs);
    // On cre un dialogue modal permettant d'entrer l'abscisse
    AbscisseDlg abscisseDlg = new AbscisseDlg(appletMere, pt);
    abscisseDlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
    // On redessine la figure pour liminer la dsignation ce point affiche pour le centre
    appletMere.videDesignation();
    appletMere.repaintFigure();
    abscisseDlg.setVisible(true);
    // On regarde si la bote de dialogue a bien t valide par OK
    if (abscisseDlg.retourOK()) {
      if (appletMere.ajouteElementAvecVerification(pt)) {
        objetCree = true;
        appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil21);
      }
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
}
