/*
 * OutilRapporteur.java
 *
 * Created on 1 juin 2006, 15:45
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;
import Applet.*;
import glob.Kernel;
import java.awt.*;
import objets.*;
import types.*;


/**
 *
 * @author Yves
 */
public class OutilRapporteur extends OutilPar2pts {

	CMesureAngleOriente ptMesureAngle;	// Pointeur
	// sur la mesure d'angles contenue dans la liste des objets visuels.
	// La valeur de cette mesure arrondie au degr prs sera utilise comme
	// angle de la rotation.
	CCercleOA ptCercle; // Pointeur sur le cercle cr dans la liste visuelle
	// auquel sera li un point.
	CPointLieCercle ptPointLie; // Le point li
  
  /** Creates a new instance of OutilRapporteur */
  public OutilRapporteur(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }
  
  public int idMenu() {
    return 33085;
  }  
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "Rapporteur.gif";
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    appletMere.indication(textes.Chaines.rapporteur1);
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo16;
  }  

  public String toolTip() {
    return textes.Chaines.toolTip16;
  }
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (point1 == null)
    {
      appletMere.indication(textes.Chaines.rapporteur2);
      point1 = (CPointAncetre) elg;
      excluDeDesignation(elg);
      ajouteClignotementDe(elg);
      resetClignotement();
      ajouteObjetsVisuels(); // On rajoute un rapporteur
      appletMere.listeObjetsVisuels.positionne(appletMere.infRand, appletMere.dimf);
      // DecalePointeurSouris(UneVue);
    }
    else
    {
      if (point2 == null)
      {
        appletMere.indication(textes.Chaines.rapporteur3);
        point2 = (CPointAncetre) elg;
        excluDeDesignation(elg);
        ajouteClignotementDe(elg);
        ajouteObjetsVisuels();
        appletMere.positionneListeVisuelle();      
        resetClignotement();
      }
      // C'est l'outil de capture qui par un clic gauche une fois
      // l'angle visuellement choisi qui provoquera l'appel de CreeObjet
    }    
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    // CElementGraphique * Ptp;


    CListeObjets liste = appletMere.listePr;
    
    double valeurAngle = ptMesureAngle.rendValeur(false);
    // On arrondit au degr prs en degrs
    if (liste.uniteAngle == UniteAngle.Radian) valeurAngle = valeurAngle*CValeurAngle.convRadDeg;
    if (valeurAngle != Math.floor(valeurAngle)) valeurAngle = Math.floor(valeurAngle + 0.5);
    if (valeurAngle == - 180) valeurAngle = 180;
    // valeurAngle = valeurAngle * CValeurAngle.convDegRad;
    CValeurAngle ptValeurAngle = new CValeurAngle(liste,  valeurAngle);
    CRotation ptr = new CRotation(liste, null, false, point1,  ptValeurAngle);    
    appletMere.ajouteElement(ptr);    
    // A la diffrence de la version C++ on ne regarde pas si existe dj une
    // rotation quivalente
    CPointImage ptp = new CPointImage(liste, null, false, appletMere.couleurActive(),
    	MotifPoint.croix, 2, point2,ptr);
    if (appletMere.ajouteElementAvecVerification(ptp))
    	appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil13);
    else {
      // Si l'image existe dj on la dtruit ainsi que la rotation
    	appletMere.detruitDernierElement();
    	appletMere.redessine();
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  @Override
  public void ajouteObjetsVisuels() {
    CPointAncetre ptp = null;
    CListeObjets listeVisuelle = appletMere.listeObjetsVisuels;
    if (point2 == null)
    {
      ptp = ajouteRapporteur(point1); // Le pointeur renvoy dans ptp est
      // un pointeur sur un point d'intersection d'une demi-droite avec un cercle.
      ptCercle = new CCercleOA(listeVisuelle, null, false, Couleur.TraduitCouleur(1),
        false,StyleTrait.traitFin,point1,ptp);
      ptCercle.cache();
      appletMere.ajouteObjetVisuel(ptCercle);

    }
    else
    {
      // Si le point dont on veut crer l'image a t dsign, le cercle prcdent
      // devient fixe en remplaant dans la liste visuelle le point souris
      // par Point2
      listeVisuelle.remplacePoint(appletMere.pointSouris,point2);
      // Pour pouvoir initialiser l'abscisse du point li, il faut mesurer
      // un angle orient  partir d'une horizontale
      CDroiteDirectionFixe ptdh = new CDroiteDirectionFixe(listeVisuelle,
        Couleur.TraduitCouleur(1), StyleTrait.traitFin, point1, true, 2);
      ptdh.cache();
      appletMere.ajouteObjetVisuel(ptdh);
      // On lui lie un point d'abscisse 1
      CPointLieDroite ptld = new CPointLieDroite(listeVisuelle, null, false,
        Couleur.TraduitCouleur(1), false, 0d, 0d, false, "", 2,
        MotifPoint.petitRond, true, 1, ptdh);       
      ptld.cache();
      appletMere.ajouteObjetVisuel(ptld);
      // On mesure l'angle
      CMesureAngleOriente ptmao = new CMesureAngleOriente(listeVisuelle, null, false,
        ptld, point1,point2);
      appletMere.ajouteObjetVisuel(ptmao);
      appletMere.positionneListeVisuelle();
      // On rajoute un point li au cercle point par ptCercle
      // Son abscisse est son angle polaire en radians
      double ang = ptmao.rendValeur(false)*Kernel.ConvDegRad;
      if (ang < 0) ang = ang + 2*Math.PI;
      ptPointLie = new CPointLieCercle(listeVisuelle, null, false,
        Couleur.TraduitCouleur(1), false, 0d, 0, false, "", 2,
        MotifPoint.petitRond, true, ang, ptCercle);
      appletMere.ajouteObjetVisuel(ptPointLie);
      // On cre la mesure de l'angle orient point2, point1, pointSouris
      ptMesureAngle = new CMesureAngleOriente(listeVisuelle, null, false,
        point2,point1,ptPointLie);
      appletMere.ajouteObjetVisuel(ptMesureAngle);
      // On cre aussi la mesure de l'angle gomtrique pour affichage sur le rapporteur
      CMesureAngleGeometrique ptmesag = new CMesureAngleGeometrique(listeVisuelle, null, false,
        point2,point1,ptPointLie);
      appletMere.ajouteObjetVisuel(ptmesag);
      // Changement par rapport  la version C++.
      // Il faudra veiller  ce que le rapporteur ne soit accessible qu'en mode degr,
      // ce qui est logique.
      // On cre une nouveau point cart du rapporteur
      // Pour cela on cre une homothtie
      CHomothetie ptHom2 = new CHomothetie(listeVisuelle, null, false, point1, 1.25);
      appletMere.ajouteObjetVisuel(ptHom2);
      CPointImage ptimh = new CPointImage(listeVisuelle, null, false,
        Couleur.TraduitCouleur(1),MotifPoint.rond, 2, ptPointLie,ptHom2);
      ptimh.cache();
      appletMere.ajouteObjetVisuel(ptimh);
      // On cre l'image provisoire du point
      // D'abord une rotation
      CValeurAngle valang = new CValeurAngle(listeVisuelle, ptMesureAngle);
      CRotation ptrot = new CRotation(listeVisuelle, null, false, point1, valang);
      appletMere.ajouteObjetVisuel(ptrot);
      // On affiche la valeur lie au point prcdent avce effacement de ce qu'il y a dessous
      CValeurAffichee ptaff = new CValeurAffichee(listeVisuelle, null, false,
        Couleur.TraduitCouleur(2),0d, 0d, 0d, 0d, false, ptimh,
        2, StyleEncadrement.Sans, true, Couleur.TraduitCouleur(0), ptmesag, "", "", 0);
      ptaff.decaleNom(-10, -3);
      appletMere.ajouteObjetVisuel(ptaff);
      // L'image
      CPointImage ptimrot = new CPointImage(listeVisuelle, null, false,
      		appletMere.couleurActive(),MotifPoint.petitRond, 2, point2, ptrot);
      appletMere.ajouteObjetVisuel(ptimrot);
      // On cre deux segments pointills (on ne sait pas si on est  l'intrieur
      // ou l'extrieur du rapporteur
      CSegment ptseg1 = new CSegment(listeVisuelle, null, false, point1, ptPointLie); // En pointills par dfaut
      appletMere.ajouteObjetVisuel(ptseg1);
      // On ne trace plus le deuxime segment pour ne pas cacher l'angle
      // CSegment ptseg2 = new CSegment(listeVisuelle, null, false, point1, ptimrot); // Idem
      // frame.ajouteObjetVisuel(ptseg2);
      // On passe la main  l'outil de dsignation ad hoc
      appletMere.outilPointageActif = appletMere.outilPointageRapporteur;
      appletMere.outilPointageActif.reset();
      appletMere.outilPointageRapporteur.associePointLie(ptPointLie);
    }
  }

}
