/*
 * OutilRot.java
 *
 * Created on 8 juillet 2006, 17:47
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;

import java.awt.*;
import dialogs.*;
import objets.*;
import types.*;
import Applet.*;

/**
 *
 * @author Yves
 */
public class OutilRot extends Outil {
  CPointAncetre point;
  CElementGraphique objet;
  CRotation ptRot;
  
  /** Creates a new instance of OutilRot */
  public OutilRot(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true);
  }
  
  public int idMenu() {
    return 32803;
  }  

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "Rotation.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo18;
  }  
 
  public String toolTip() {
    return textes.Chaines.toolTip18;
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    point = null;
    objet = null;
    designationDe(NatureObjet.NToutPoint);
    appletMere.indication(textes.Chaines.rotation1);
  }

  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CListeObjets liste = appletMere.listePr;
    appletMere.ajouteElement(ptRot);
    CElementGraphique elg = imageParTransformation(liste,  objet, ptRot);
    if (appletMere.ajouteElementAvecVerification(elg)) {
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil14);
    }
    else{
      appletMere.detruitDernierElement();
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    CListeObjets liste = appletMere.listePr;
    if (point == null) {
      appletMere.indication(textes.Chaines.rotation2);
      point = (CPointAncetre) elg;
      excluDeDesignation(elg);
      ajouteClignotementDe(elg);
      resetClignotement();
      CValeurAngle ang = new CValeurAngle(liste, 0, "0");
      ptRot = new CRotation(liste, null, false, point, ang);
      // On cre un dialogue modal permettant d'entrer l'angle de la rotation
      AngleRotDlg angleRotDlg = new AngleRotDlg(appletMere, ptRot);
      angleRotDlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
      // On redessine la figure pour liminer la dsignation ce point affiche pour le centre
      appletMere.videDesignation();
      appletMere.paneFigure.repaint();
      angleRotDlg.setVisible(true);
      // On regarde si la bote de dialogue a bien t valide par OK
      if (angleRotDlg.retourOK()) {
        ajouteObjetsVisuels();
        designationDe(appletMere.natureObjetsPourImages());
        resetClignotement();
        appletMere.indication(textes.Chaines.rotation3);

      }
      else {
        annuleClignotement();
        select(); 
      }      
    }
    else {
      if (objet == null) {
        objet = elg;
        creeObjet();
        annuleClignotement();
      }
    }
  }    
  /* Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
  	// On cre un segment en pointills joignant le centre au point souris
  	CSegment pts1 = new CSegment(liste, null, false, point, appletMere.pointSouris);
    appletMere.ajouteObjetVisuel(pts1);
    appletMere.ajouteObjetVisuel(ptRot);
    CPointImage ptim = new CPointImage(liste, null, false, Couleur.TraduitCouleur(1),
      MotifPoint.petitRond, 2, appletMere.pointSouris, ptRot);
    appletMere.ajouteObjetVisuel(ptim);
    // On cre un deuxime segment joigant le centre au point image
  	CSegment pts2 = new CSegment(liste, null, false, point, ptim);
    appletMere.ajouteObjetVisuel(pts2);
    // On cre une marque d'angle orient pour visualiser la rotation
    CMarqueAngleOriente ptmar = new CMarqueAngleOriente(liste, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitFin, StyleMarqueAngle.marqueSimple, 18, StyleFleche.FlecheCourtePleine, 
      appletMere.pointSouris, point, ptim);
    appletMere.ajouteObjetVisuel(ptmar);
  }
}
