/*
 * OutilSymAxiale.java
 *
 * Created on 13 juin 2006, 08:52
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;

import java.awt.*;

import objets.*;

import types.*;
import Applet.*;

/**
 *
 * @author Yves
 */
public class OutilSymAxiale extends Outil {
  CDroiteAncetre droite;
  CElementGraphique objet;
  
  /** Creates a new instance of OutilTranslation */
  public OutilSymAxiale(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true);
  }

  public int idMenu() {
    return 32799;
  }

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "SymAxiale.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo21;
  }  

  public String toolTip() {
    return textes.Chaines.toolTip21;
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    droite = null;
    objet = null;
    designationDe(NatureObjet.NTouteDroite);
    appletMere.indication(textes.Chaines.symAxiale1);
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CListeObjets liste = appletMere.listePr;
    CSymetrieAxiale ptSym = new CSymetrieAxiale(liste, null, false, droite);
    appletMere.ajouteElement(ptSym);
    CElementGraphique elg = imageParTransformation(liste,  objet, ptSym);
    if (appletMere.ajouteElementAvecVerification(elg)) {
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil17);
    }
    else {
      appletMere.detruitDernierElement();   
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CSymetrieAxiale sym = new CSymetrieAxiale(liste, null, false, droite);
    appletMere.ajouteObjetVisuel(sym);
    CPointImage ptim = new CPointImage(liste, null, false, Couleur.TraduitCouleur(1),
       MotifPoint.petitRond, 2, appletMere.pointSouris, sym);
    appletMere.ajouteObjetVisuel(ptim);
    CMilieu ptm = new CMilieu(liste, null, false, Couleur.TraduitCouleur(1), 
       MotifPoint.croix, appletMere.pointSouris, ptim);
    appletMere.ajouteObjetVisuel(ptm);
    CSegment seg1 = new CSegment(liste, null, false, Couleur.TraduitCouleur(1),
       false, StyleTrait.traitPointille, appletMere.pointSouris,
      ptm);
    appletMere.ajouteObjetVisuel(seg1);
    CSegment seg2 = new CSegment(liste, null, false, Couleur.TraduitCouleur(1), false,
       StyleTrait.traitPointille, ptm, ptim);
    appletMere.ajouteObjetVisuel(seg2);
    CMarqueSegment mar1 = new CMarqueSegment(liste, null, false, Couleur.TraduitCouleur(1),
       false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, seg1);
    appletMere.ajouteObjetVisuel(mar1);
    CMarqueSegment mar2 = new CMarqueSegment(liste, null, false, Couleur.TraduitCouleur(1),
       false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, seg2);
    appletMere.ajouteObjetVisuel(mar2);
    CDroitePerpendiculaire perp = new CDroitePerpendiculaire(liste, null, false, Couleur.TraduitCouleur(1),
            StyleTrait.traitFin, ptm, seg1, 2);
    perp.cache();
    appletMere.ajouteObjetVisuel(perp);
    CMarqueAngleDroit marque = new CMarqueAngleDroit(liste, null, false, perp);
    appletMere.ajouteObjetVisuel(marque);
  }
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (droite == null) {
      appletMere.indication(textes.Chaines.symAxiale2);
      droite = (CDroiteAncetre) elg;
      excluDeDesignation(elg);
      ajouteClignotementDe(elg);
      ajouteObjetsVisuels();
        designationDe(appletMere.natureObjetsPourImages());
      resetClignotement();
    }
    else {
      if (objet == null) {
        objet = elg;
        creeObjet();
        annuleClignotement();
      }
    }
  }  
}
